﻿/*
OuDiaSecond Copyright (C) 2017-2020 diagram_mania

このプログラムは、take-okm氏が作成したOuDiaを改造したソフトウェアです。
このプログラム利用については、take-okm氏記載の下記文書に準拠します。
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(訳: 

	OuDia - 列車時刻表をもとに、ダイヤグラムを描画するWin32アプリケーシ
ョン。

Copyright (C) 2006-2017 take-okm 

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財
団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、それ以降のバージョ
ンのうちどれか)が定める条件の下で再頒布または改変 することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。
商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在
しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部 受け取っ
ているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> を
ご覧ください。

)

  加えて、特別な例外として、take-okm はこのプログラムのコードを 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  あるいは "MFC Version 9.0" と同じライセンスが適用された
  "MFC Version 9.0" の改変されたバージョン)とリンクし、
  リンクされた両者を含む結合著作物を頒布する許可を与えます。
  あなたは "MFC" 以外で使われているすべて
  のコードに関しては全面的にGNU一般公衆利用許諾契約書に従わなければ
  なりません。あなたがこのファイルを改変したならば、あなたはこの例外
  をあなたのバージョンのファイルに引き続き設けることもできますが、そ
  うする義務はありません。もし例外を設けたくなければ、この例外条項を
  あなたのバージョンからは削除してください。)
*/
/*
// ****************************************************************
//	ViewJikokuhyou\WndJikokuhyou\CCellBuilderCustomize.cpp
//	$Id: CCellBuilderCustomize.cpp 366 2016-08-18 20:26:22Z okm $
// ****************************************************************
*/
/** @file */
#include "stdafx.h"
//#include "..\..\StdAfx.h"
#include "CCellBuilderCustomize.h"
#include "..\..\resource.h"
#include "DcDraw\DcDraw.h"
#include "NsOu/dynamic_castOu.h"
#include "..\..\entDed\entDed.h"
#include "str\stringSplit.h"
#include "MfcUtil/MfcUtil.h"
#include <NsOu\OuNew.h>
#include "Str/strToWstr.h"
//#include "DcdGrid/WndDcdGrid3/WndDcdGrid3.h"
//#include "DcdGrid/CDcdGrid.h"
//#include "DcdGrid/CDcdGridXBorder.h"

namespace ViewJikokuhyou{
namespace WndJikokuhyou{
	//using namespace OuLib::Str;
	//using DcDraw::CDcdTextboxV3 ;

// --------------------------------
//@name 描画処理に使用する テキスト描画属性
// --------------------------------

CdDrawTextProp	CCellBuilderCustomize::getCdDrawTextPropMenutext()const
{ 
	CdDedDispProp aCdDedDispProp = m_pCDedRosenFileData->getCdDedDispProp() ;

	CConverter_WinGdi	aConv ;
	return CdDrawTextProp( 
		aCdDedDispProp.getJikokuhyouFont(0) ,
		aConv.CdColorPropOfSysColor( COLOR_MENUTEXT ) ) ;
}

CdDrawTextProp	CCellBuilderCustomize::getCdDrawTextPropStandard()const
{ 
	CdDedDispProp aCdDedDispProp = m_pCDedRosenFileData->getCdDedDispProp() ;

	return CdDrawTextProp( 
		aCdDedDispProp.getJikokuhyouFont(0) ,
		CdColorProp( 0 , 0 , 0 ) ) ;
}

CdDrawTextProp	CCellBuilderCustomize::getCdDrawTextPropOperation()const
{
	CdDedDispProp aCdDedDispProp = m_pCDedRosenFileData->getCdDedDispProp();

	return CdDrawTextProp(
		aCdDedDispProp.getJikokuhyouFont(0),
		CdColorProp(0, 0, 0),
		CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
}

CdDrawTextProp	CCellBuilderCustomize::getCdDrawTextPropTsuuka()const
{ 
	CdDedDispProp aCdDedDispProp = m_pCDedRosenFileData->getCdDedDispProp() ;

	return CdDrawTextProp( 
		aCdDedDispProp.getJikokuhyouFont(0) ,
		CdColorProp( 128 , 128 , 128 ) ,
		CdDrawTextFormat( CdDrawTextFormat::H_CENTER ) ) ;
}

//edit_by_d_mania
const CdDedJikoku::CConv
CCellBuilderCustomize::getCdDedJikokuConv()const 
{
	//if( m_bDisplaySecondEkiJikoku )
	//{
	//	if (m_bDisplayColonEkiJikoku)
	//	{
	//		static CdDedJikoku::CConv aConv(
	//			false,		//	コロン有
	//											// 時が 00 から 09 の場合、10の位の "0" をスペースにします。
	//			CdDedJikoku::CConv::EHour_ZeroToSpace,
	//			CdDedJikoku::CConv::ESecond_Output 	// 秒を表示します
	//		);
	//		return aConv;
	//	}
	//	else
	//	{
	//		static CdDedJikoku::CConv aConv(
	//			true,		//	コロン無
	//											// 時が 00 から 09 の場合、10の位の "0" をスペースにします。
	//			CdDedJikoku::CConv::EHour_ZeroToSpace,
	//			CdDedJikoku::CConv::ESecond_Output 	// 秒を表示します
	//		);
	//		return aConv;
	//	}
	//}
	//else
	//{
	//	if (m_bDisplayColonEkiJikoku)
	//	{
	//		static CdDedJikoku::CConv aConv(
	//			false,		//	コロン有
	//						// 時が 00 から 09 の場合、10の位の "0" をスペースにします。
	//			CdDedJikoku::CConv::EHour_ZeroToSpace,
	//			CdDedJikoku::CConv::ESecond_NoSecond 	// 秒を常に出力しません。
	//		);
	//		return aConv;
	//	}
	//	else
	//	{
	//		static CdDedJikoku::CConv aConv(
	//			true,		//	コロン無
	//						// 時が 00 から 09 の場合、10の位の "0" をスペースにします。
	//			CdDedJikoku::CConv::EHour_ZeroToSpace,
	//			CdDedJikoku::CConv::ESecond_NoSecond 	// 秒を常に出力しません。
	//		);
	//		return aConv;
	//	}
	//}


	CdDedJikoku::CConv::ESecond eSecond = CdDedJikoku::CConv::ESecond_NoSecond;
	if (m_bDisplaySecondEkiJikoku)
	{
		eSecond = CdDedJikoku::CConv::ESecond_Output;
	}

	CdDedJikoku::CConv aConv(
		!m_bDisplayColonEkiJikoku,
		CdDedJikoku::CConv::EHour_ZeroToSpace,
		eSecond,
		(CdDedJikoku::CConv::ESecondRound)m_iSecondRoundChaku,
		(CdDedJikoku::CConv::ESecondRound)m_iSecondRoundHatsu,
		m_bDisplay2400
	);
	return aConv;
}
	// --------------------------------
	//@name 描画処理に使用する ブラシ属性
	// --------------------------------

CdBrushProp CCellBuilderCustomize::getCdBrushPropMenutext()const
{
	CConverter_WinGdi	aConv ;
	return CdBrushProp( aConv.CdColorPropOfSysColor( COLOR_MENU ) ) ;
}

CdBrushProp	CCellBuilderCustomize::getCdBrushPropStandard()const
{
	return CdBrushProp( CdColorProp( 255 , 255 , 255 ) ) ;
}

	// --------------------------------
	//@name 描画処理に使用する DcDrawオブジェクトのプロトタイプ
	// --------------------------------

CDcdTextbox CCellBuilderCustomize::createCDcdXColumn0()const
{
	tstring strExtent = m_pCDedRosenFileData->
		getCdDedDispProp().createEkimeiExtentString() ;
	//strExtent = 路線ファイルデータに保存されている値をもとにして、
	//	作成した、文字列幅の基準文字列です。

	CDcdTextbox aCDcd( 
		_T("") ,
		getCdDrawTextPropMenutext() ,
		strExtent ,
		1 ,
		RectangleTextFrameWidth , RectangleTextFrameWidth ,
		CdPenProp() ,
		getCdBrushPropMenutext() 
	) ;
	return ( aCDcd ) ;
}

CDcdTextboxV3 CCellBuilderCustomize::createCDcdXColumn0V()const
{
	tstring strExtent = m_pCDedRosenFileData->
		getCdDedDispProp().createEkimeiExtentString() ;
	//strExtent = 路線ファイルデータに保存されている値をもとにして、
	//	作成した、文字列幅の基準文字列です。

	CdDedDispProp	aCdDedDispProp = m_pCDedRosenFileData->getCdDedDispProp() ;

	CConverter_WinGdi	aConv ;

	CDcdTextboxV3 aCDcd( 
		_T("") ,
		aCdDedDispProp.getJikokuhyouVFont() ,
		getRessyameiTextExtent().getX() ,
		getRessyameiTextExtent().getY() ,
		aConv.CdColorPropOfSysColor( COLOR_MENUTEXT ) ,
		RectangleTextFrameWidth , RectangleTextFrameWidth ,
		CdPenProp() ,
		getCdBrushPropMenutext() ) ;
	return ( aCDcd ) ;
}


CDcdTextbox CCellBuilderCustomize::createCDcdEkimei()const
{
	tstring strExtent = m_pCDedRosenFileData->
		getCdDedDispProp().createEkimeiExtentString() ;
	//strExtent = 路線ファイルデータに保存されている値をもとにして、
	//	作成した、文字列幅の基準文字列です。

	CDcdTextbox aCDcd( 
		_T("") ,
		getCdDrawTextPropStandard() ,
		strExtent ,
		1 ,
		RectangleTextFrameWidth , RectangleTextFrameWidth ,
		CdPenProp() ,
		getCdBrushPropStandard() ) ;
	return ( aCDcd ) ;
}


CDcdTextbox CCellBuilderCustomize::createCDcdHatsuchaku()const
{
	tstring strExtent;
	//if (m_bDisplayAllTrack) 
	//{
	//	strExtent = MfcUtil::LoadCString(IDS_WORD_Track);
	//}
	//else 
	//{
		strExtent = MfcUtil::LoadCString( IDS_WORD_Chaku );
	//}

	//strExtent = 路線ファイルデータに保存されている値をもとにして、
	//	作成した、文字列幅の基準文字列です。


	CDcdTextbox aCDcd( 
		_T("") ,
		getCdDrawTextPropStandard() ,
		strExtent ,
		1 ,
		RectangleTextFrameWidth , RectangleTextFrameWidth ,
		CdPenProp() ,
		getCdBrushPropStandard() ) ;
	return ( aCDcd ) ;
}

CDcdTextbox CCellBuilderCustomize::createCDcdRessyabangou(
	int iRessyasyubetsuIndex )const
{
	CdDedDispProp	aCdDedDispProp = m_pCDedRosenFileData->getCdDedDispProp() ;
	tstring strCellExtent( aCdDedDispProp.getJikokuhyouRessyaWidth() , '0' ) ;
	//strCellExtent = セルの大きさの目安となる文字列です。
	//	時刻表列車セルの幅(文字数) CdDedDispProp::m_iJikokuhyouRessyaWidth
	//	の数だけ '0' が並んだ文字列です

	const CentDedRessyasyubetsu* pCentDedRessyasyubetsu
		= m_pCDedRosenFileData->getCentDedRosen()->getCentDedRessyasyubetsuCont()
		->getMuPtr()->get( iRessyasyubetsuIndex ) ;
	if (m_bDisplayParentSyubetsu && pCentDedRessyasyubetsu->getParentSyubetsuIndex() >= 0)
	{
		pCentDedRessyasyubetsu
			= m_pCDedRosenFileData->getCentDedRosen()->getCentDedRessyasyubetsuCont()
			->getMuPtr()->get(pCentDedRessyasyubetsu->getParentSyubetsuIndex());
	}

	CdDrawTextProp aCdDrawTextProp = getCdDrawTextPropStandard() ;

	aCdDrawTextProp.setCdDrawTextFormat( CdDrawTextFormat( CdDrawTextFormat::H_CENTER ) ) ;
	aCdDrawTextProp.setTextColor( 
		pCentDedRessyasyubetsu->getJikokuhyouMojiColor() ) ;


	CDcdTextbox aCDcd( 
		_T("") ,
		aCdDrawTextProp ,
		strCellExtent ,
		1 ,
		RectangleTextFrameWidth , RectangleTextFrameWidth ,
		CdPenProp() ,
		getCdBrushPropStandard() ) ;
	return ( aCDcd ) ;
}

CDcdTextboxV3 CCellBuilderCustomize::createCDcdRessyamei(
	int iRessyasyubetsuIndex )const
{
	const CentDedRessyasyubetsu* pCentDedRessyasyubetsu
		= m_pCDedRosenFileData->getCentDedRosen()->getCentDedRessyasyubetsuCont()
		->getMuPtr()->get( iRessyasyubetsuIndex ) ;
	if (m_bDisplayParentSyubetsu && pCentDedRessyasyubetsu->getParentSyubetsuIndex() >= 0)
	{
		pCentDedRessyasyubetsu
			= m_pCDedRosenFileData->getCentDedRosen()->getCentDedRessyasyubetsuCont()
			->getMuPtr()->get(pCentDedRessyasyubetsu->getParentSyubetsuIndex());
	}

	CdDedDispProp	aCdDedDispProp = m_pCDedRosenFileData->getCdDedDispProp() ;

	CDcdTextboxV3 aCDcd( 
		_T("") ,
		aCdDedDispProp.getJikokuhyouVFont(),
		getRessyameiTextExtent().getX() ,
		getRessyameiTextExtent().getY() ,
		pCentDedRessyasyubetsu->getJikokuhyouMojiColor() ,
		RectangleTextFrameWidth , RectangleTextFrameWidth ,
		CdPenProp() ,
		getCdBrushPropStandard() ) ;
	return ( aCDcd ) ;
}

CDcdTextbox CCellBuilderCustomize::createCDcdEkijikoku(
	int iRessyasyubetsuIndex )const
{
	const CentDedRessyasyubetsu* pCentDedRessyasyubetsu
		= m_pCDedRosenFileData->getCentDedRosen()->getCentDedRessyasyubetsuCont()
		->getMuPtr()->get( iRessyasyubetsuIndex ) ;
	if (m_bDisplayParentSyubetsu && pCentDedRessyasyubetsu->getParentSyubetsuIndex() >= 0)
	{
		pCentDedRessyasyubetsu
			= m_pCDedRosenFileData->getCentDedRosen()->getCentDedRessyasyubetsuCont()
			->getMuPtr()->get(pCentDedRessyasyubetsu->getParentSyubetsuIndex());
	}
	int idxFont = pCentDedRessyasyubetsu->getJikokuhyouFontIndex() ;
	

	CDcdTextbox aCDcd 
		= createCDcdRessyabangou( iRessyasyubetsuIndex ) ;
		
	CdDrawTextProp	aCdDrawTextProp = aCDcd.getCdDrawTextProp() ;
	aCdDrawTextProp.setCdFontProp(
		m_pCDedRosenFileData
			->getCdDedDispProp().getJikokuhyouFont( idxFont ) ) ;
	aCDcd.setCdDrawTextProp( aCdDrawTextProp ) ;

	return ( aCDcd ) ;
}

	// --------------------------------
	//@name update() の下請関数
	// --------------------------------
void CCellBuilderCustomize::update01_updateWithoutRessya(
		CWndJikokuhyou* pCWndJikokuhyou ) 
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid() ;
	CDcdTargetGetDC	aCDcdTarget( NULL ) ;

	// ********************************
	//(1.1)　CWndDcdGrid の外枠線のDcDrawオブジェクトと、列幅を設定
	// ********************************
	update01_01_setGridBorder( 
		pCWndJikokuhyou ) ;


	// ********************************
	//(1.2)　列の数を設定します。
	//	X列数が2未満なら2にします。
	//	Y列数は、CdYColSpecCont で
	//	導出された列数とします。
	// ********************************
	{
		int iXColumnNumberMax = -1 ;
		{
			int iXColumnNumber = m_CdXColSpecCont.ColumnNumberFromSpec( 
				CdXColSpec( 
					CdXColSpec::ColumnType_Ekimei ) ) ;
			iXColumnNumberMax = max( iXColumnNumberMax , iXColumnNumber ) ;
		}
		{
			int iXColumnNumber = m_CdXColSpecCont.ColumnNumberFromSpec( 
				CdXColSpec( 
					CdXColSpec::ColumnType_Chakuhatsu ) ) ;
			iXColumnNumberMax = max( iXColumnNumberMax , iXColumnNumber ) ;
		}

		pCDcdGrid->setXColumnCount( max( iXColumnNumberMax + 1 , 
			pCDcdGrid->getXColumnCount() ) ) ;
		pCDcdGrid->setYColumnCount( m_CdYColSpecCont.size() ) ;
	}
 
	// ********************************
	//(1.3)　X列(ColumnType_Ekimei) の各セルと、すべてのY列の高さ・
	//	Y列境界線・Y列境界線の高さ設定
	// ********************************
	{
		CdXColSpec aCdXColSpec( 
			CdXColSpec::ColumnType_Ekimei ) ;
		int iXColumnNumber = 
			m_CdXColSpecCont.ColumnNumberFromSpec( aCdXColSpec ) ;

		// ================================
		//(1.3.1)　セル(ColumnType_Ekimei,ColumnType_Ressyabangou) と、
		//	Y列(ColumnType_Ressyabangou)の高さ・Y列境界線・Y列境界線の高さ設定
		// ================================
		update01_03_01_setEkimei_Ressyabangou( 
			pCWndJikokuhyou ) ;

		// ================================
		//	(1.3.2)　同様に、セル(ColumnType_Ekimei, 
		//	ColumnType_Ressyasyubetsu～ ColumnType_Bikou ) と、
		//	Y列(ColumnType_Ressyasyubetsu～ ColumnType_Bikou)の高さ・
		//	Y列境界線・Y列境界線の高さを設定。
		// ================================
		// --------------------------------
		//	(1.3.2.12)セル(ColumnType_Ekimei, ColumnType_OperationNumber)
		// --------------------------------
		update01_03_02_12_setEkimei_OperationNumber(
			pCWndJikokuhyou);

		// --------------------------------
		//	(1.3.2.2)セル(ColumnType_Ekimei, ColumnType_Ressyasyubetsu)
		// --------------------------------
		update01_03_02_02_setEkimei_Ressyasyubetsu( 
			pCWndJikokuhyou ) ;

		// --------------------------------
		//	(1.3.2.3)セル(ColumnType_Ekimei, ColumnType_Ressyamei)
		// --------------------------------
		update01_03_02_03_setEkimei_Ressyamei( 
			pCWndJikokuhyou ) ;


		// --------------------------------
		//	(1.3.2.4)セル(ColumnType_Ekimei, ColumnType_Gousuu)
		// --------------------------------
		update01_03_02_04_setEkimei_Gousuu( 
			pCWndJikokuhyou ) ;

		
		// --------------------------------
		//	(1.3.2.5)セル(ColumnType_Ekimei, ColumnType_Gou)
		// --------------------------------
		update01_03_02_05_setEkimei_Gou( 
			pCWndJikokuhyou ) ;

		// --------------------------------
		//	(1.3.2.10)セル(ColumnType_Ekimei, ColumnType_Operation_Shihatsu)
		// --------------------------------
		update01_03_02_13_setShihatsuEkimei(
			pCWndJikokuhyou);

		// --------------------------------
		//	(1.3.2.10)セル(ColumnType_Ekimei, ColumnType_Operation_Shihatsu)
		// --------------------------------
		//update01_03_02_10_setEkimei_Operation_Shihatsu(
		//	pCWndJikokuhyou);

		// --------------------------------
		//	(1.3.2.10)セル(ColumnType_Ekimei, ColumnType_Operation_Shuchaku)
		// --------------------------------
		update01_03_02_14_setShuchakuEkimei(
			pCWndJikokuhyou);

		// --------------------------------
		//	(1.3.2.10)セル(ColumnType_Ekimei, ColumnType_Operation_Shuchaku)
		// --------------------------------
		//update01_03_02_11_setEkimei_Operation_Shuchaku(
		//	pCWndJikokuhyou);

		// --------------------------------
		//	(1.3.2.15)セル(ColumnType_Ekimei, ColumnType_Outer_Shihatsu)
		// --------------------------------
		update01_03_02_15_setEkimei_OuterTerminal_Shihatsu(
			pCWndJikokuhyou);
		
		// --------------------------------
		//	セル(ColumnType_Ekimei,ColumnType_Ekijikoku_Chaku)
		//	セル(ColumnType_Ekimei,ColumnType_Track)
		//	セル(ColumnType_Ekimei,ColumnType_Ekijikoku_Hatsu)
		// --------------------------------
		update01_03_02_06_setEkimei_Chaku( 
			pCWndJikokuhyou ) ;
		update01_03_02_09_setEkimei_Track(
			pCWndJikokuhyou);

		update01_03_02_19_setEkimei_Ressyabangou(
			pCWndJikokuhyou);
		update01_03_02_20_setEkimei_OperationNumber(
			pCWndJikokuhyou);
		update01_03_02_21_setEkimei_Ressyasyubetsu(
			pCWndJikokuhyou);
		update01_03_02_22_setEkimei_Ressyamei(
			pCWndJikokuhyou);
		update01_03_02_23_setEkimei_Gousuu(
			pCWndJikokuhyou);
		update01_03_02_24_setEkimei_Gou(
			pCWndJikokuhyou);

		update01_03_02_07_setEkimei_Hatsu( 
			pCWndJikokuhyou ) ;
		

		// --------------------------------
		//	(1.3.2.16)セル(ColumnType_Ekimei, ColumnType_Outer_Shuchaku)
		// --------------------------------
		update01_03_02_16_setEkimei_OuterTerminal_Shuchaku(
			pCWndJikokuhyou);

		// --------------------------------
		//	(1.3.2.8)セル(ColumnType_Ekimei,ColumnType_Bikou)
		// --------------------------------
		update01_03_02_08_setEkimei_Bikou( 
			pCWndJikokuhyou ) ;
		
		// ================================
		//(1.3.3)　X列(ColumnType_Ekimei ) の幅を設定。
		//	幅は、駅名列の DcDraw オブジェクトの幅とします。
		// ================================
		CDcdGridXColumn* pCDcdGridXColumn = pCDcdGrid->getXColumn( 
			iXColumnNumber ) ;
		if ( pCDcdGridXColumn )
		{
			CDcdTextbox aCDcdTextbox =createCDcdXColumn0() ;
			CdDcdSizeXy aCdDcdSizeXy ;
			if ( aCDcdTextbox.getItemSize( 
				&aCDcdTarget , &aCdDcdSizeXy ) )
			{
				pCDcdGridXColumn->setColumnSize( aCdDcdSizeXy.getX() ) ;
			}
		}
		// ================================
		//	(1.3.4)　X列(ColumnType_Ekimei ) の境界線の DcDrawオブジェクトの
		//	属性を設定。
		//	(1.3.5)　X列(ColumnType_Ekimei ) の境界線の幅を設定。
		// ================================
		{
			CDcdGridXBorder* pCDcdGridXBorder 
				= pCDcdGridXColumn->getCDcdGridXBorder() ;
			Ou<CDcdLine> pCDcdLine = pCDcdGridXBorder->getIfDcDraw() ;

			pCDcdLine->setCdPenProp( CdPenProp() ) ;	//NULLPEN

			CdDcdSizeXy aCdDcdSizeXy ;
			if ( pCDcdLine->getItemSize( &aCDcdTarget , &aCdDcdSizeXy ) )
			{
				pCDcdGridXBorder->setColumnBorderSize( aCdDcdSizeXy.getX() ) ;
			}
		}
	}

	// ********************************
	//(1.4)　X列(ColumnType_Chakuhatsu) の各セルを設定
	// ********************************
	{
		CdXColSpec aCdXColSpec( 
			CdXColSpec::ColumnType_Chakuhatsu ) ;
		int iXColumnNumber = 
			m_CdXColSpecCont.ColumnNumberFromSpec( aCdXColSpec ) ;
		// ================================
		//(1.4.1)　セル(ColumnType_Chakuhatsu, 
		//	ColumnType_Ekijikoku_Chaku～ ColumnType_Ekijikoku_Hatsu) を設定。
		// ================================
		update01_04_01_06_setChakuhatsu_Chaku( 
			pCWndJikokuhyou ) ;
		update01_04_01_09_setChakuhatsu_Track(
			pCWndJikokuhyou);
		update01_04_01_07_setChakuhatsu_Hatsu( 
			pCWndJikokuhyou ) ;

		// ================================
		//	(1.4.3)　X列(ColumnType_Chakuhatsu ) の幅を設定。
		//	幅は、着発列の DcDraw オブジェクトの幅とします。
		// ================================
		CDcdGridXColumn* pCDcdGridXColumn = pCDcdGrid->getXColumn( 
			iXColumnNumber ) ;
		if ( pCDcdGridXColumn )
		{
			CDcdTextbox aCDcdTextbox = 
				createCDcdHatsuchaku() ;
			CdDcdSizeXy aCdDcdSizeXy ;
			if ( aCDcdTextbox.getItemSize( 
				&aCDcdTarget , &aCdDcdSizeXy ) )
			{
				pCDcdGridXColumn->setColumnSize( aCdDcdSizeXy.getX() ) ;
			}
		}

		// ================================
		//	(1.4.4)　X列(ColumnType_Chakuhatsu ) の境界線の 
		//	DcDrawオブジェクトの属性を設定。
		//(1.4.5)　X列(ColumnType_Chakuhatsu ) の境界線の幅を設定。
		// ================================
		{
			CDcdGridXBorder* pCDcdGridXBorder 
				= pCDcdGridXColumn->getCDcdGridXBorder() ;
			Ou<CDcdLine> pCDcdLine = pCDcdGridXBorder->getIfDcDraw() ;

			pCDcdLine->setCdPenProp( getCdPenPropBoldLine() ) ;	

			CdDcdSizeXy aCdDcdSizeXy ;
			if ( pCDcdLine->getItemSize( &aCDcdTarget , &aCdDcdSizeXy ) )
			{
				pCDcdGridXBorder->setColumnBorderSize( aCdDcdSizeXy.getX() ) ;
			}
		}
	}
}

void CCellBuilderCustomize::update01_01_setGridBorder( 
	CWndJikokuhyou* pCWndJikokuhyou ) 
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid() ;
	CDcdTargetGetDC	aCDcdTarget( NULL ) ;


	//	左
	{
		CDcdGridXBorder* pCDcdGridXBorder = pCDcdGrid->getCDcdGridXBorderTop() ;
		Ou<CDcdLine> pCDcdLine = pCDcdGridXBorder->getIfDcDraw();
		pCDcdLine->setCdPenProp( getCdPenPropBoldLine() ) ;

		CdDcdSizeXy aCdDcdSizeXy ;
		if ( pCDcdLine->getItemSize( &aCDcdTarget , &aCdDcdSizeXy ) )
		{
			pCDcdGridXBorder->setColumnBorderSize( aCdDcdSizeXy.getX() ) ;
		}
	}
	//	右
	{
		CDcdGridXBorder* pCDcdGridXBorder 
			= pCDcdGrid->getCDcdGridXBorderBottom() ;
		Ou<CDcdLine> pCDcdLine = pCDcdGridXBorder->getIfDcDraw();
		pCDcdLine->setCdPenProp( getCdPenPropBoldLine() ) ;

		CdDcdSizeXy aCdDcdSizeXy ;
		if ( pCDcdLine->getItemSize( &aCDcdTarget , &aCdDcdSizeXy ) )
		{
			pCDcdGridXBorder->setColumnBorderSize( aCdDcdSizeXy.getX() ) ;
		}
	}
	//	上
	{
		CDcdGridYBorder* pCDcdGridYBorder = pCDcdGrid->getCDcdGridYBorderTop() ;
		Ou<CDcdLine> pCDcdLine = pCDcdGridYBorder->getIfDcDraw();
		pCDcdLine->setCdPenProp( getCdPenPropBoldLine() ) ;

		CdDcdSizeXy aCdDcdSizeXy ;
		if ( pCDcdLine->getItemSize( &aCDcdTarget , &aCdDcdSizeXy ) )
		{
			pCDcdGridYBorder->setColumnBorderSize( aCdDcdSizeXy.getY() ) ;
		}
	}
	//	下
	{
		CDcdGridYBorder* pCDcdGridYBorder 
			= pCDcdGrid->getCDcdGridYBorderBottom() ;
		Ou<CDcdLine> pCDcdLine = pCDcdGridYBorder->getIfDcDraw();
		pCDcdLine->setCdPenProp( getCdPenPropBoldLine() ) ;

		CdDcdSizeXy aCdDcdSizeXy ;
		if ( pCDcdLine->getItemSize( &aCDcdTarget , &aCdDcdSizeXy ) )
		{
			pCDcdGridYBorder->setColumnBorderSize( aCdDcdSizeXy.getY() ) ;
		}
	}
}

void CCellBuilderCustomize::update01_03_01_setEkimei_Ressyabangou( 
	CWndJikokuhyou* pCWndJikokuhyou ) 
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid() ;
	CDcdTargetGetDC	aCDcdTarget( NULL ) ;

	// --------------------------------
	CdXColSpec aCdXColSpec( 
		CdXColSpec::ColumnType_Ekimei ) ;
	int iXColumnNumber = 
		m_CdXColSpecCont.ColumnNumberFromSpec( aCdXColSpec ) ;

	if ( iXColumnNumber >= 0 )
	{
		CdYColSpec aCdYColSpec( 
			CdYColSpec::ColumnType_Ressyabangou ) ;
		int iYColumnNumber = m_CdYColSpecCont.ColumnNumberFromSpec( 
			aCdYColSpec , false ) ;
		CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell( 
			iXColumnNumber , iYColumnNumber ) ;

		typedef CDcdTextbox CDcDrawCell ;
		Ou<CDcDrawCell> pCDcDrawCell ;

		if ( pCDcdGridCell != 0 )
		{
			//(1.3.*.1)　セル(ColumnType_Ekimei,ColumnType_Ressyabangou) 
			//	の結合セルの属性を設定。
			pCDcdGridCell->setAttachCellCount( 2 , 1 ) ;

			//	(1.3.*.2)　セル(ColumnType_Ekimei,ColumnType_Ressyabangou) 
			//	のDcDrawオブジェクトの型を設定
			//	( CDcdTextbox とする)。
			{
				pCDcDrawCell = dynamic_castOu<CDcDrawCell>( 
					pCDcdGridCell->getIfDcDraw() ) ;
				if ( pCDcDrawCell == NULL )
				{
					pCDcDrawCell = OuNew<CDcDrawCell>( new CDcDrawCell ) ;
					pCDcdGridCell->setIfDcDraw( pCDcDrawCell ) ;
				}
			}

			//(1.3.*.3)　セル(ColumnType_Ekimei,ColumnType_Ressyabangou) 
			//	DcDrawオブジェクトに、属性を設定。
			{
				*pCDcDrawCell = createCDcdXColumn0() ;
				pCDcDrawCell->setText( tstringOf( 
					(LPCTSTR)MfcUtil::LoadCString( 
						IDS_WORD_Ressyabangou ) ) ) ;
			}
		}

		CDcdGridYColumn* pCDcdGridYColumn = pCDcdGrid->getYColumn( 
			iYColumnNumber ) ;
		if ( pCDcdGridYColumn )
		{
			//(1.3.*.4)　Y列(ColumnType_Ressyabangou) のセルの高さを設定
			{
				CdDcdSizeXy aCdDcdSizeXy ;
				if ( pCDcDrawCell->getItemSize( 
					&aCDcdTarget , &aCdDcdSizeXy ) )
				{
					pCDcdGridYColumn->setColumnSize( aCdDcdSizeXy.getY() ) ;
				}
			}
			//	　(1.3.*.5)　Y列(ColumnType_Ressyabangou) の境界線の
			//	DcDrawオブジェクト に属性を設定。
			//	　(1.3.*.6)　Y列ColumnType_Ressyabangou) の境界線の
			//	高さを設定
			{
				CDcdGridYBorder* pCDcdGridYBorder 
					= pCDcdGridYColumn->getCDcdGridYBorder() ;
				Ou<CDcdLine> pCDcdLine = pCDcdGridYBorder->getIfDcDraw() ;
				pCDcdLine->setCdPenProp( getCdPenPropNarrowLine() ) ;

				CdDcdSizeXy aCdDcdSizeXy ;
				if ( pCDcdLine->getItemSize( 
					&aCDcdTarget , &aCdDcdSizeXy ) )
				{
					pCDcdGridYBorder->setColumnBorderSize( 
						aCdDcdSizeXy.getX() ) ;
				}
			}
		}
	}
}

void CCellBuilderCustomize::update01_03_02_12_setEkimei_OperationNumber(
	CWndJikokuhyou * pCWndJikokuhyou)
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	CDcdTargetGetDC	aCDcdTarget(NULL);

	// --------------------------------
	CdXColSpec aCdXColSpec(
		CdXColSpec::ColumnType_Ekimei);
	int iXColumnNumber =
		m_CdXColSpecCont.ColumnNumberFromSpec(aCdXColSpec);


	if (iXColumnNumber >= 0)
	{
		CdYColSpec aCdYColSpec(
			CdYColSpec::ColumnType_OperationNumber);
		int iYColumnNumber = m_CdYColSpecCont.ColumnNumberFromSpec(
			aCdYColSpec, false);
		CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell(
			iXColumnNumber, iYColumnNumber);

		typedef CDcdTextbox CDcDrawCell;
		Ou<CDcDrawCell> pCDcDrawCell;

		if (pCDcdGridCell != NULL)
		{
			//(1.3.*.1)　結合セルの属性を設定。
			pCDcdGridCell->setAttachCellCount(2, 1);

			//	(1.3.*.2)　セル 
			//	のDcDrawオブジェクトの型を設定
			//	( CDcdTextbox とする)。
			{
				pCDcDrawCell = dynamic_castOu<CDcDrawCell>(
					pCDcdGridCell->getIfDcDraw());
				if (pCDcDrawCell == NULL)
				{
					pCDcDrawCell = OuNew<CDcDrawCell>(new CDcDrawCell);
					pCDcdGridCell->setIfDcDraw(pCDcDrawCell);
				}
			}
			//(1.3.*.3)　セルの DcDrawオブジェクトに、属性を設定。
			{
				*pCDcDrawCell = createCDcdXColumn0();
				pCDcDrawCell->setText(tstringOf(
					(LPCTSTR)MfcUtil::LoadCString(
						IDS_WORD_OperationNumber)));
			}
		}
		CDcdGridYColumn* pCDcdGridYColumn = pCDcdGrid->getYColumn(
			iYColumnNumber);
		if (pCDcdGridYColumn != NULL)
		{
			//(1.3.*.4)　Y列 のセルの高さを設定
			{
				CdDcdSizeXy aCdDcdSizeXy;
				if (pCDcDrawCell->getItemSize(
					&aCDcdTarget, &aCdDcdSizeXy))
				{
					pCDcdGridYColumn->setColumnSize(aCdDcdSizeXy.getY());
				}
			}
			//	　(1.3.*.5)　Y列 の境界線の
			//	DcDrawオブジェクト に属性を設定。
			//	　(1.3.*.6)　Y列 の境界線の
			//	高さを設定
			{
				CDcdGridYBorder* pCDcdGridYBorder
					= pCDcdGridYColumn->getCDcdGridYBorder();
				Ou<CDcdLine> pCDcdLine = pCDcdGridYBorder->getIfDcDraw();
				pCDcdLine->setCdPenProp(getCdPenPropNarrowLine());

				CdDcdSizeXy aCdDcdSizeXy;
				if (pCDcdLine->getItemSize(
					&aCDcdTarget, &aCdDcdSizeXy))
				{
					pCDcdGridYBorder->setColumnBorderSize(
						aCdDcdSizeXy.getX());
				}
			}
		}
	}
}


void CCellBuilderCustomize::update01_03_02_02_setEkimei_Ressyasyubetsu(
	CWndJikokuhyou* pCWndJikokuhyou)
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	CDcdTargetGetDC	aCDcdTarget(NULL);

	// --------------------------------
	CdXColSpec aCdXColSpec(
		CdXColSpec::ColumnType_Ekimei);
	int iXColumnNumber =
		m_CdXColSpecCont.ColumnNumberFromSpec(aCdXColSpec);


	if (iXColumnNumber >= 0)
	{
		CdYColSpec aCdYColSpec(
			CdYColSpec::ColumnType_Ressyasyubetsu);
		int iYColumnNumber = m_CdYColSpecCont.ColumnNumberFromSpec(
			aCdYColSpec, false);
		CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell(
			iXColumnNumber, iYColumnNumber);

		typedef CDcdTextbox CDcDrawCell;
		Ou<CDcDrawCell> pCDcDrawCell;

		if (pCDcdGridCell != NULL)
		{
			//(1.3.*.1)　結合セルの属性を設定。
			pCDcdGridCell->setAttachCellCount(2, 1);

			//	(1.3.*.2)　セル 
			//	のDcDrawオブジェクトの型を設定
			//	( CDcdTextbox とする)。
			{
				pCDcDrawCell = dynamic_castOu<CDcDrawCell>(
					pCDcdGridCell->getIfDcDraw());
				if (pCDcDrawCell == NULL)
				{
					pCDcDrawCell = OuNew<CDcDrawCell>(new CDcDrawCell);
					pCDcdGridCell->setIfDcDraw(pCDcDrawCell);
				}
			}
			//(1.3.*.3)　セルの DcDrawオブジェクトに、属性を設定。
			{
				*pCDcDrawCell = createCDcdXColumn0();
				pCDcDrawCell->setText(tstringOf(
					(LPCTSTR)MfcUtil::LoadCString(
						IDS_WORD_RESSYASYUBETSU)));
			}
		}
		CDcdGridYColumn* pCDcdGridYColumn = pCDcdGrid->getYColumn(
			iYColumnNumber);
		if (pCDcdGridYColumn != NULL)
		{
			//(1.3.*.4)　Y列 のセルの高さを設定
			{
				CdDcdSizeXy aCdDcdSizeXy;
				if (pCDcDrawCell->getItemSize(
					&aCDcdTarget, &aCdDcdSizeXy))
				{
					pCDcdGridYColumn->setColumnSize(aCdDcdSizeXy.getY());
				}
			}
			//	　(1.3.*.5)　Y列 の境界線の
			//	DcDrawオブジェクト に属性を設定。
			//	　(1.3.*.6)　Y列 の境界線の
			//	高さを設定
			{
				CDcdGridYBorder* pCDcdGridYBorder
					= pCDcdGridYColumn->getCDcdGridYBorder();
				Ou<CDcdLine> pCDcdLine = pCDcdGridYBorder->getIfDcDraw();
				pCDcdLine->setCdPenProp(getCdPenPropNarrowLine());

				CdDcdSizeXy aCdDcdSizeXy;
				if (pCDcdLine->getItemSize(
					&aCDcdTarget, &aCdDcdSizeXy))
				{
					pCDcdGridYBorder->setColumnBorderSize(
						aCdDcdSizeXy.getX());
				}
			}
		}
	}
}


void CCellBuilderCustomize::update01_03_02_03_setEkimei_Ressyamei( 
	CWndJikokuhyou* pCWndJikokuhyou ) 
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid() ;
	CDcdTargetGetDC	aCDcdTarget( NULL ) ;

	// --------------------------------
	CdXColSpec aCdXColSpec( 
		CdXColSpec::ColumnType_Ekimei ) ;
	int iXColumnNumber = 
		m_CdXColSpecCont.ColumnNumberFromSpec( aCdXColSpec ) ;

	if ( iXColumnNumber >= 0 )
	{
		CdYColSpec aCdYColSpec( 
			CdYColSpec::ColumnType_Ressyamei ) ;
		int iYColumnNumber = m_CdYColSpecCont.ColumnNumberFromSpec( 
			aCdYColSpec , false ) ;
		CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell( 
			iXColumnNumber , iYColumnNumber ) ;

		typedef CDcdTextboxV3 CDcDrawCell ;
		Ou<CDcDrawCell> pCDcDrawCell ;

		if ( pCDcdGridCell != NULL )
		{
			//(1.3.*.1)　結合セルの属性を設定。
			pCDcdGridCell->setAttachCellCount( 2 , 3 ) ;

			//	(1.3.*.2)　セル(ColumnType_Ekimei,ColumnType_Ressyabangou) 
			//	のDcDrawオブジェクトの型を設定
			//	( CDcdTextbox とする)。
			{
				pCDcDrawCell = dynamic_castOu<CDcDrawCell>( 
					pCDcdGridCell->getIfDcDraw() ) ;
				if ( pCDcDrawCell == NULL )
				{
					pCDcDrawCell = OuNew<CDcDrawCell>( new CDcDrawCell ) ;
					pCDcdGridCell->setIfDcDraw( pCDcDrawCell ) ;
				}
			}
			//(1.3.*.3)　セル(ColumnType_Ekimei,ColumnType_Ressyabangou) 
			//	DcDrawオブジェクトに、属性を設定。
			{
				*pCDcDrawCell = createCDcdXColumn0V() ;
				pCDcDrawCell->setText( tstringOf( 
					(LPCTSTR)MfcUtil::LoadCString( 
						IDS_WORD_Ressyamei ) ) ) ;
			}
		}
		CDcdGridYColumn* pCDcdGridYColumn = pCDcdGrid->getYColumn( 
			iYColumnNumber ) ;
		if ( pCDcdGridYColumn != NULL )
		{
			//(1.3.*.4)　Y列 のセルの高さを設定
			{
				CdDcdSizeXy aCdDcdSizeXy ;
				if ( pCDcDrawCell->getItemSize( 
					&aCDcdTarget , &aCdDcdSizeXy ) )
				{
					pCDcdGridYColumn->setColumnSize( aCdDcdSizeXy.getY() ) ;					}
			}
			//	　(1.3.*.5)　Y列 の境界線の
			//	DcDrawオブジェクト に属性を設定。
			//	　(1.3.*.6)　Y列 の境界線の
			//	高さを設定
			{
				CDcdGridYBorder* pCDcdGridYBorder 
					= pCDcdGridYColumn->getCDcdGridYBorder() ;
				Ou<CDcdLine> pCDcdLine = pCDcdGridYBorder->getIfDcDraw() ;
				pCDcdLine->setCdPenProp( getCdPenPropNullLine() ) ;

				CdDcdSizeXy aCdDcdSizeXy ;
				if ( pCDcdLine->getItemSize( 
					&aCDcdTarget , &aCdDcdSizeXy ) )
				{
					pCDcdGridYBorder->setColumnBorderSize( 
						aCdDcdSizeXy.getX() ) ;
				}
			}
		}
	}
}


void CCellBuilderCustomize::update01_03_02_04_setEkimei_Gousuu( 
	CWndJikokuhyou* pCWndJikokuhyou ) 
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid() ;
	CDcdTargetGetDC	aCDcdTarget( NULL ) ;

	// --------------------------------
	CdXColSpec aCdXColSpec( 
		CdXColSpec::ColumnType_Ekimei ) ;
	int iXColumnNumber = 
		m_CdXColSpecCont.ColumnNumberFromSpec( aCdXColSpec ) ;

	if ( iXColumnNumber >= 0 )
	{
		CdYColSpec aCdYColSpec( 
			CdYColSpec::ColumnType_Gousuu ) ;
		int iYColumnNumber = m_CdYColSpecCont.ColumnNumberFromSpec( 
			aCdYColSpec , false ) ;
		CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell( 
			iXColumnNumber , iYColumnNumber ) ;

		typedef CDcdTextbox CDcDrawCell ;
		Ou<CDcDrawCell> pCDcDrawCell ;

		if ( pCDcdGridCell != NULL )
		{
			//(1.3.*.1)　結合セルの属性を設定。
			pCDcdGridCell->setAttachCellCount( 2 , 1 ) ;

			//	(1.3.*.2)　セルのDcDrawオブジェクトの型を設定
			{
				pCDcDrawCell = dynamic_castOu<CDcDrawCell>( 
					pCDcdGridCell->getIfDcDraw() ) ;
				if ( pCDcDrawCell == NULL )
				{
					pCDcDrawCell = OuNew<CDcDrawCell>( new CDcDrawCell ) ;
					pCDcdGridCell->setIfDcDraw( pCDcDrawCell ) ;
				}
			}
			//(1.3.*.3)　セルのDcDrawオブジェクトに、属性を設定。
			{
				*pCDcDrawCell = createCDcdXColumn0() ;
			}
		}
		CDcdGridYColumn* pCDcdGridYColumn = pCDcdGrid->getYColumn( 
			iYColumnNumber ) ;
		if ( pCDcdGridYColumn != NULL )
		{
			//(1.3.*.4)　Y列 のセルの高さを設定
			{
				CdDcdSizeXy aCdDcdSizeXy ;
				if ( pCDcDrawCell->getItemSize( 
					&aCDcdTarget , &aCdDcdSizeXy ) )
				{
					pCDcdGridYColumn->setColumnSize( aCdDcdSizeXy.getY() ) ;					}
			}
			//	　(1.3.*.5)　Y列 の境界線の
			//	DcDrawオブジェクト に属性を設定。
			//	　(1.3.*.6)　Y列 の境界線の
			//	高さを設定
			{
				CDcdGridYBorder* pCDcdGridYBorder 
					= pCDcdGridYColumn->getCDcdGridYBorder() ;
				Ou<CDcdLine> pCDcdLine = pCDcdGridYBorder->getIfDcDraw() ;
				pCDcdLine->setCdPenProp( getCdPenPropNullLine() ) ;

				CdDcdSizeXy aCdDcdSizeXy ;
				if ( pCDcdLine->getItemSize( 
					&aCDcdTarget , &aCdDcdSizeXy ) )
				{
					pCDcdGridYBorder->setColumnBorderSize( 
						aCdDcdSizeXy.getX() ) ;
				}
			}
		}
	}
}


void CCellBuilderCustomize::update01_03_02_05_setEkimei_Gou( 
	CWndJikokuhyou* pCWndJikokuhyou ) 
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid() ;
	CDcdTargetGetDC	aCDcdTarget( NULL ) ;

	// --------------------------------
	CdXColSpec aCdXColSpec( 
		CdXColSpec::ColumnType_Ekimei ) ;
	int iXColumnNumber = 
		m_CdXColSpecCont.ColumnNumberFromSpec( aCdXColSpec ) ;

	if ( iXColumnNumber >= 0 )
	{
		CdYColSpec aCdYColSpec( 
			CdYColSpec::ColumnType_Gou ) ;
		int iYColumnNumber = m_CdYColSpecCont.ColumnNumberFromSpec( 
			aCdYColSpec , false ) ;
		CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell( 
			iXColumnNumber , iYColumnNumber ) ;

		typedef CDcdTextbox CDcDrawCell ;
		Ou<CDcDrawCell> pCDcDrawCell ;

		if ( pCDcdGridCell != NULL )
		{
			//(1.3.*.1)　結合セルの属性を設定。
			pCDcdGridCell->setAttachCellCount( 2 , 1 ) ;

			//	(1.3.*.2)　セルのDcDrawオブジェクトの型を設定
			{
				pCDcDrawCell = dynamic_castOu<CDcDrawCell>( 
					pCDcdGridCell->getIfDcDraw() ) ;
				if ( pCDcDrawCell == NULL )
				{
					pCDcDrawCell = OuNew<CDcDrawCell>( new CDcDrawCell ) ;
					pCDcdGridCell->setIfDcDraw( pCDcDrawCell ) ;
				}
			}
			//(1.3.*.3)　セルのDcDrawオブジェクトに、属性を設定。
			{
				*pCDcDrawCell = createCDcdXColumn0() ;
			}
		}
		CDcdGridYColumn* pCDcdGridYColumn = pCDcdGrid->getYColumn( 
			iYColumnNumber ) ;
		if ( pCDcdGridYColumn != NULL )
		{
			//(1.3.*.4)　Y列 のセルの高さを設定
			{
				CdDcdSizeXy aCdDcdSizeXy ;
				if ( pCDcDrawCell->getItemSize( 
					&aCDcdTarget , &aCdDcdSizeXy ) )
				{
					pCDcdGridYColumn->setColumnSize( aCdDcdSizeXy.getY() ) ;					}
			}
			//	　(1.3.*.5)　Y列 の境界線の
			//	DcDrawオブジェクト に属性を設定。
			//	　(1.3.*.6)　Y列 の境界線の
			//	高さを設定
			{
				CDcdGridYBorder* pCDcdGridYBorder 
					= pCDcdGridYColumn->getCDcdGridYBorder() ;
				Ou<CDcdLine> pCDcdLine = pCDcdGridYBorder->getIfDcDraw() ;
				pCDcdLine->setCdPenProp( getCdPenPropNarrowLine() ) ;

				CdDcdSizeXy aCdDcdSizeXy ;
				if ( pCDcdLine->getItemSize( 
					&aCDcdTarget , &aCdDcdSizeXy ) )
				{
					pCDcdGridYBorder->setColumnBorderSize( 
						aCdDcdSizeXy.getX() ) ;
				}
			}
		}
	}
}

void CCellBuilderCustomize::update01_03_02_13_setShihatsuEkimei(
	CWndJikokuhyou* pCWndJikokuhyou)
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	CDcdTargetGetDC	aCDcdTarget(NULL);

	// --------------------------------
	/*const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki =
	m_pCDedRosenFileData->getCentDedRosen()->getCentDedEkiCont()->getMuPtr(
	m_pCentDedRessyaCont->getRessyahoukou());*/

	// --------------------------------
	CdXColSpec aCdXColSpec(
		CdXColSpec::ColumnType_Ekimei);
	int iXColumnNumber =
		m_CdXColSpecCont.ColumnNumberFromSpec(aCdXColSpec);
	if (iXColumnNumber >= 0)
	{
		CdYColSpec aCdYColSpec(
			CdYColSpec::ColumnType_ShihatsuEkimei);
		int iYColumnNumber =
			m_CdYColSpecCont.ColumnNumberFromSpec(aCdYColSpec, false);
		CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell(
			iXColumnNumber, iYColumnNumber);

		typedef CDcdTextbox CDcDrawCell;
		Ou<CDcDrawCell> pCDcDrawCell;
		if (pCDcdGridCell != 0)
		{
			//(1.3.*.1)　セルの結合セルの属性を設定。

			pCDcdGridCell->setAttachCellCount(2, 1);

			//	(1.3.*.2)　セルのDcDrawオブジェクトの型を設定
			//	( CDcdTextbox とする)。
			{
				pCDcDrawCell = dynamic_castOu<CDcDrawCell>(
					pCDcdGridCell->getIfDcDraw());
				if (pCDcDrawCell == NULL)
				{
					pCDcDrawCell = OuNew<CDcDrawCell>(new CDcDrawCell);
					pCDcdGridCell->setIfDcDraw(pCDcDrawCell);
				}
			}
			//(1.3.*.3)　セルのDcDrawオブジェクトに、属性を設定。
			{
				*pCDcDrawCell = createCDcdEkimei();
				pCDcDrawCell->setText(tstringOf(
					(LPCTSTR)MfcUtil::LoadCString(
						IDS_WORD_ShihatsuEkimei)));
			}
		}

		CDcdGridYColumn* pCDcdGridYColumn = pCDcdGrid->getYColumn(
			iYColumnNumber);
		if (pCDcdGridYColumn)
		{
			//(1.3.*.4)　Y列のセルの高さを設定
			{
				CdDcdSizeXy aCdDcdSizeXy;
				if (pCDcDrawCell->getItemSize(
					&aCDcdTarget, &aCdDcdSizeXy))
				{
					pCDcdGridYColumn->setColumnSize(
						aCdDcdSizeXy.getY());
				}
			}
			//	　(1.3.*.5)　Y列(ColumnType_Ressyabangou) の境界線の
			//	DcDrawオブジェクト に属性を設定。
			//	　(1.3.*.6)　Y列ColumnType_Ressyabangou) の境界線の
			//	高さを設定
			{
				CDcdGridYBorder* pCDcdGridYBorder
					= pCDcdGridYColumn->getCDcdGridYBorder();
				Ou<CDcdLine> pCDcdLine =
					pCDcdGridYBorder->getIfDcDraw();
				pCDcdLine->setCdPenProp(getCdPenPropNarrowLine());


				// --------------------------------
				//	線の幅から、列幅を設定
				CdDcdSizeXy aCdDcdSizeXy;
				if (pCDcdLine->getItemSize(
					&aCDcdTarget, &aCdDcdSizeXy))
				{
					pCDcdGridYBorder->setColumnBorderSize(
						aCdDcdSizeXy.getX());
				}
			}
		}
	}
}

void CCellBuilderCustomize::update01_03_02_14_setShuchakuEkimei(
	CWndJikokuhyou* pCWndJikokuhyou)
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	CDcdTargetGetDC	aCDcdTarget(NULL);

	// --------------------------------
	/*const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki =
	m_pCDedRosenFileData->getCentDedRosen()->getCentDedEkiCont()->getMuPtr(
	m_pCentDedRessyaCont->getRessyahoukou());*/

	// --------------------------------
	CdXColSpec aCdXColSpec(
		CdXColSpec::ColumnType_Ekimei);
	int iXColumnNumber =
		m_CdXColSpecCont.ColumnNumberFromSpec(aCdXColSpec);
	if (iXColumnNumber >= 0)
	{
		CdYColSpec aCdYColSpec(
			CdYColSpec::ColumnType_ShuchakuEkimei);
		int iYColumnNumber =
			m_CdYColSpecCont.ColumnNumberFromSpec(aCdYColSpec, false);
		CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell(
			iXColumnNumber, iYColumnNumber);

		typedef CDcdTextbox CDcDrawCell;
		Ou<CDcDrawCell> pCDcDrawCell;
		if (pCDcdGridCell != 0)
		{
			//(1.3.*.1)　セルの結合セルの属性を設定。

			pCDcdGridCell->setAttachCellCount(2, 1);

			//	(1.3.*.2)　セルのDcDrawオブジェクトの型を設定
			//	( CDcdTextbox とする)。
			{
				pCDcDrawCell = dynamic_castOu<CDcDrawCell>(
					pCDcdGridCell->getIfDcDraw());
				if (pCDcDrawCell == NULL)
				{
					pCDcDrawCell = OuNew<CDcDrawCell>(new CDcDrawCell);
					pCDcdGridCell->setIfDcDraw(pCDcDrawCell);
				}
			}
			//(1.3.*.3)　セルのDcDrawオブジェクトに、属性を設定。
			{
				*pCDcDrawCell = createCDcdEkimei();
				pCDcDrawCell->setText(tstringOf(
					(LPCTSTR)MfcUtil::LoadCString(
						IDS_WORD_ShuchakuEkimei)));
			}
		}

		CDcdGridYColumn* pCDcdGridYColumn = pCDcdGrid->getYColumn(
			iYColumnNumber);
		if (pCDcdGridYColumn)
		{
			//(1.3.*.4)　Y列のセルの高さを設定
			{
				CdDcdSizeXy aCdDcdSizeXy;
				if (pCDcDrawCell->getItemSize(
					&aCDcdTarget, &aCdDcdSizeXy))
				{
					pCDcdGridYColumn->setColumnSize(
						aCdDcdSizeXy.getY());
				}
			}
			//	　(1.3.*.5)　Y列(ColumnType_Ressyabangou) の境界線の
			//	DcDrawオブジェクト に属性を設定。
			//	　(1.3.*.6)　Y列ColumnType_Ressyabangou) の境界線の
			//	高さを設定
			{
				CDcdGridYBorder* pCDcdGridYBorder
					= pCDcdGridYColumn->getCDcdGridYBorder();
				Ou<CDcdLine> pCDcdLine =
					pCDcdGridYBorder->getIfDcDraw();
				pCDcdLine->setCdPenProp(getCdPenPropNarrowLine());


				// --------------------------------
				//	線の幅から、列幅を設定
				CdDcdSizeXy aCdDcdSizeXy;
				if (pCDcdLine->getItemSize(
					&aCDcdTarget, &aCdDcdSizeXy))
				{
					pCDcdGridYBorder->setColumnBorderSize(
						aCdDcdSizeXy.getX());
				}
			}
		}
	}
}

void CCellBuilderCustomize::update01_03_02_15_setEkimei_OuterTerminal_Shihatsu(
	CWndJikokuhyou* pCWndJikokuhyou)
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	CDcdTargetGetDC	aCDcdTarget(NULL);

	// --------------------------------
	/*const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki =
	m_pCDedRosenFileData->getCentDedRosen()->getCentDedEkiCont()->getMuPtr(
	m_pCentDedRessyaCont->getRessyahoukou());*/

	// --------------------------------
	CdXColSpec aCdXColSpec(
		CdXColSpec::ColumnType_Ekimei);
	int iXColumnNumber =
		m_CdXColSpecCont.ColumnNumberFromSpec(aCdXColSpec);
	if (iXColumnNumber >= 0)
	{
		CdYColSpec aCdYColSpec1(
			CdYColSpec::ColumnType_Outer_Shihatsu1);
		CdYColSpec aCdYColSpec2(
			CdYColSpec::ColumnType_Outer_Shihatsu2);
		int iYColumnNumber1 =
			m_CdYColSpecCont.ColumnNumberFromSpec(aCdYColSpec1, false);
		int iYColumnNumber2 =
			m_CdYColSpecCont.ColumnNumberFromSpec(aCdYColSpec2, false);
		CDcdGridCell* pCDcdGridCell1 = pCDcdGrid->getCell(
			iXColumnNumber, iYColumnNumber1);
		CDcdGridCell* pCDcdGridCell2 = pCDcdGrid->getCell(
			iXColumnNumber, iYColumnNumber2);

		typedef CDcdTextbox CDcDrawCell;
		Ou<CDcDrawCell> pCDcDrawCell1;
		Ou<CDcDrawCell> pCDcDrawCell2;
		if (pCDcdGridCell1 != 0)
		{
			//(1.3.*.1)　セルの結合セルの属性を設定。

			pCDcdGridCell1->setAttachCellCount(2, 1);
			pCDcdGridCell2->setAttachCellCount(2, 1);

			//	(1.3.*.2)　セルのDcDrawオブジェクトの型を設定
			//	( CDcdTextbox とする)。
			{
				pCDcDrawCell1 = dynamic_castOu<CDcDrawCell>(
					pCDcdGridCell1->getIfDcDraw());
				pCDcDrawCell2 = dynamic_castOu<CDcDrawCell>(
					pCDcdGridCell2->getIfDcDraw());
				if (pCDcDrawCell1 == NULL)
				{
					pCDcDrawCell1 = OuNew<CDcDrawCell>(new CDcDrawCell);
					pCDcdGridCell1->setIfDcDraw(pCDcDrawCell1);
				}
				if (pCDcDrawCell2 == NULL)
				{
					pCDcDrawCell2 = OuNew<CDcDrawCell>(new CDcDrawCell);
					pCDcdGridCell2->setIfDcDraw(pCDcDrawCell2);
				}
			}
			//(1.3.*.3)　セルのDcDrawオブジェクトに、属性を設定。
			{
				*pCDcDrawCell1 = createCDcdEkimei();
				pCDcDrawCell1->setText(tstringOf(
					(LPCTSTR)MfcUtil::LoadCString(
						IDS_WORD_ShihatsuEkimei)));
				*pCDcDrawCell2 = createCDcdEkimei();
				pCDcDrawCell2->setText(tstringOf(
					(LPCTSTR)MfcUtil::LoadCString(
						IDS_WORD_Jikoku)));
			}
		}

		CDcdGridYColumn* pCDcdGridYColumn1 = pCDcdGrid->getYColumn(
			iYColumnNumber1);
		if (pCDcdGridYColumn1)
		{
			//(1.3.*.4)　Y列のセルの高さを設定
			{
				CdDcdSizeXy aCdDcdSizeXy;
				if (pCDcDrawCell1->getItemSize(
					&aCDcdTarget, &aCdDcdSizeXy))
				{
					pCDcdGridYColumn1->setColumnSize(
						aCdDcdSizeXy.getY());
				}
			}
			//	　(1.3.*.5)　Y列(ColumnType_Ressyabangou) の境界線の
			//	DcDrawオブジェクト に属性を設定。
			//	　(1.3.*.6)　Y列ColumnType_Ressyabangou) の境界線の
			//	高さを設定
			{
				CDcdGridYBorder* pCDcdGridYBorder1
					= pCDcdGridYColumn1->getCDcdGridYBorder();
				Ou<CDcdLine> pCDcdLine =
					pCDcdGridYBorder1->getIfDcDraw();
				pCDcdLine->setCdPenProp(getCdPenPropNullLine());
				//pCDcdLine->setCdPenProp(getCdPenPropNarrowLine());


				// --------------------------------
				//	線の幅から、列幅を設定
				CdDcdSizeXy aCdDcdSizeXy;
				if (pCDcdLine->getItemSize(
					&aCDcdTarget, &aCdDcdSizeXy))
				{
					pCDcdGridYBorder1->setColumnBorderSize(
						aCdDcdSizeXy.getX());
				}
			}
		}

		CDcdGridYColumn* pCDcdGridYColumn2 = pCDcdGrid->getYColumn(
			iYColumnNumber2);
		if (pCDcdGridYColumn2)
		{
			//(1.3.*.4)　Y列のセルの高さを設定
			{
				CdDcdSizeXy aCdDcdSizeXy;
				if (pCDcDrawCell2->getItemSize(
					&aCDcdTarget, &aCdDcdSizeXy))
				{
					pCDcdGridYColumn2->setColumnSize(
						aCdDcdSizeXy.getY());
				}
			}
			//	　(1.3.*.5)　Y列(ColumnType_Ressyabangou) の境界線の
			//	DcDrawオブジェクト に属性を設定。
			//	　(1.3.*.6)　Y列ColumnType_Ressyabangou) の境界線の
			//	高さを設定
			{
				CDcdGridYBorder* pCDcdGridYBorder2
					= pCDcdGridYColumn2->getCDcdGridYBorder();
				Ou<CDcdLine> pCDcdLine =
					pCDcdGridYBorder2->getIfDcDraw();
				pCDcdLine->setCdPenProp(getCdPenPropNarrowLine());
				//pCDcdLine->setCdPenProp(getCdPenPropNullLine());

				// --------------------------------
				//	線の幅から、列幅を設定
				CdDcdSizeXy aCdDcdSizeXy;
				if (pCDcdLine->getItemSize(
					&aCDcdTarget, &aCdDcdSizeXy))
				{
					pCDcdGridYBorder2->setColumnBorderSize(
						aCdDcdSizeXy.getX());
				}
			}
		}

	}
}

void CCellBuilderCustomize::update01_03_02_06_setEkimei_Chaku( 
	CWndJikokuhyou* pCWndJikokuhyou ) 
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid() ;
	CDcdTargetGetDC	aCDcdTarget( NULL ) ;

	// --------------------------------
	const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki = 
		m_pCDedRosenFileData->getCentDedRosen()->getCentDedEkiCont()->getMuPtr(
		m_pCentDedRessyaCont->getRessyahoukou() ) ;

	// --------------------------------
	CdXColSpec aCdXColSpec( 
		CdXColSpec::ColumnType_Ekimei ) ;
	int iXColumnNumber = 
		m_CdXColSpecCont.ColumnNumberFromSpec( aCdXColSpec ) ;
	if ( iXColumnNumber >= 0 )
	{
		for ( int iEkiOrder = 0 ; iEkiOrder < muCdDedEki->size() ; 
			iEkiOrder ++ )
		{
			CentDedEkiCont::CdDedEki aCdDedEki = muCdDedEki->get( iEkiOrder ) ;

			CdYColSpec aCdYColSpec( 
				CdYColSpec::ColumnType_Ekijikoku_Chaku , 
				iEkiOrder ) ;
			int iYColumnNumber = 
				m_CdYColSpecCont.ColumnNumberFromSpec( aCdYColSpec , false ) ;
			CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell( 
				iXColumnNumber , iYColumnNumber ) ;

			typedef CDcdTextbox CDcDrawCell ;
			Ou<CDcDrawCell> pCDcDrawCell ;
			if ( pCDcdGridCell != 0 )
			{
				//(1.3.*.1)　セルの結合セルの属性を設定。
				/**
					2.0Update
					・カスタマイズ時刻表
						次の列が発時刻の場合のみ結合する
				*/

				CdYColSpec aCdYColSpecNext
					= m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumber + 1);
				if (aCdYColSpec.getColumnType() == aCdYColSpec.ColumnType_Ekijikoku_Chaku
					&& aCdYColSpecNext.getColumnType() == aCdYColSpecNext.ColumnType_Ekijikoku_Hatsu
					&& aCdYColSpec.getEkiOrder() == aCdYColSpecNext.getEkiOrder())
				{
					pCDcdGridCell->setAttachCellCount(1, 2);
				}
				else
				{
					pCDcdGridCell->setAttachCellCount(1, 1);
				}


				//	(1.3.*.2)　セルのDcDrawオブジェクトの型を設定
				//	( CDcdTextbox とする)。
				{
					pCDcDrawCell = dynamic_castOu<CDcDrawCell>( 
						pCDcdGridCell->getIfDcDraw() ) ;
					if ( pCDcDrawCell == NULL )
					{
						pCDcDrawCell = OuNew<CDcDrawCell>( new CDcDrawCell ) ;
						pCDcdGridCell->setIfDcDraw( pCDcDrawCell ) ;
					}
				}
				//(1.3.*.3)　セルのDcDrawオブジェクトに、属性を設定。
				{
					*pCDcDrawCell = createCDcdEkimei() ;
					pCDcDrawCell->setText( aCdDedEki.getEkimei() );
				}
			}
			CDcdGridYColumn* pCDcdGridYColumn = pCDcdGrid->getYColumn( 
				iYColumnNumber ) ;
			if ( pCDcdGridYColumn )
			{
				//(1.3.*.4)　Y列のセルの高さを設定
				{
					CdDcdSizeXy aCdDcdSizeXy ;
					if ( pCDcDrawCell->getItemSize( 
						&aCDcdTarget , &aCdDcdSizeXy ) )
					{
						pCDcdGridYColumn->setColumnSize( 
							aCdDcdSizeXy.getY() ) ;
					}
				}
				//	　(1.3.*.5)　Y列(ColumnType_Ressyabangou) の境界線の
				//	DcDrawオブジェクト に属性を設定。
				//	　(1.3.*.6)　Y列ColumnType_Ressyabangou) の境界線の
				//	高さを設定
				{
					CDcdGridYBorder* pCDcdGridYBorder 
						= pCDcdGridYColumn->getCDcdGridYBorder() ;
					Ou<CDcdLine> pCDcdLine = 
						pCDcdGridYBorder->getIfDcDraw() ;

					//	この駅の駅時刻形式が「着発」 AND
					//	この列が着で、次の列が発なら、下に罫線
					CdYColSpec aCdYColSpecNext  
						= m_CdYColSpecCont.ColumnNumberToSpec( 
							iYColumnNumber + 1 ) ;
					if (aCdYColSpecNext.getColumnType() == aCdYColSpec.ColumnType_Bikou)
					{
						pCDcdLine->setCdPenProp(getCdPenPropBoldLine());
					}
					else if (aCdYColSpec.getEkiOrder()
						!= aCdYColSpecNext.getEkiOrder()
						&& aCdDedEki.getKyoukaisen())
					{
						pCDcdLine->setCdPenProp(getCdPenPropBoldLine());
					}
					else if (aCdYColSpec.getEkiOrder()
						!= aCdYColSpecNext.getEkiOrder() &&
						aCdYColSpecNext.isEkiJikoku())
					{
						pCDcdLine->setCdPenProp(getCdPenPropNullLine());
					}
					else
					{
						pCDcdLine->setCdPenProp(getCdPenPropNarrowLine());
					}
					
					// --------------------------------
					//	線の幅から、列幅を設定
					CdDcdSizeXy aCdDcdSizeXy ;
					if ( pCDcdLine->getItemSize( 
						&aCDcdTarget , &aCdDcdSizeXy ) )
					{
						if (pCDcdLine->getCdPenProp().getLogicalunitWidth() >0)
						{
							pCDcdGridYBorder->setColumnBorderSize(
								aCdDcdSizeXy.getX());
						}
						else
						{
							pCDcdGridYBorder->setColumnBorderSize((DcdSize)0);
						}
					}
				}
			}
		}
	}
}

void CCellBuilderCustomize::update01_03_02_09_setEkimei_Track(
	CWndJikokuhyou* pCWndJikokuhyou)
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	CDcdTargetGetDC	aCDcdTarget(NULL);

	// --------------------------------
	const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki =
		m_pCDedRosenFileData->getCentDedRosen()->getCentDedEkiCont()->getMuPtr(
			m_pCentDedRessyaCont->getRessyahoukou());

	// --------------------------------
	CdXColSpec aCdXColSpec(
		CdXColSpec::ColumnType_Ekimei);
	int iXColumnNumber =
		m_CdXColSpecCont.ColumnNumberFromSpec(aCdXColSpec);
	if (iXColumnNumber >= 0)
	{
		for (int iEkiOrder = 0; iEkiOrder < muCdDedEki->size();
			iEkiOrder++)
		{
			CentDedEkiCont::CdDedEki aCdDedEki = muCdDedEki->get(iEkiOrder);

			CdYColSpec aCdYColSpec(
				CdYColSpec::ColumnType_Track,
				iEkiOrder);
			int iYColumnNumber =
				m_CdYColSpecCont.ColumnNumberFromSpec(aCdYColSpec, false);
			CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell(
				iXColumnNumber, iYColumnNumber);

			typedef CDcdTextbox CDcDrawCell;
			Ou<CDcDrawCell> pCDcDrawCell;
			if (pCDcdGridCell != 0)
			{
				//(1.3.*.1)　セルの結合セルの属性を設定。
				/**
					2.0Update
					・カスタマイズ時刻表
						右側着発の表示セルと、結合
				*/
				pCDcdGridCell->setAttachCellCount(2, 1);

				//	(1.3.*.2)　セルのDcDrawオブジェクトの型を設定
				//	( CDcdTextbox とする)。
				{
					pCDcDrawCell = dynamic_castOu<CDcDrawCell>(
						pCDcdGridCell->getIfDcDraw());
					if (pCDcDrawCell == NULL)
					{
						pCDcDrawCell = OuNew<CDcDrawCell>(new CDcDrawCell);
						pCDcdGridCell->setIfDcDraw(pCDcDrawCell);
					}
				}
				//(1.3.*.3)　セルのDcDrawオブジェクトに、属性を設定。
				{
					*pCDcDrawCell = createCDcdEkimei();
					//AllTrackの場合、駅名、そうでない場合、着発番線・発車番線・到着番線のいずれか
					//if (m_bDisplayAllTrack)
					//{
					//	pCDcDrawCell->setText(aCdDedEki.getEkimei());
					//}
					//else 
					if(aCdDedEki.isHatsuChakuHyouji())
					{
						pCDcDrawCell->setText(tstringOf(
							(LPCTSTR)MfcUtil::LoadCString(
								IDS_WORD_TrackChakuHatsu)));
					}
					else if (aCdDedEki.getChakujikokuHyouji())
					{
						pCDcDrawCell->setText(tstringOf(
							(LPCTSTR)MfcUtil::LoadCString(
								IDS_WORD_TrackChaku)));
					}
					else
					{
						pCDcDrawCell->setText(tstringOf(
							(LPCTSTR)MfcUtil::LoadCString(
								IDS_WORD_TrackHatsu)));
					}
				}
			}

			CDcdGridYColumn* pCDcdGridYColumn = pCDcdGrid->getYColumn(
				iYColumnNumber);
			if (pCDcdGridYColumn)
			{
				//(1.3.*.4)　Y列のセルの高さを設定
				{
					CdDcdSizeXy aCdDcdSizeXy;
					if (pCDcDrawCell->getItemSize(
						&aCDcdTarget, &aCdDcdSizeXy))
					{
						pCDcdGridYColumn->setColumnSize(
							aCdDcdSizeXy.getY());
					}
				}
				//	　(1.3.*.5)　Y列(ColumnType_Ressyabangou) の境界線の
				//	DcDrawオブジェクト に属性を設定。
				//	　(1.3.*.6)　Y列ColumnType_Ressyabangou) の境界線の
				//	高さを設定
				{
					CDcdGridYBorder* pCDcdGridYBorder
						= pCDcdGridYColumn->getCDcdGridYBorder();
					Ou<CDcdLine> pCDcdLine =
						pCDcdGridYBorder->getIfDcDraw();

					CdYColSpec aCdYColSpecNext
						= m_CdYColSpecCont.ColumnNumberToSpec(
							iYColumnNumber + 1);
					if (aCdYColSpecNext.getColumnType() == aCdYColSpec.ColumnType_Bikou)
					{
						pCDcdLine->setCdPenProp(getCdPenPropBoldLine());
					}
					else if (aCdYColSpec.getEkiOrder()
						!= aCdYColSpecNext.getEkiOrder()
						&& aCdDedEki.getKyoukaisen())
					{
						pCDcdLine->setCdPenProp(getCdPenPropBoldLine());
					}
					else
					{
						pCDcdLine->setCdPenProp(getCdPenPropNarrowLine());
					}
					
					// --------------------------------
					//	線の幅から、列幅を設定
					CdDcdSizeXy aCdDcdSizeXy;
					if (pCDcdLine->getItemSize(
						&aCDcdTarget, &aCdDcdSizeXy))
					{
						pCDcdGridYBorder->setColumnBorderSize(
							aCdDcdSizeXy.getX());
					}
				}
			}
		}
	}
}

void CCellBuilderCustomize::update01_03_02_19_setEkimei_Ressyabangou(
	CWndJikokuhyou* pCWndJikokuhyou)
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	CDcdTargetGetDC	aCDcdTarget(NULL);

	// --------------------------------
	const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki =
		m_pCDedRosenFileData->getCentDedRosen()->getCentDedEkiCont()->getMuPtr(
			m_pCentDedRessyaCont->getRessyahoukou());
	CdXColSpec aCdXColSpec(
		CdXColSpec::ColumnType_Ekimei);
	int iXColumnNumber =
		m_CdXColSpecCont.ColumnNumberFromSpec(aCdXColSpec);

	if (iXColumnNumber >= 0)
	{
		for (int iEkiOrder = 0; iEkiOrder < muCdDedEki->size();
			iEkiOrder++)
		{
			CentDedEkiCont::CdDedEki aCdDedEki = muCdDedEki->get(iEkiOrder);
			CdYColSpec aCdYColSpec(
				CdYColSpec::ColumnType_EkiRessyabangou,
				iEkiOrder);
			int iYColumnNumber = m_CdYColSpecCont.ColumnNumberFromSpec(
				aCdYColSpec, false);
			CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell(
				iXColumnNumber, iYColumnNumber);

			typedef CDcdTextbox CDcDrawCell;
			Ou<CDcDrawCell> pCDcDrawCell;

			if (pCDcdGridCell != 0)
			{
				//(1.3.*.1)　セル(ColumnType_Ekimei,ColumnType_Ressyabangou) 
				//	の結合セルの属性を設定。
				pCDcdGridCell->setAttachCellCount(2, 1);

				//	(1.3.*.2)　セル(ColumnType_Ekimei,ColumnType_Ressyabangou) 
				//	のDcDrawオブジェクトの型を設定
				//	( CDcdTextbox とする)。
				{
					pCDcDrawCell = dynamic_castOu<CDcDrawCell>(
						pCDcdGridCell->getIfDcDraw());
					if (pCDcDrawCell == NULL)
					{
						pCDcDrawCell = OuNew<CDcDrawCell>(new CDcDrawCell);
						pCDcdGridCell->setIfDcDraw(pCDcDrawCell);
					}
				}

				//(1.3.*.3)　セル(ColumnType_Ekimei,ColumnType_Ressyabangou) 
				//	DcDrawオブジェクトに、属性を設定。
				{
					*pCDcDrawCell = createCDcdXColumn0();
					pCDcDrawCell->setText(tstringOf(
						(LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_Ressyabangou)));
				}
			}

			CDcdGridYColumn* pCDcdGridYColumn = pCDcdGrid->getYColumn(
				iYColumnNumber);
			if (pCDcdGridYColumn)
			{
				//(1.3.*.4)　Y列(ColumnType_Ressyabangou) のセルの高さを設定
				{
					CdDcdSizeXy aCdDcdSizeXy;
					if (pCDcDrawCell->getItemSize(
						&aCDcdTarget, &aCdDcdSizeXy))
					{
						pCDcdGridYColumn->setColumnSize(aCdDcdSizeXy.getY());
					}
				}
				//	　(1.3.*.5)　Y列(ColumnType_Ressyabangou) の境界線の
				//	DcDrawオブジェクト に属性を設定。
				//	　(1.3.*.6)　Y列ColumnType_Ressyabangou) の境界線の
				//	高さを設定
				{
					CDcdGridYBorder* pCDcdGridYBorder
						= pCDcdGridYColumn->getCDcdGridYBorder();
					Ou<CDcdLine> pCDcdLine = pCDcdGridYBorder->getIfDcDraw();

					CdYColSpec aCdYColSpecNext
						= m_CdYColSpecCont.ColumnNumberToSpec(
							iYColumnNumber + 1);
					if (aCdYColSpecNext.getColumnType() == aCdYColSpec.ColumnType_Bikou)
					{
						pCDcdLine->setCdPenProp(getCdPenPropBoldLine());
					}
					else if (aCdYColSpec.getEkiOrder()
						!= aCdYColSpecNext.getEkiOrder()
						&& aCdDedEki.getKyoukaisen())
					{
						pCDcdLine->setCdPenProp(getCdPenPropBoldLine());
					}
					else
					{
						pCDcdLine->setCdPenProp(getCdPenPropNarrowLine());
					}

					CdDcdSizeXy aCdDcdSizeXy;
					if (pCDcdLine->getItemSize(
						&aCDcdTarget, &aCdDcdSizeXy))
					{
						pCDcdGridYBorder->setColumnBorderSize(
							aCdDcdSizeXy.getX());
					}
				}
			}
		}
	}
}

void CCellBuilderCustomize::update01_03_02_20_setEkimei_OperationNumber(
	CWndJikokuhyou * pCWndJikokuhyou)
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	CDcdTargetGetDC	aCDcdTarget(NULL);

	// --------------------------------
	const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki =
		m_pCDedRosenFileData->getCentDedRosen()->getCentDedEkiCont()->getMuPtr(
			m_pCentDedRessyaCont->getRessyahoukou());
	CdXColSpec aCdXColSpec(
		CdXColSpec::ColumnType_Ekimei);
	int iXColumnNumber =
		m_CdXColSpecCont.ColumnNumberFromSpec(aCdXColSpec);


	if (iXColumnNumber >= 0)
	{
		for (int iEkiOrder = 0; iEkiOrder < muCdDedEki->size();
			iEkiOrder++)
		{
			CentDedEkiCont::CdDedEki aCdDedEki = muCdDedEki->get(iEkiOrder);
			CdYColSpec aCdYColSpec(
				CdYColSpec::ColumnType_EkiOperationNumber,
				iEkiOrder);
			int iYColumnNumber = m_CdYColSpecCont.ColumnNumberFromSpec(
				aCdYColSpec, false);
			CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell(
				iXColumnNumber, iYColumnNumber);

			typedef CDcdTextbox CDcDrawCell;
			Ou<CDcDrawCell> pCDcDrawCell;

			if (pCDcdGridCell != NULL)
			{
				//(1.3.*.1)　結合セルの属性を設定。
				pCDcdGridCell->setAttachCellCount(2, 1);

				//	(1.3.*.2)　セル 
				//	のDcDrawオブジェクトの型を設定
				//	( CDcdTextbox とする)。
				{
					pCDcDrawCell = dynamic_castOu<CDcDrawCell>(
						pCDcdGridCell->getIfDcDraw());
					if (pCDcDrawCell == NULL)
					{
						pCDcDrawCell = OuNew<CDcDrawCell>(new CDcDrawCell);
						pCDcdGridCell->setIfDcDraw(pCDcDrawCell);
					}
				}
				//(1.3.*.3)　セルの DcDrawオブジェクトに、属性を設定。
				{
					*pCDcDrawCell = createCDcdXColumn0();
					pCDcDrawCell->setText(tstringOf(
						(LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_OperationNumber)));
				}
			}
			CDcdGridYColumn* pCDcdGridYColumn = pCDcdGrid->getYColumn(
				iYColumnNumber);
			if (pCDcdGridYColumn != NULL)
			{
				//(1.3.*.4)　Y列 のセルの高さを設定
				{
					CdDcdSizeXy aCdDcdSizeXy;
					if (pCDcDrawCell->getItemSize(
						&aCDcdTarget, &aCdDcdSizeXy))
					{
						pCDcdGridYColumn->setColumnSize(aCdDcdSizeXy.getY());
					}
				}
				//	　(1.3.*.5)　Y列 の境界線の
				//	DcDrawオブジェクト に属性を設定。
				//	　(1.3.*.6)　Y列 の境界線の
				//	高さを設定
				{
					CDcdGridYBorder* pCDcdGridYBorder
						= pCDcdGridYColumn->getCDcdGridYBorder();
					Ou<CDcdLine> pCDcdLine = pCDcdGridYBorder->getIfDcDraw();

					CdYColSpec aCdYColSpecNext
						= m_CdYColSpecCont.ColumnNumberToSpec(
							iYColumnNumber + 1);
					if (aCdYColSpecNext.getColumnType() == aCdYColSpec.ColumnType_Bikou)
					{
						pCDcdLine->setCdPenProp(getCdPenPropBoldLine());
					}
					else if (aCdYColSpec.getEkiOrder()
						!= aCdYColSpecNext.getEkiOrder()
						&& aCdDedEki.getKyoukaisen())
					{
						pCDcdLine->setCdPenProp(getCdPenPropBoldLine());
					}
					else
					{
						pCDcdLine->setCdPenProp(getCdPenPropNarrowLine());
					}

					CdDcdSizeXy aCdDcdSizeXy;
					if (pCDcdLine->getItemSize(
						&aCDcdTarget, &aCdDcdSizeXy))
					{
						pCDcdGridYBorder->setColumnBorderSize(
							aCdDcdSizeXy.getX());
					}
				}
			}
		}
	}
}


void CCellBuilderCustomize::update01_03_02_21_setEkimei_Ressyasyubetsu(
	CWndJikokuhyou* pCWndJikokuhyou)
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	CDcdTargetGetDC	aCDcdTarget(NULL);

	// --------------------------------
	const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki =
		m_pCDedRosenFileData->getCentDedRosen()->getCentDedEkiCont()->getMuPtr(
			m_pCentDedRessyaCont->getRessyahoukou());
	CdXColSpec aCdXColSpec(
		CdXColSpec::ColumnType_Ekimei);
	int iXColumnNumber =
		m_CdXColSpecCont.ColumnNumberFromSpec(aCdXColSpec);


	if (iXColumnNumber >= 0)
	{
		for (int iEkiOrder = 0; iEkiOrder < muCdDedEki->size();
			iEkiOrder++)
		{
			CentDedEkiCont::CdDedEki aCdDedEki = muCdDedEki->get(iEkiOrder);
			CdYColSpec aCdYColSpec(
				CdYColSpec::ColumnType_EkiRessyasyubetsu,
				iEkiOrder);
			int iYColumnNumber = m_CdYColSpecCont.ColumnNumberFromSpec(
				aCdYColSpec, false);
			CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell(
				iXColumnNumber, iYColumnNumber);

			typedef CDcdTextbox CDcDrawCell;
			Ou<CDcDrawCell> pCDcDrawCell;

			if (pCDcdGridCell != NULL)
			{
				//(1.3.*.1)　結合セルの属性を設定。
				pCDcdGridCell->setAttachCellCount(2, 1);

				//	(1.3.*.2)　セル 
				//	のDcDrawオブジェクトの型を設定
				//	( CDcdTextbox とする)。
				{
					pCDcDrawCell = dynamic_castOu<CDcDrawCell>(
						pCDcdGridCell->getIfDcDraw());
					if (pCDcDrawCell == NULL)
					{
						pCDcDrawCell = OuNew<CDcDrawCell>(new CDcDrawCell);
						pCDcdGridCell->setIfDcDraw(pCDcDrawCell);
					}
				}
				//(1.3.*.3)　セルの DcDrawオブジェクトに、属性を設定。
				{
					*pCDcDrawCell = createCDcdXColumn0();
					pCDcDrawCell->setText(tstringOf(
						(LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_RESSYASYUBETSU)));
				}
			}
			CDcdGridYColumn* pCDcdGridYColumn = pCDcdGrid->getYColumn(
				iYColumnNumber);
			if (pCDcdGridYColumn != NULL)
			{
				//(1.3.*.4)　Y列 のセルの高さを設定
				{
					CdDcdSizeXy aCdDcdSizeXy;
					if (pCDcDrawCell->getItemSize(
						&aCDcdTarget, &aCdDcdSizeXy))
					{
						pCDcdGridYColumn->setColumnSize(aCdDcdSizeXy.getY());
					}
				}
				//	　(1.3.*.5)　Y列 の境界線の
				//	DcDrawオブジェクト に属性を設定。
				//	　(1.3.*.6)　Y列 の境界線の
				//	高さを設定
				{
					CDcdGridYBorder* pCDcdGridYBorder
						= pCDcdGridYColumn->getCDcdGridYBorder();
					Ou<CDcdLine> pCDcdLine = pCDcdGridYBorder->getIfDcDraw();

					CdYColSpec aCdYColSpecNext
						= m_CdYColSpecCont.ColumnNumberToSpec(
							iYColumnNumber + 1);
					if (aCdYColSpecNext.getColumnType() == aCdYColSpec.ColumnType_Bikou)
					{
						pCDcdLine->setCdPenProp(getCdPenPropBoldLine());
					}
					else if (aCdYColSpec.getEkiOrder()
						!= aCdYColSpecNext.getEkiOrder()
						&& aCdDedEki.getKyoukaisen())
					{
						pCDcdLine->setCdPenProp(getCdPenPropBoldLine());
					}
					else
					{
						pCDcdLine->setCdPenProp(getCdPenPropNarrowLine());
					}

					CdDcdSizeXy aCdDcdSizeXy;
					if (pCDcdLine->getItemSize(
						&aCDcdTarget, &aCdDcdSizeXy))
					{
						pCDcdGridYBorder->setColumnBorderSize(
							aCdDcdSizeXy.getX());
					}
				}
			}
		}
	}
}


void CCellBuilderCustomize::update01_03_02_22_setEkimei_Ressyamei(
	CWndJikokuhyou* pCWndJikokuhyou)
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	CDcdTargetGetDC	aCDcdTarget(NULL);

	// --------------------------------
	const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki =
		m_pCDedRosenFileData->getCentDedRosen()->getCentDedEkiCont()->getMuPtr(
			m_pCentDedRessyaCont->getRessyahoukou());
	CdXColSpec aCdXColSpec(
		CdXColSpec::ColumnType_Ekimei);
	int iXColumnNumber =
		m_CdXColSpecCont.ColumnNumberFromSpec(aCdXColSpec);

	if (iXColumnNumber >= 0)
	{
		for (int iEkiOrder = 0; iEkiOrder < muCdDedEki->size();
			iEkiOrder++)
		{
			CdYColSpec aCdYColSpec(
				CdYColSpec::ColumnType_EkiRessyamei,
				iEkiOrder);
			int iYColumnNumber = m_CdYColSpecCont.ColumnNumberFromSpec(
				aCdYColSpec, false);
			CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell(
				iXColumnNumber, iYColumnNumber);

			typedef CDcdTextboxV3 CDcDrawCell;
			Ou<CDcDrawCell> pCDcDrawCell;

			if (pCDcdGridCell != NULL)
			{
				//(1.3.*.1)　結合セルの属性を設定。
				pCDcdGridCell->setAttachCellCount(2, 3);

				//	(1.3.*.2)　セル(ColumnType_Ekimei,ColumnType_Ressyabangou) 
				//	のDcDrawオブジェクトの型を設定
				//	( CDcdTextbox とする)。
				{
					pCDcDrawCell = dynamic_castOu<CDcDrawCell>(
						pCDcdGridCell->getIfDcDraw());
					if (pCDcDrawCell == NULL)
					{
						pCDcDrawCell = OuNew<CDcDrawCell>(new CDcDrawCell);
						pCDcdGridCell->setIfDcDraw(pCDcDrawCell);
					}
				}
				//(1.3.*.3)　セル(ColumnType_Ekimei,ColumnType_Ressyabangou) 
				//	DcDrawオブジェクトに、属性を設定。
				{
					*pCDcDrawCell = createCDcdXColumn0V();
					pCDcDrawCell->setText(tstringOf(
						(LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_Ressyamei)));
				}
			}
			CDcdGridYColumn* pCDcdGridYColumn = pCDcdGrid->getYColumn(
				iYColumnNumber);
			if (pCDcdGridYColumn != NULL)
			{
				//(1.3.*.4)　Y列 のセルの高さを設定
				{
					CdDcdSizeXy aCdDcdSizeXy;
					if (pCDcDrawCell->getItemSize(
						&aCDcdTarget, &aCdDcdSizeXy))
					{
						pCDcdGridYColumn->setColumnSize(aCdDcdSizeXy.getY());
					}
				}
				//	　(1.3.*.5)　Y列 の境界線の
				//	DcDrawオブジェクト に属性を設定。
				//	　(1.3.*.6)　Y列 の境界線の
				//	高さを設定
				{
					CDcdGridYBorder* pCDcdGridYBorder
						= pCDcdGridYColumn->getCDcdGridYBorder();
					Ou<CDcdLine> pCDcdLine = pCDcdGridYBorder->getIfDcDraw();
					pCDcdLine->setCdPenProp(getCdPenPropNullLine());

					CdDcdSizeXy aCdDcdSizeXy;
					if (pCDcdLine->getItemSize(
						&aCDcdTarget, &aCdDcdSizeXy))
					{
						pCDcdGridYBorder->setColumnBorderSize(
							aCdDcdSizeXy.getX());
					}
				}
			}
		}
	}
}


void CCellBuilderCustomize::update01_03_02_23_setEkimei_Gousuu(
	CWndJikokuhyou* pCWndJikokuhyou)
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	CDcdTargetGetDC	aCDcdTarget(NULL);

	// --------------------------------
	const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki =
		m_pCDedRosenFileData->getCentDedRosen()->getCentDedEkiCont()->getMuPtr(
			m_pCentDedRessyaCont->getRessyahoukou());
	CdXColSpec aCdXColSpec(
		CdXColSpec::ColumnType_Ekimei);
	int iXColumnNumber =
		m_CdXColSpecCont.ColumnNumberFromSpec(aCdXColSpec);

	if (iXColumnNumber >= 0)
	{
		for (int iEkiOrder = 0; iEkiOrder < muCdDedEki->size();
			iEkiOrder++)
		{
			CdYColSpec aCdYColSpec(
				CdYColSpec::ColumnType_EkiGousuu,
				iEkiOrder);
			int iYColumnNumber = m_CdYColSpecCont.ColumnNumberFromSpec(
				aCdYColSpec, false);
			CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell(
				iXColumnNumber, iYColumnNumber);

			typedef CDcdTextbox CDcDrawCell;
			Ou<CDcDrawCell> pCDcDrawCell;

			if (pCDcdGridCell != NULL)
			{
				//(1.3.*.1)　結合セルの属性を設定。
				pCDcdGridCell->setAttachCellCount(2, 1);

				//	(1.3.*.2)　セルのDcDrawオブジェクトの型を設定
				{
					pCDcDrawCell = dynamic_castOu<CDcDrawCell>(
						pCDcdGridCell->getIfDcDraw());
					if (pCDcDrawCell == NULL)
					{
						pCDcDrawCell = OuNew<CDcDrawCell>(new CDcDrawCell);
						pCDcdGridCell->setIfDcDraw(pCDcDrawCell);
					}
				}
				//(1.3.*.3)　セルのDcDrawオブジェクトに、属性を設定。
				{
					*pCDcDrawCell = createCDcdXColumn0();
				}
			}
			CDcdGridYColumn* pCDcdGridYColumn = pCDcdGrid->getYColumn(
				iYColumnNumber);
			if (pCDcdGridYColumn != NULL)
			{
				//(1.3.*.4)　Y列 のセルの高さを設定
				{
					CdDcdSizeXy aCdDcdSizeXy;
					if (pCDcDrawCell->getItemSize(
						&aCDcdTarget, &aCdDcdSizeXy))
					{
						pCDcdGridYColumn->setColumnSize(aCdDcdSizeXy.getY());
					}
				}
				//	　(1.3.*.5)　Y列 の境界線の
				//	DcDrawオブジェクト に属性を設定。
				//	　(1.3.*.6)　Y列 の境界線の
				//	高さを設定
				{
					CDcdGridYBorder* pCDcdGridYBorder
						= pCDcdGridYColumn->getCDcdGridYBorder();
					Ou<CDcdLine> pCDcdLine = pCDcdGridYBorder->getIfDcDraw();
					pCDcdLine->setCdPenProp(getCdPenPropNullLine());

					CdDcdSizeXy aCdDcdSizeXy;
					if (pCDcdLine->getItemSize(
						&aCDcdTarget, &aCdDcdSizeXy))
					{
						pCDcdGridYBorder->setColumnBorderSize(
							aCdDcdSizeXy.getX());
					}
				}
			}
		}
	}
}


void CCellBuilderCustomize::update01_03_02_24_setEkimei_Gou(
	CWndJikokuhyou* pCWndJikokuhyou)
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	CDcdTargetGetDC	aCDcdTarget(NULL);

	// --------------------------------
	const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki =
		m_pCDedRosenFileData->getCentDedRosen()->getCentDedEkiCont()->getMuPtr(
			m_pCentDedRessyaCont->getRessyahoukou());
	CdXColSpec aCdXColSpec(
		CdXColSpec::ColumnType_Ekimei);
	int iXColumnNumber =
		m_CdXColSpecCont.ColumnNumberFromSpec(aCdXColSpec);

	if (iXColumnNumber >= 0)
	{
		for (int iEkiOrder = 0; iEkiOrder < muCdDedEki->size();
			iEkiOrder++)
		{
			CentDedEkiCont::CdDedEki aCdDedEki = muCdDedEki->get(iEkiOrder);
			CdYColSpec aCdYColSpec(
				CdYColSpec::ColumnType_EkiGou,
				iEkiOrder);
			int iYColumnNumber = m_CdYColSpecCont.ColumnNumberFromSpec(
				aCdYColSpec, false);
			CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell(
				iXColumnNumber, iYColumnNumber);

			typedef CDcdTextbox CDcDrawCell;
			Ou<CDcDrawCell> pCDcDrawCell;

			if (pCDcdGridCell != NULL)
			{
				//(1.3.*.1)　結合セルの属性を設定。
				pCDcdGridCell->setAttachCellCount(2, 1);

				//	(1.3.*.2)　セルのDcDrawオブジェクトの型を設定
				{
					pCDcDrawCell = dynamic_castOu<CDcDrawCell>(
						pCDcdGridCell->getIfDcDraw());
					if (pCDcDrawCell == NULL)
					{
						pCDcDrawCell = OuNew<CDcDrawCell>(new CDcDrawCell);
						pCDcdGridCell->setIfDcDraw(pCDcDrawCell);
					}
				}
				//(1.3.*.3)　セルのDcDrawオブジェクトに、属性を設定。
				{
					*pCDcDrawCell = createCDcdXColumn0();
				}
			}
			CDcdGridYColumn* pCDcdGridYColumn = pCDcdGrid->getYColumn(
				iYColumnNumber);
			if (pCDcdGridYColumn != NULL)
			{
				//(1.3.*.4)　Y列 のセルの高さを設定
				{
					CdDcdSizeXy aCdDcdSizeXy;
					if (pCDcDrawCell->getItemSize(
						&aCDcdTarget, &aCdDcdSizeXy))
					{
						pCDcdGridYColumn->setColumnSize(aCdDcdSizeXy.getY());
					}
				}
				//	　(1.3.*.5)　Y列 の境界線の
				//	DcDrawオブジェクト に属性を設定。
				//	　(1.3.*.6)　Y列 の境界線の
				//	高さを設定
				{
					CDcdGridYBorder* pCDcdGridYBorder
						= pCDcdGridYColumn->getCDcdGridYBorder();
					Ou<CDcdLine> pCDcdLine = pCDcdGridYBorder->getIfDcDraw();

					CdYColSpec aCdYColSpecNext
						= m_CdYColSpecCont.ColumnNumberToSpec(
							iYColumnNumber + 1);
					if (aCdYColSpecNext.getColumnType() == aCdYColSpec.ColumnType_Bikou)
					{
						pCDcdLine->setCdPenProp(getCdPenPropBoldLine());
					}
					else if (aCdYColSpec.getEkiOrder()
						!= aCdYColSpecNext.getEkiOrder()
						&& aCdDedEki.getKyoukaisen())
					{
						pCDcdLine->setCdPenProp(getCdPenPropBoldLine());
					}
					else
					{
						pCDcdLine->setCdPenProp(getCdPenPropNarrowLine());
					}

					CdDcdSizeXy aCdDcdSizeXy;
					if (pCDcdLine->getItemSize(
						&aCDcdTarget, &aCdDcdSizeXy))
					{
						pCDcdGridYBorder->setColumnBorderSize(
							aCdDcdSizeXy.getX());
					}
				}
			}
		}
	}
}

void CCellBuilderCustomize::update01_03_02_07_setEkimei_Hatsu(
	CWndJikokuhyou* pCWndJikokuhyou ) 
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid() ;
	CDcdTargetGetDC	aCDcdTarget( NULL ) ;

	// --------------------------------
	const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki = 
		m_pCDedRosenFileData->getCentDedRosen()->getCentDedEkiCont()->getMuPtr(
		m_pCentDedRessyaCont->getRessyahoukou() ) ;

	// --------------------------------
	CdXColSpec aCdXColSpec( 
		CdXColSpec::ColumnType_Ekimei ) ;
	int iXColumnNumber = 
		m_CdXColSpecCont.ColumnNumberFromSpec( aCdXColSpec ) ;
	if ( iXColumnNumber >= 0 )
	{
		for ( int iEkiOrder = 0 ; iEkiOrder < muCdDedEki->size() ; 
			iEkiOrder ++ )
		{
			CentDedEkiCont::CdDedEki aCdDedEki = muCdDedEki->get( iEkiOrder ) ;

			CdYColSpec aCdYColSpec( 
				CdYColSpec::ColumnType_Ekijikoku_Hatsu , 
				iEkiOrder ) ;
			int iYColumnNumber = 
				m_CdYColSpecCont.ColumnNumberFromSpec( aCdYColSpec , false ) ;
			CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell( 
				iXColumnNumber , iYColumnNumber ) ;

			typedef CDcdTextbox CDcDrawCell ;
			Ou<CDcDrawCell> pCDcDrawCell ;
			if ( pCDcdGridCell != 0 )
			{
				//(1.3.*.1)　セルの結合セルの属性を設定。
				
				pCDcdGridCell->setAttachCellCount( 1 , 1 ) ;

				//	(1.3.*.2)　セルのDcDrawオブジェクトの型を設定
				//	( CDcdTextbox とする)。
				{
					pCDcDrawCell = dynamic_castOu<CDcDrawCell>( 
						pCDcdGridCell->getIfDcDraw() ) ;
					if ( pCDcDrawCell == NULL )
					{
						pCDcDrawCell = OuNew<CDcDrawCell>( new CDcDrawCell ) ;
						pCDcdGridCell->setIfDcDraw( pCDcDrawCell ) ;
					}
				}
				//(1.3.*.3)　セルのDcDrawオブジェクトに、属性を設定。
				{
					*pCDcDrawCell = createCDcdEkimei() ;
					pCDcDrawCell->setText( aCdDedEki.getEkimei() );
				}
			}

			CDcdGridYColumn* pCDcdGridYColumn = pCDcdGrid->getYColumn( 
				iYColumnNumber ) ;
			if ( pCDcdGridYColumn )
			{
				//(1.3.*.4)　Y列のセルの高さを設定
				{
					CdDcdSizeXy aCdDcdSizeXy ;
					if ( pCDcDrawCell->getItemSize( 
						&aCDcdTarget , &aCdDcdSizeXy ) )
					{
						pCDcdGridYColumn->setColumnSize( 
							aCdDcdSizeXy.getY() ) ;
					}
				}
				//	　(1.3.*.5)　Y列(ColumnType_Ressyabangou) の境界線の
				//	DcDrawオブジェクト に属性を設定。
				//	　(1.3.*.6)　Y列ColumnType_Ressyabangou) の境界線の
				//	高さを設定
				{
					CDcdGridYBorder* pCDcdGridYBorder 
						= pCDcdGridYColumn->getCDcdGridYBorder() ;
					Ou<CDcdLine> pCDcdLine = 
						pCDcdGridYBorder->getIfDcDraw() ;

					CdYColSpec aCdYColSpecNext  
						= m_CdYColSpecCont.ColumnNumberToSpec( 
							iYColumnNumber + 1 ) ;
					if (aCdYColSpecNext.getColumnType() == aCdYColSpec.ColumnType_Bikou)
					{
						pCDcdLine->setCdPenProp(getCdPenPropBoldLine());
					}
					else if (aCdYColSpec.getEkiOrder()
						!= aCdYColSpecNext.getEkiOrder()
						&& aCdDedEki.getKyoukaisen())
					{
						pCDcdLine->setCdPenProp(getCdPenPropBoldLine());
					}
					else if (aCdYColSpecNext.isEkiJikoku())
					{
						pCDcdLine->setCdPenProp(getCdPenPropNullLine());
					}
					else
					{
						pCDcdLine->setCdPenProp(getCdPenPropNarrowLine());
					}

					//	次の列が異なる駅の列。
					//	当駅に『境界線』属性がある。
					//	次の列が路線外終着駅表示
					//
					//	これら条件を満たす場合は、
					//	下（次の駅との間）に罫線
					//if ( aCdYColSpecNext.isEkiJikoku() 
					//	&& aCdYColSpec.getEkiOrder() 
					//		!= aCdYColSpecNext.getEkiOrder() 
					//	&& aCdDedEki.getKyoukaisen() ) 
					//{
					//	/*pCDcdLine->setCdPenProp( 
					//		getCdPenPropNarrowLine() ) ;*/
					//	pCDcdLine->setCdPenProp(getCdPenPropBoldLine());
					//}
					////	次の列が路線外終着駅表示の場合は、細線
					//else if (aCdYColSpecNext.getColumnType() == aCdYColSpecNext.ColumnType_Outer_Shuchaku1)
					//{
					//	pCDcdLine->setCdPenProp(getCdPenPropNarrowLine());
					//}
					////	次の列が駅時刻、番線表示以外の場合は、太線
					//else if ( !aCdYColSpecNext.isEkiJikoku() &&
					//	aCdYColSpecNext.getColumnType() != aCdYColSpecNext.ColumnType_Track)
					//{
					//	pCDcdLine->setCdPenProp( getCdPenPropBoldLine() ) ;
					//}
					//else
					//{
					//	pCDcdLine->setCdPenProp( getCdPenPropNullLine() ) ;
					//}

					// --------------------------------
					//	線の幅から、列幅を設定
					CdDcdSizeXy aCdDcdSizeXy ;
					if ( pCDcdLine->getItemSize( 
						&aCDcdTarget , &aCdDcdSizeXy ) )
					{
						if(pCDcdLine->getCdPenProp().getLogicalunitWidth() >0)
						{
							pCDcdGridYBorder->setColumnBorderSize(
								aCdDcdSizeXy.getX());
						}
						else
						{
							pCDcdGridYBorder->setColumnBorderSize((DcdSize)0);
						}
					}
				}
			}
		}
	}
}

void CCellBuilderCustomize::update01_03_02_16_setEkimei_OuterTerminal_Shuchaku(
	CWndJikokuhyou* pCWndJikokuhyou)
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	CDcdTargetGetDC	aCDcdTarget(NULL);

	// --------------------------------
	/*const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki =
	m_pCDedRosenFileData->getCentDedRosen()->getCentDedEkiCont()->getMuPtr(
	m_pCentDedRessyaCont->getRessyahoukou());*/

	// --------------------------------
	CdXColSpec aCdXColSpec(
		CdXColSpec::ColumnType_Ekimei);
	int iXColumnNumber =
		m_CdXColSpecCont.ColumnNumberFromSpec(aCdXColSpec);
	if (iXColumnNumber >= 0)
	{
		CdYColSpec aCdYColSpec1(
			CdYColSpec::ColumnType_Outer_Shuchaku1);
		CdYColSpec aCdYColSpec2(
			CdYColSpec::ColumnType_Outer_Shuchaku2);
		int iYColumnNumber1 =
			m_CdYColSpecCont.ColumnNumberFromSpec(aCdYColSpec1, false);
		int iYColumnNumber2 =
			m_CdYColSpecCont.ColumnNumberFromSpec(aCdYColSpec2, false);
		CDcdGridCell* pCDcdGridCell1 = pCDcdGrid->getCell(
			iXColumnNumber, iYColumnNumber1);
		CDcdGridCell* pCDcdGridCell2 = pCDcdGrid->getCell(
			iXColumnNumber, iYColumnNumber2);

		typedef CDcdTextbox CDcDrawCell;
		Ou<CDcDrawCell> pCDcDrawCell1;
		Ou<CDcDrawCell> pCDcDrawCell2;
		if (pCDcdGridCell1 != 0)
		{
			//(1.3.*.1)　セルの結合セルの属性を設定。

			pCDcdGridCell1->setAttachCellCount(2, 1);
			pCDcdGridCell2->setAttachCellCount(2, 1);

			//	(1.3.*.2)　セルのDcDrawオブジェクトの型を設定
			//	( CDcdTextbox とする)。
			{
				pCDcDrawCell1 = dynamic_castOu<CDcDrawCell>(
					pCDcdGridCell1->getIfDcDraw());
				pCDcDrawCell2 = dynamic_castOu<CDcDrawCell>(
					pCDcdGridCell2->getIfDcDraw());
				if (pCDcDrawCell1 == NULL)
				{
					pCDcDrawCell1 = OuNew<CDcDrawCell>(new CDcDrawCell);
					pCDcdGridCell1->setIfDcDraw(pCDcDrawCell1);
				}
				if (pCDcDrawCell2 == NULL)
				{
					pCDcDrawCell2 = OuNew<CDcDrawCell>(new CDcDrawCell);
					pCDcdGridCell2->setIfDcDraw(pCDcDrawCell2);
				}
			}
			//(1.3.*.3)　セルのDcDrawオブジェクトに、属性を設定。
			{
				*pCDcDrawCell1 = createCDcdEkimei();
				pCDcDrawCell1->setText(tstringOf(
					(LPCTSTR)MfcUtil::LoadCString(
						IDS_WORD_ShuchakuEkimei)));
				*pCDcDrawCell2 = createCDcdEkimei();
				pCDcDrawCell2->setText(tstringOf(
					(LPCTSTR)MfcUtil::LoadCString(
						IDS_WORD_Jikoku)));
			}
		}

		CDcdGridYColumn* pCDcdGridYColumn1 = pCDcdGrid->getYColumn(
			iYColumnNumber1);
		if (pCDcdGridYColumn1)
		{
			//(1.3.*.4)　Y列のセルの高さを設定
			{
				CdDcdSizeXy aCdDcdSizeXy;
				if (pCDcDrawCell1->getItemSize(
					&aCDcdTarget, &aCdDcdSizeXy))
				{
					pCDcdGridYColumn1->setColumnSize(
						aCdDcdSizeXy.getY());
				}
			}
			//	　(1.3.*.5)　Y列(ColumnType_Ressyabangou) の境界線の
			//	DcDrawオブジェクト に属性を設定。
			//	　(1.3.*.6)　Y列ColumnType_Ressyabangou) の境界線の
			//	高さを設定
			{
				CDcdGridYBorder* pCDcdGridYBorder1
					= pCDcdGridYColumn1->getCDcdGridYBorder();
				Ou<CDcdLine> pCDcdLine =
					pCDcdGridYBorder1->getIfDcDraw();
				pCDcdLine->setCdPenProp(getCdPenPropNullLine());


				// --------------------------------
				//	線の幅から、列幅を設定
				CdDcdSizeXy aCdDcdSizeXy;
				if (pCDcdLine->getItemSize(
					&aCDcdTarget, &aCdDcdSizeXy))
				{
					pCDcdGridYBorder1->setColumnBorderSize(
						aCdDcdSizeXy.getX());
				}
			}
		}

		CDcdGridYColumn* pCDcdGridYColumn2 = pCDcdGrid->getYColumn(
			iYColumnNumber2);
		if (pCDcdGridYColumn2)
		{
			//(1.3.*.4)　Y列のセルの高さを設定
			{
				CdDcdSizeXy aCdDcdSizeXy;
				if (pCDcDrawCell2->getItemSize(
					&aCDcdTarget, &aCdDcdSizeXy))
				{
					pCDcdGridYColumn2->setColumnSize(
						aCdDcdSizeXy.getY());
				}
			}
			//	　(1.3.*.5)　Y列(ColumnType_Ressyabangou) の境界線の
			//	DcDrawオブジェクト に属性を設定。
			//	　(1.3.*.6)　Y列ColumnType_Ressyabangou) の境界線の
			//	高さを設定
			{
				CDcdGridYBorder* pCDcdGridYBorder2
					= pCDcdGridYColumn2->getCDcdGridYBorder();
				Ou<CDcdLine> pCDcdLine =
					pCDcdGridYBorder2->getIfDcDraw();
				//pCDcdLine->setCdPenProp(getCdPenPropNarrowLine());
				pCDcdLine->setCdPenProp(getCdPenPropBoldLine());


				// --------------------------------
				//	線の幅から、列幅を設定
				CdDcdSizeXy aCdDcdSizeXy;
				if (pCDcdLine->getItemSize(
					&aCDcdTarget, &aCdDcdSizeXy))
				{
					pCDcdGridYBorder2->setColumnBorderSize(
						aCdDcdSizeXy.getX());
				}
			}
		}
	}
}

void CCellBuilderCustomize::update01_03_02_08_setEkimei_Bikou( 
		CWndJikokuhyou* pCWndJikokuhyou ) 
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid() ;
	CDcdTargetGetDC	aCDcdTarget( NULL ) ;
	// --------------------------------
	CdXColSpec aCdXColSpec( 
		CdXColSpec::ColumnType_Ekimei ) ;
	int iXColumnNumber = 
		m_CdXColSpecCont.ColumnNumberFromSpec( aCdXColSpec ) ;

	if ( iXColumnNumber >= 0 )
	{
		CdYColSpec aCdYColSpec( 
			CdYColSpec::ColumnType_Bikou ) ;
		int iYColumnNumber = m_CdYColSpecCont.ColumnNumberFromSpec( 
			aCdYColSpec , false ) ;
		CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell( 
			iXColumnNumber , iYColumnNumber ) ;

		typedef CDcdTextboxV3 CDcDrawCell ;
		Ou<CDcDrawCell> pCDcDrawCell ;
		if ( pCDcdGridCell != NULL )
		{
			//(1.3.*.1)　結合セルの属性を設定。
			pCDcdGridCell->setAttachCellCount( 2 , 1 ) ;

			//	(1.3.*.2)　セル(ColumnType_Ekimei,ColumnType_Ressyabangou) 
			//	のDcDrawオブジェクトの型を設定
			//	( CDcdTextbox とする)。
			{
				pCDcDrawCell = dynamic_castOu<CDcDrawCell>( 
					pCDcdGridCell->getIfDcDraw() ) ;
				if ( pCDcDrawCell == NULL )
				{
					pCDcDrawCell = OuNew<CDcDrawCell>( new CDcDrawCell ) ;
					pCDcdGridCell->setIfDcDraw( pCDcDrawCell ) ;
				}
			}
			//(1.3.*.3)　セル(ColumnType_Ekimei,ColumnType_Ressyabangou) 
			//	DcDrawオブジェクトに、属性を設定。
			{
				*pCDcDrawCell = createCDcdXColumn0V() ;
				pCDcDrawCell->setLinesExtentX ( getBikouTextExtent().getX() ) ;
				pCDcDrawCell->setLinesExtentY ( getBikouTextExtent().getY() ) ;
				pCDcDrawCell->setText( tstringOf( 
					(LPCTSTR)MfcUtil::LoadCString( 
					IDS_WORD_Bikou ) ) ) ;
			}
		}
		CDcdGridYColumn* pCDcdGridYColumn = pCDcdGrid->getYColumn( 
			iYColumnNumber ) ;
		if ( pCDcdGridYColumn != NULL )
		{
			//(1.3.*.4)　Y列 のセルの高さを設定
			{
				CdDcdSizeXy aCdDcdSizeXy ;
				if ( pCDcDrawCell->getItemSize( 
					&aCDcdTarget , &aCdDcdSizeXy ) )
				{
					pCDcdGridYColumn->setColumnSize( aCdDcdSizeXy.getY() ) ;
				}
			}
			//	　(1.3.*.5)　Y列 の境界線の
			//	DcDrawオブジェクト に属性を設定。
			//	　(1.3.*.6)　Y列 の境界線の
			//	高さを設定
			{
				CDcdGridYBorder* pCDcdGridYBorder 
					= pCDcdGridYColumn->getCDcdGridYBorder() ;
				Ou<CDcdLine> pCDcdLine = pCDcdGridYBorder->getIfDcDraw() ;
				pCDcdLine->setCdPenProp( getCdPenPropNullLine() ) ;

				CdDcdSizeXy aCdDcdSizeXy ;
				if ( pCDcdLine->getItemSize( 
					&aCDcdTarget , &aCdDcdSizeXy ) )
				{
					pCDcdGridYBorder->setColumnBorderSize( 
						aCdDcdSizeXy.getX() ) ;
				}
			}
		}
	}
}

void CCellBuilderCustomize::update01_04_01_06_setChakuhatsu_Chaku( 
		CWndJikokuhyou* pCWndJikokuhyou ) 
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid() ;
	CDcdTargetGetDC	aCDcdTarget( NULL ) ;

	// --------------------------------
	const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki = 
		m_pCDedRosenFileData->getCentDedRosen()->getCentDedEkiCont()->getMuPtr(
		m_pCentDedRessyaCont->getRessyahoukou() ) ;
	// --------------------------------
	CdXColSpec aCdXColSpec( 
		CdXColSpec::ColumnType_Chakuhatsu ) ;
	int iXColumnNumber = 
		m_CdXColSpecCont.ColumnNumberFromSpec( aCdXColSpec ) ;
	if ( iXColumnNumber >= 0 )
	{
		for ( int iEkiOrder = 0 ; iEkiOrder < muCdDedEki->size() ; 
			iEkiOrder ++ )
		{
			CentDedEkiCont::CdDedEki aCdDedEki = muCdDedEki->get( iEkiOrder ) ;

			CdYColSpec aCdYColSpec( 
				CdYColSpec::ColumnType_Ekijikoku_Chaku , 
				iEkiOrder ) ;
			int iYColumnNumber = 
				m_CdYColSpecCont.ColumnNumberFromSpec( aCdYColSpec , false ) ;
			CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell( 
				iXColumnNumber , iYColumnNumber ) ;

			typedef CDcdTextbox CDcDrawCell ;
			Ou<CDcDrawCell> pCDcDrawCell ;
			if ( pCDcdGridCell != 0 )
			{
				//(1.4.1.*.1)　セルの結合セルの属性を設定。
				pCDcdGridCell->setAttachCellCount( 1 , 1 ) ;
			
				//	(1.4.1.*.2)　セルのDcDrawオブジェクトの型を設定
				//	( CDcdTextbox とする)。
				{
					pCDcDrawCell = dynamic_castOu<CDcDrawCell>( 
						pCDcdGridCell->getIfDcDraw() ) ;
					if ( pCDcDrawCell == NULL )
					{
						pCDcDrawCell = OuNew<CDcDrawCell>( new CDcDrawCell ) ;
						pCDcdGridCell->setIfDcDraw( pCDcDrawCell ) ;
					}
				}
				//(1.4.1.*.3)　セルのDcDrawオブジェクトに、属性を設定。
				{
					*pCDcDrawCell = createCDcdHatsuchaku();
					pCDcDrawCell->setText( tstringOf( 
						(LPCTSTR)MfcUtil::LoadCString( 
						IDS_WORD_Chaku ) ) );
				}
			}
		}
	}
}

void CCellBuilderCustomize::update01_04_01_09_setChakuhatsu_Track(
	CWndJikokuhyou* pCWndJikokuhyou)
{
	//不要そうなので一旦コメントアウト
	//CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	//CDcdTargetGetDC	aCDcdTarget(NULL);

	//// --------------------------------
	//const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki =
	//	m_pCDedRosenFileData->getCentDedRosen()->getCentDedEkiCont()->getMuPtr(
	//		m_pCentDedRessyaCont->getRessyahoukou());
	//// --------------------------------
	//CdXColSpec aCdXColSpec(
	//	CdXColSpec::ColumnType_Chakuhatsu);
	//int iXColumnNumber =
	//	m_CdXColSpecCont.ColumnNumberFromSpec(aCdXColSpec);
	//if (iXColumnNumber >= 0)
	//{
	//	for (int iEkiOrder = 0; iEkiOrder < muCdDedEki->size();
	//		iEkiOrder++)
	//	{
	//		CentDedEkiCont::CdDedEki aCdDedEki = muCdDedEki->get(iEkiOrder);

	//		CdYColSpec aCdYColSpec(
	//			CdYColSpec::ColumnType_Track,
	//			iEkiOrder);
	//		int iYColumnNumber =
	//			m_CdYColSpecCont.ColumnNumberFromSpec(aCdYColSpec, false);
	//		CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell(
	//			iXColumnNumber, iYColumnNumber);

	//		typedef CDcdTextbox CDcDrawCell;
	//		Ou<CDcDrawCell> pCDcDrawCell;
	//		if (pCDcdGridCell != 0)
	//		{
	//			//(1.4.1.*.1)　セルの結合セルの属性を設定。
	//			pCDcdGridCell->setAttachCellCount(1, 1);

	//			//	(1.4.1.*.2)　セルのDcDrawオブジェクトの型を設定
	//			//	( CDcdTextbox とする)。
	//			{
	//				pCDcDrawCell = dynamic_castOu<CDcDrawCell>(
	//					pCDcdGridCell->getIfDcDraw());
	//				if (pCDcDrawCell == NULL)
	//				{
	//					pCDcDrawCell = OuNew<CDcDrawCell>(new CDcDrawCell);
	//					pCDcdGridCell->setIfDcDraw(pCDcDrawCell);
	//				}
	//			}
	//			//(1.4.1.*.3)　セルのDcDrawオブジェクトに、属性を設定。
	//			{
	//				*pCDcDrawCell = createCDcdHatsuchaku();
	//				if(m_bDisplayAllTrack)
	//				{
	//					pCDcDrawCell->setText(tstringOf(
	//						(LPCTSTR)MfcUtil::LoadCString(
	//							IDS_WORD_Track)));
	//				}
	//			}
	//		}
	//	}
	//}
}

void CCellBuilderCustomize::update01_04_01_07_setChakuhatsu_Hatsu( 
		CWndJikokuhyou* pCWndJikokuhyou ) 
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid() ;
	CDcdTargetGetDC	aCDcdTarget( NULL ) ;

	// --------------------------------
	const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki = 
		m_pCDedRosenFileData->getCentDedRosen()->getCentDedEkiCont()->getMuPtr(
		m_pCentDedRessyaCont->getRessyahoukou() ) ;
	// --------------------------------
	CdXColSpec aCdXColSpec( 
		CdXColSpec::ColumnType_Chakuhatsu ) ;
	int iXColumnNumber = 
		m_CdXColSpecCont.ColumnNumberFromSpec( aCdXColSpec ) ;
	if ( iXColumnNumber >= 0 )
	{
		for ( int iEkiOrder = 0 ; iEkiOrder < muCdDedEki->size() ; 
			iEkiOrder ++ )
		{
			CentDedEkiCont::CdDedEki aCdDedEki = muCdDedEki->get( iEkiOrder ) ;

			CdYColSpec aCdYColSpec( 
				CdYColSpec::ColumnType_Ekijikoku_Hatsu , 
				iEkiOrder ) ;
			int iYColumnNumber = 
				m_CdYColSpecCont.ColumnNumberFromSpec( aCdYColSpec , false ) ;
			CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell( 
				iXColumnNumber , iYColumnNumber ) ;

			typedef CDcdTextbox CDcDrawCell ;
			Ou<CDcDrawCell> pCDcDrawCell ;
			if ( pCDcdGridCell != 0 )
			{
				//(1.4.1.*.1)　セルの結合セルの属性を設定。
				pCDcdGridCell->setAttachCellCount( 1 , 1 ) ;
			
				//	(1.4.1.*.2)　セルのDcDrawオブジェクトの型を設定
				//	( CDcdTextbox とする)。
				{
					pCDcDrawCell = dynamic_castOu<CDcDrawCell>( 
						pCDcdGridCell->getIfDcDraw() ) ;
					if ( pCDcDrawCell == NULL )
					{
						pCDcDrawCell = OuNew<CDcDrawCell>( new CDcDrawCell ) ;
						pCDcdGridCell->setIfDcDraw( pCDcDrawCell ) ;
					}
				}
				//(1.4.1.*.3)　セルのDcDrawオブジェクトに、属性を設定。
				{
					*pCDcDrawCell = createCDcdHatsuchaku();
					pCDcDrawCell->setText( tstringOf( 
						(LPCTSTR)MfcUtil::LoadCString( 
						IDS_WORD_Hatsu ) ) );
				}
			}
		}
	}
}


void CCellBuilderCustomize::update02_02_updateRessya( 
		int iXColumnNumber ,
		const vector<int>& contCustomizeRessyaIndex,
		//const CentDedRessya* pCentDedRessya ,
		CWndJikokuhyou* pCWndJikokuhyou ) 
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid() ;
	CDcdTargetGetDC	aCDcdTarget( NULL ) ;

	int iRessyaIndex = 0;
	const CentDedRessya* pCentDedRessya;
	if (contCustomizeRessyaIndex.empty() || contCustomizeRessyaIndex[iRessyaIndex] < 0 ||
		contCustomizeRessyaIndex[iRessyaIndex] >= m_pCentDedRessyaCont->size())
	{
		CentDedRessya aRessya(m_pCentDedRessyaCont->createNullRessya());
		pCentDedRessya = &aRessya;
	}
	else
	{
		pCentDedRessya = m_pCentDedRessyaCont->getMuPtr()->get(contCustomizeRessyaIndex[iRessyaIndex]);
	}

	int iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();
	int iSyubetsuChangeEkiOrder = -1;
	int iConnectEkiOrder = -1;
	int iReleaseEkiOrder = -1;
	if (pCentDedRessya->getLastOperation().getAOperation() == CentDedAfterOperation::AOperation_Junction &&
		m_iEnableOperation > 0)
	{
		iConnectEkiOrder = pCentDedRessya->getLastOperation().getConnectEkiOrder();
	}
	if (pCentDedRessya->getFirstOperation().getBOperation() == CentDedBeforeOperation::BOperation_Junction &&
		m_iEnableOperation > 0)
	{
		iReleaseEkiOrder = pCentDedRessya->getFirstOperation().getReleaseEkiOrder();
	}
	const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki =
		m_pCDedRosenFileData->getCentDedRosen()->getCentDedEkiCont()->getMuPtr(
			pCentDedRessya->getRessyahoukou());
	for (int iYColumnNumber = 0; iYColumnNumber < m_CdYColSpecCont.size(); iYColumnNumber++)
	{
		CdYColSpec aCdYColSpec = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumber);

		switch (aCdYColSpec.getColumnType())
		{
			case CdYColSpec::ColumnType_Ressyabangou:
			{
				// ================================
				//　(2.2.1)　セル(ColumnType_Ressya ,
				//	ColumnType_Ressyabangou) を設定
				// ================================
				update02_02_01_setRessya_Ressyabangou(
					iXColumnNumber,
					iYColumnNumber,
					pCentDedRessya,
					pCWndJikokuhyou);
			}
			break;
			case CdYColSpec::ColumnType_OperationNumber:
			{
				// --------------------------------
				//	(2.2.2.12)セル(ColumnType_Ressya, ColumnType_OperationNumber)
				// --------------------------------
				update02_02_02_12_setRessya_OperationNumber(
					iXColumnNumber,
					iYColumnNumber,
					pCentDedRessya,
					pCWndJikokuhyou);
			}
			break;
			case CdYColSpec::ColumnType_Ressyasyubetsu:
			{
				// --------------------------------
				//	(2.2.2.2)セル(ColumnType_Ressya, ColumnType_Ressyasyubetsu)
				// --------------------------------
				update02_02_02_02_setRessya_Ressyasyubetsu(
					iXColumnNumber,
					iYColumnNumber,
					pCentDedRessya,
					pCWndJikokuhyou);
			}
			break;
			case CdYColSpec::ColumnType_Ressyamei:
			{
				// --------------------------------
				//	(2.2.2.3)セル(ColumnType_Ressya, ColumnType_Ressyamei)
				// --------------------------------
				update02_02_02_03_setRessya_Ressyamei(
					iXColumnNumber,
					iYColumnNumber,
					pCentDedRessya,
					pCWndJikokuhyou);
			}
			break;
			case CdYColSpec::ColumnType_Gousuu:
			{
				// --------------------------------
				//	(2.2.2.4)セル(ColumnType_Ressya, ColumnType_Gousuu)
				// --------------------------------
				update02_02_02_04_setRessya_Gousuu(
					iXColumnNumber,
					iYColumnNumber,
					pCentDedRessya,
					pCWndJikokuhyou);
			}
			break;
			case CdYColSpec::ColumnType_Gou:
			{
				// --------------------------------
				//	(2.2.2.5)セル(ColumnType_Ressya, ColumnType_Gou)
				// --------------------------------
				update02_02_02_05_setRessya_Gou(
					iXColumnNumber,
					iYColumnNumber,
					pCentDedRessya,
					pCWndJikokuhyou);
			}
			break;
			case CdYColSpec::ColumnType_ShihatsuEkimei:
			{
				// --------------------------------
				//	(2.2.2.13)セル(ColumnType_Ressya, ColumnType_ShihatsuEkimei)
				// --------------------------------
				update02_02_02_13_setRessya_ShihatsuEkimei(
					iXColumnNumber,
					iYColumnNumber,
					pCentDedRessya,
					pCWndJikokuhyou);
			}
			break;
			case CdYColSpec::ColumnType_ShuchakuEkimei:
			{
				// --------------------------------
				//	(2.2.2.14)セル(ColumnType_Ressya, ColumnType_ShuchakuEkimei)
				// --------------------------------
				update02_02_02_14_setRessya_ShuchakuEkimei(
					iXColumnNumber,
					iYColumnNumber,
					pCentDedRessya,
					pCWndJikokuhyou);
			}
			break;
			case CdYColSpec::ColumnType_Outer_Shihatsu1:
			{
				// --------------------------------
				//	(2.2.2.15)セル(ColumnType_Ressya, ColumnType_Outer_Shihatsu)
				// --------------------------------
				update02_02_02_15_setRessya_OuterTerminal_Shihatsu(
					iXColumnNumber,
					iYColumnNumber,
					pCentDedRessya,
					pCWndJikokuhyou);
				iYColumnNumber += 1;
			}
			break;
			case CdYColSpec::ColumnType_Ekijikoku_Chaku:
			{
				if (iRessyaIndex < (int)contCustomizeRessyaIndex.size() - 1 &&
					aCdYColSpec.getEkiOrder() > iValidSyuuchakuEki &&
					iValidSyuuchakuEki != -1)
				{
					iRessyaIndex++;
					pCentDedRessya =
						m_pCentDedRessyaCont->getMuPtr()->get(contCustomizeRessyaIndex[iRessyaIndex]);
					iSyubetsuChangeEkiOrder = iValidSyuuchakuEki;
					iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();

					if (pCentDedRessya->getLastOperation().getAOperation() == CentDedAfterOperation::AOperation_Junction &&
						m_iEnableOperation > 0)
					{
						iConnectEkiOrder = pCentDedRessya->getLastOperation().getConnectEkiOrder();
					}
					iReleaseEkiOrder = -1;
				}
				update02_02_02_06_setRessya_Chaku(
					iXColumnNumber,
					iYColumnNumber,
					pCentDedRessya,
					aCdYColSpec.getEkiOrder(),
					iSyubetsuChangeEkiOrder,
					iConnectEkiOrder,
					iReleaseEkiOrder,
					pCWndJikokuhyou);
			}
			break;
			case CdYColSpec::ColumnType_Track:
			{
				if (iRessyaIndex < (int)contCustomizeRessyaIndex.size() - 1 &&
					aCdYColSpec.getEkiOrder() > iValidSyuuchakuEki &&
					iValidSyuuchakuEki != -1)
				{
					iRessyaIndex++;
					pCentDedRessya =
						m_pCentDedRessyaCont->getMuPtr()->get(contCustomizeRessyaIndex[iRessyaIndex]);
					iSyubetsuChangeEkiOrder = iValidSyuuchakuEki;
					iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();

					if (pCentDedRessya->getLastOperation().getAOperation() == CentDedAfterOperation::AOperation_Junction &&
						m_iEnableOperation > 0)
					{
						iConnectEkiOrder = pCentDedRessya->getLastOperation().getConnectEkiOrder();
					}
					iReleaseEkiOrder = -1;
				}
				update02_02_02_09_setRessya_Track(
					iXColumnNumber,
					iYColumnNumber,
					pCentDedRessya,
					aCdYColSpec.getEkiOrder(),
					iSyubetsuChangeEkiOrder,
					iConnectEkiOrder,
					iReleaseEkiOrder,
					pCWndJikokuhyou);
			}
			break;
			case CdYColSpec::ColumnType_EkiRessyabangou:
			{
				if (iRessyaIndex < (int)contCustomizeRessyaIndex.size() - 1 &&
					aCdYColSpec.getEkiOrder() >= iValidSyuuchakuEki &&
					iValidSyuuchakuEki != -1)
				{
					iRessyaIndex++;
					pCentDedRessya =
						m_pCentDedRessyaCont->getMuPtr()->get(contCustomizeRessyaIndex[iRessyaIndex]);
					iSyubetsuChangeEkiOrder = iValidSyuuchakuEki;
					iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();

					if (pCentDedRessya->getLastOperation().getAOperation() == CentDedAfterOperation::AOperation_Junction &&
						m_iEnableOperation > 0)
					{
						iConnectEkiOrder = pCentDedRessya->getLastOperation().getConnectEkiOrder();
					}
					iReleaseEkiOrder = -1;
				}
				update02_02_02_19_setRessya_Ressyabangou(
					iXColumnNumber,
					iYColumnNumber,
					pCentDedRessya,
					aCdYColSpec.getEkiOrder(),
					iSyubetsuChangeEkiOrder,
					iConnectEkiOrder,
					iReleaseEkiOrder,
					pCWndJikokuhyou);
			}
			break;
			case CdYColSpec::ColumnType_EkiOperationNumber:
			{
				if (iRessyaIndex < (int)contCustomizeRessyaIndex.size() - 1 &&
					aCdYColSpec.getEkiOrder() >= iValidSyuuchakuEki &&
					iValidSyuuchakuEki != -1)
				{
					iRessyaIndex++;
					pCentDedRessya =
						m_pCentDedRessyaCont->getMuPtr()->get(contCustomizeRessyaIndex[iRessyaIndex]);
					iSyubetsuChangeEkiOrder = iValidSyuuchakuEki;
					iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();

					if (pCentDedRessya->getLastOperation().getAOperation() == CentDedAfterOperation::AOperation_Junction &&
						m_iEnableOperation > 0)
					{
						iConnectEkiOrder = pCentDedRessya->getLastOperation().getConnectEkiOrder();
					}
					iReleaseEkiOrder = -1;
				}
				update02_02_02_20_setRessya_OperationNumber(
					iXColumnNumber,
					iYColumnNumber,
					pCentDedRessya,
					aCdYColSpec.getEkiOrder(),
					iSyubetsuChangeEkiOrder,
					iConnectEkiOrder,
					iReleaseEkiOrder,
					pCWndJikokuhyou);
			}
			break;
			case CdYColSpec::ColumnType_EkiRessyasyubetsu:
			{
				if (iRessyaIndex < (int)contCustomizeRessyaIndex.size() - 1 &&
					aCdYColSpec.getEkiOrder() >= iValidSyuuchakuEki &&
					iValidSyuuchakuEki != -1)
				{
					iRessyaIndex++;
					pCentDedRessya =
						m_pCentDedRessyaCont->getMuPtr()->get(contCustomizeRessyaIndex[iRessyaIndex]);
					iSyubetsuChangeEkiOrder = iValidSyuuchakuEki;
					iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();

					if (pCentDedRessya->getLastOperation().getAOperation() == CentDedAfterOperation::AOperation_Junction &&
						m_iEnableOperation > 0)
					{
						iConnectEkiOrder = pCentDedRessya->getLastOperation().getConnectEkiOrder();
					}
					iReleaseEkiOrder = -1;
				}
				update02_02_02_21_setRessya_Ressyasyubetsu(
					iXColumnNumber,
					iYColumnNumber,
					pCentDedRessya,
					aCdYColSpec.getEkiOrder(),
					iSyubetsuChangeEkiOrder,
					iConnectEkiOrder,
					iReleaseEkiOrder,
					pCWndJikokuhyou);
			}
			break;
			case CdYColSpec::ColumnType_EkiRessyamei:
			{
				if (iRessyaIndex < (int)contCustomizeRessyaIndex.size() - 1 &&
					aCdYColSpec.getEkiOrder() >= iValidSyuuchakuEki &&
					iValidSyuuchakuEki != -1)
				{
					iRessyaIndex++;
					pCentDedRessya =
						m_pCentDedRessyaCont->getMuPtr()->get(contCustomizeRessyaIndex[iRessyaIndex]);
					iSyubetsuChangeEkiOrder = iValidSyuuchakuEki;
					iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();

					if (pCentDedRessya->getLastOperation().getAOperation() == CentDedAfterOperation::AOperation_Junction &&
						m_iEnableOperation > 0)
					{
						iConnectEkiOrder = pCentDedRessya->getLastOperation().getConnectEkiOrder();
					}
					iReleaseEkiOrder = -1;
				}
				update02_02_02_22_setRessya_Ressyamei(
					iXColumnNumber,
					iYColumnNumber,
					pCentDedRessya,
					aCdYColSpec.getEkiOrder(),
					iSyubetsuChangeEkiOrder,
					iConnectEkiOrder,
					iReleaseEkiOrder,
					pCWndJikokuhyou);
			}
			break;
			case CdYColSpec::ColumnType_EkiGousuu:
			{
				if (iRessyaIndex < (int)contCustomizeRessyaIndex.size() - 1 &&
					aCdYColSpec.getEkiOrder() >= iValidSyuuchakuEki &&
					iValidSyuuchakuEki != -1)
				{
					iRessyaIndex++;
					pCentDedRessya =
						m_pCentDedRessyaCont->getMuPtr()->get(contCustomizeRessyaIndex[iRessyaIndex]);
					iSyubetsuChangeEkiOrder = iValidSyuuchakuEki;
					iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();

					if (pCentDedRessya->getLastOperation().getAOperation() == CentDedAfterOperation::AOperation_Junction &&
						m_iEnableOperation > 0)
					{
						iConnectEkiOrder = pCentDedRessya->getLastOperation().getConnectEkiOrder();
					}
					iReleaseEkiOrder = -1;
				}
				update02_02_02_23_setRessya_Gousuu(
					iXColumnNumber,
					iYColumnNumber,
					pCentDedRessya,
					aCdYColSpec.getEkiOrder(),
					iSyubetsuChangeEkiOrder,
					iConnectEkiOrder,
					iReleaseEkiOrder,
					pCWndJikokuhyou);
			}
			break;
			case CdYColSpec::ColumnType_EkiGou:
			{
				if (iRessyaIndex < (int)contCustomizeRessyaIndex.size() - 1 &&
					aCdYColSpec.getEkiOrder() >= iValidSyuuchakuEki &&
					iValidSyuuchakuEki != -1)
				{
					iRessyaIndex++;
					pCentDedRessya =
						m_pCentDedRessyaCont->getMuPtr()->get(contCustomizeRessyaIndex[iRessyaIndex]);
					iSyubetsuChangeEkiOrder = iValidSyuuchakuEki;
					iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();

					if (pCentDedRessya->getLastOperation().getAOperation() == CentDedAfterOperation::AOperation_Junction &&
						m_iEnableOperation > 0)
					{
						iConnectEkiOrder = pCentDedRessya->getLastOperation().getConnectEkiOrder();
					}
					iReleaseEkiOrder = -1;
				}
				update02_02_02_24_setRessya_Gou(
					iXColumnNumber,
					iYColumnNumber,
					pCentDedRessya,
					aCdYColSpec.getEkiOrder(),
					iSyubetsuChangeEkiOrder,
					iConnectEkiOrder,
					iReleaseEkiOrder,
					pCWndJikokuhyou);
			}
			break;
			case CdYColSpec::ColumnType_Ekijikoku_Hatsu:
			{
				if (iRessyaIndex < (int)contCustomizeRessyaIndex.size() - 1 &&
					aCdYColSpec.getEkiOrder() >= iValidSyuuchakuEki &&
					iValidSyuuchakuEki != -1)
				{
					iRessyaIndex++;
					pCentDedRessya =
						m_pCentDedRessyaCont->getMuPtr()->get(contCustomizeRessyaIndex[iRessyaIndex]);
					iSyubetsuChangeEkiOrder = iValidSyuuchakuEki;
					iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();

					if (pCentDedRessya->getLastOperation().getAOperation() == CentDedAfterOperation::AOperation_Junction &&
						m_iEnableOperation > 0)
					{
						iConnectEkiOrder = pCentDedRessya->getLastOperation().getConnectEkiOrder();
					}
					iReleaseEkiOrder = -1;
				}
				update02_02_02_07_setRessya_Hatsu(
					iXColumnNumber,
					iYColumnNumber,
					pCentDedRessya,
					aCdYColSpec.getEkiOrder(),
					iSyubetsuChangeEkiOrder,
					iConnectEkiOrder,
					iReleaseEkiOrder,
					pCWndJikokuhyou);
			}
			break;
			case CdYColSpec::ColumnType_Outer_Shuchaku1:
			{
				// --------------------------------
				//	(2.2.2.16)セル(ColumnType_Ressya, ColumnType_Outer_Shuchaku)
				// --------------------------------
				update02_02_02_16_setRessya_OuterTerminal_Shuchaku(
					iXColumnNumber,
					iYColumnNumber,
					pCentDedRessya,
					pCWndJikokuhyou);
				iYColumnNumber += 1;
			}
			break;
			case CdYColSpec::ColumnType_Bikou:
			{
				// --------------------------------
				//	(2.2.2.8)セル(ColumnType_Ressya,ColumnType_Bikou)
				// --------------------------------
				update02_02_02_08_setRessya_Bikou(
					iXColumnNumber,
					iYColumnNumber,
					pCentDedRessya,
					pCWndJikokuhyou);
			}
			break;
		}
	}
	//種別変更が行われた場合は、終着駅名欄を修正する。pCentDedRessyaは、ここまでくれば末尾になっているはずなので、そのまま渡す
	if ((int)contCustomizeRessyaIndex.size() > 1)
	{
		int iYColumnNumber = m_CdYColSpecCont.ColumnNumberFromSpec(
			CdYColSpec(CdYColSpec::ColumnType_ShuchakuEkimei),false);
		if (iYColumnNumber >= 0)
		{
			// --------------------------------
			//	(2.2.2.14)セル(ColumnType_Ressya, ColumnType_ShuchakuEkimei)
			// --------------------------------
			update02_02_02_14_setRessya_ShuchakuEkimei(
				iXColumnNumber,
				iYColumnNumber,
				pCentDedRessya,
				pCWndJikokuhyou);
		}
	}

	// ================================
	//　(2.2.3)　X列(ColumnType_Ressya ) の幅を設定。
	//	幅は、駅時刻列の DcDraw オブジェクトの幅とします。
	// ================================
	CDcdGridXColumn* pCDcdGridXColumn 
		= pCDcdGrid->getXColumn( iXColumnNumber ) ;
	{
		{
			CDcdGridCell* pCDcdGridCell 
				= pCDcdGrid->getCell( iXColumnNumber , 0 ) ;
			CdDcdSizeXy	aCdDcdSizeXy ;
			if ( pCDcdGridCell->getIfDcDraw()->getItemSize( 
					&aCDcdTarget , &aCdDcdSizeXy ) ){
				pCDcdGridXColumn->setColumnSize( aCdDcdSizeXy.getX() ) ;
			}
		}
	}

	// ================================
	//　(2.2.4)　X列(ColumnType_Ressya ) の境界線の 
	//	DcDrawオブジェクトの属性を設定。
	//　(2.2.5)　X列(ColumnType_Ressya ) の境界線の幅を設定。
	// ================================
	{
		CDcdGridXBorder* pCDcdGridXBorder 
			= pCDcdGridXColumn->getCDcdGridXBorder() ;
		Ou<CDcdLine> pCDcdLine = pCDcdGridXBorder->getIfDcDraw() ;

		pCDcdLine->setCdPenProp( getCdPenPropNarrowLine() ) ;

		CdDcdSizeXy aCdDcdSizeXy ;
		if ( pCDcdLine->getItemSize( &aCDcdTarget , &aCdDcdSizeXy ) )
		{
			pCDcdGridXBorder->setColumnBorderSize( aCdDcdSizeXy.getX() ) ;
		}
	}
	// ================================
	//	X列を再描画領域とします。
	// ================================
	{
		CdDcdZoneXy	aCdDcdZoneXy ;
		//X列の範囲
		{
			CdDcdZone	zoneXColumnZone = pCDcdGrid->getXColumnZone( 
				&aCDcdTarget , 
				iXColumnNumber ) ;
			CdDcdZone	zoneXColumnBorderZone = pCDcdGrid->getXColumnBorderZone( 
				&aCDcdTarget , 
				iXColumnNumber ) ;
			
			aCdDcdZoneXy.setX( 
				zoneXColumnZone.ZoneOr( zoneXColumnBorderZone ) ) ;
		}
		//Y列の範囲
		{
			CdDcdZone	zoneYColumnTop = pCDcdGrid->getYColumnZone( 
				&aCDcdTarget , 
				0 ) ;
			CdDcdZone	zoneYColumnBottom = pCDcdGrid->getYColumnZone( 
				&aCDcdTarget , 
				INT_MAX ) ;
			aCdDcdZoneXy.setY( 
				zoneYColumnTop.ZoneOr( zoneYColumnBottom ) ) ;
		}
		CConverter_WinGdi	aConv ;
		pCWndJikokuhyou->InvalidateRect( 
			&aConv.RECTOf( aCdDcdZoneXy ) ) ; 
	}
}

void CCellBuilderCustomize::update02_02_01_setRessya_Ressyabangou( 
	int iXColumnNumber ,
	int iYColumnNumber,
	const CentDedRessya* pCentDedRessya ,
	CWndJikokuhyou* pCWndJikokuhyou ) 
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid() ;
	//CDcdTargetGetDC	aCDcdTarget( NULL ) ;
	// --------------------------------
	//CdYColSpec aCdYColSpec( 
	//	CdYColSpec::ColumnType_Ressyabangou ) ;
	//int iYColumnNumber = 
	//	m_CdYColSpecCont.ColumnNumberFromSpec( aCdYColSpec , false ) ;
	CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell( 
		iXColumnNumber , iYColumnNumber ) ;
	// --------------------------------
	//CdDedDispProp	aCdDedDispProp = m_pCDedRosenFileData->getCdDedDispProp() ;
	//tstring strCellExtent( aCdDedDispProp.getJikokuhyouRessyaWidth() , '0' ) ;
	//strCellExtent = セルの大きさの目安となる文字列です。
	//	時刻表列車セルの幅(文字数) CdDedDispProp::m_iJikokuhyouRessyaWidth
	//	の数だけ '0' が並んだ文字列です

	if ( pCDcdGridCell != 0 )
	{
		typedef CDcdTextbox CDcDrawCell ;
		Ou<CDcDrawCell> pCDcDrawCell ;
		// --------------------------------
		//　(2.2.*.1)　セル(ColumnType_Ressya,ColumnType_Ressyabangou) の
		//	結合セルを設定
		pCDcdGridCell->setAttachCellCount( 1 , 1 ) ;

		//　(2.2.*.2)　セル の	DcDrawオブジェクトの型を設定
		//	( CDcdTextbox とする)。
		{
			pCDcDrawCell = dynamic_castOu<CDcDrawCell>( 
				pCDcdGridCell->getIfDcDraw() ) ;
			if ( pCDcDrawCell == NULL )
			{
				pCDcDrawCell = OuNew<CDcDrawCell>( new CDcDrawCell ) ;
				pCDcdGridCell->setIfDcDraw( pCDcDrawCell ) ;
			}
		}

		//　(2.2.*.3)　セルの DcDrawオブジェクトに、属性を設定。
		{
			int idxRessyasyubetsu 
					= pCentDedRessya->getRessyasyubetsuIndex() ;
			tstring strText = pCentDedRessya->getRessyabangou() ;
			
			*pCDcDrawCell = createCDcdRessyabangou( idxRessyasyubetsu ) ;
			pCDcDrawCell->setText( strText );
		}

		//セルの背景色を指定します。
		{
			pCDcDrawCell->setCdBrushProp(CdColorProp(255, 255, 255));
		}
	}
}

void CCellBuilderCustomize::update02_02_02_12_setRessya_OperationNumber(
	int iXColumnNumber,
	int iYColumnNumber,
	const CentDedRessya * pCentDedRessya, 
	CWndJikokuhyou * pCWndJikokuhyou)
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	//CDcdTargetGetDC	aCDcdTarget(NULL);
	// --------------------------------
	//CdYColSpec aCdYColSpec(
	//	CdYColSpec::ColumnType_OperationNumber);
	//int iYColumnNumber =
	//	m_CdYColSpecCont.ColumnNumberFromSpec(aCdYColSpec, false);
	CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell(
		iXColumnNumber, iYColumnNumber);
	// --------------------------------
	if (pCDcdGridCell != 0)
	{
		typedef CDcdTextbox CDcDrawCell;
		Ou<CDcDrawCell> pCDcDrawCell;
		// --------------------------------
		//　(2.2.*.1)　セル(ColumnType_Ressya,ColumnType_Ressyabangou) の
		//	結合セルを設定
		pCDcdGridCell->setAttachCellCount(1, 1);

		//　(2.2.*.2)　セル の	DcDrawオブジェクトの型を設定
		//	( CDcdTextbox とする)。
		{
			pCDcDrawCell = dynamic_castOu<CDcDrawCell>(
				pCDcdGridCell->getIfDcDraw());
			if (pCDcDrawCell == NULL)
			{
				pCDcDrawCell = OuNew<CDcDrawCell>(new CDcDrawCell);
				pCDcdGridCell->setIfDcDraw(pCDcDrawCell);
			}
		}

		//　(2.2.*.3)　セルの DcDrawオブジェクトに、属性を設定。
		{
			int idxRessyasyubetsu
				= pCentDedRessya->getRessyasyubetsuIndex();
			//const CentDedRessyasyubetsu* pCentDedRessyasyubetsu = NULL;
			//{
			//	pCentDedRessyasyubetsu =
			//		pCentDedRosen->getCentDedRessyasyubetsuCont()->getMuPtr()
			//		->get(idxRessyasyubetsu);
			//	if (pCentDedRessyasyubetsu == NULL)
			//	{
			//		pCentDedRessyasyubetsu =
			//			pCentDedRosen->getCentDedRessyasyubetsuCont()
			//			->getMuPtr()->get(0);
			//	}
			//}
			//pCentDedRessyasyubetsu = 列車種別オブジェクト
			//	(指定がないなら、列車種別[0])
			tstring strText = joinc('+', pCentDedRessya->getOperationNumber(
				pCentDedRessya->getValidSihatsuEki()));

			*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
			pCDcDrawCell->setText(strText);
		}

		//セルの背景色を指定します。
		{
			pCDcDrawCell->setCdBrushProp(CdColorProp(255, 255, 255));
		}
	}
}


void CCellBuilderCustomize::update02_02_02_02_setRessya_Ressyasyubetsu( 
	int iXColumnNumber ,
	int iYColumnNumber,
	const CentDedRessya* pCentDedRessya ,
	CWndJikokuhyou* pCWndJikokuhyou ) 
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid() ;
	const CentDedRosen* pCentDedRosen = 
		m_pCDedRosenFileData->getCentDedRosen() ;
	// --------------------------------
	//CDcdTargetGetDC	aCDcdTarget( NULL ) ;
	// --------------------------------
	//CdYColSpec aCdYColSpec( 
	//	CdYColSpec::ColumnType_Ressyasyubetsu ) ;
	//int iYColumnNumber = 
	//	m_CdYColSpecCont.ColumnNumberFromSpec( aCdYColSpec , false ) ;
	CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell( 
		iXColumnNumber , iYColumnNumber ) ;
	// --------------------------------
	if ( pCDcdGridCell != 0 )
	{
		typedef CDcdTextbox CDcDrawCell ;
		Ou<CDcDrawCell> pCDcDrawCell ;
		// --------------------------------
		//　(2.2.*.1)　セル(ColumnType_Ressya,ColumnType_Ressyabangou) の
		//	結合セルを設定
		pCDcdGridCell->setAttachCellCount( 1 , 1 ) ;

		//　(2.2.*.2)　セル の	DcDrawオブジェクトの型を設定
		//	( CDcdTextbox とする)。
		{
			pCDcDrawCell = dynamic_castOu<CDcDrawCell>( 
				pCDcdGridCell->getIfDcDraw() ) ;
			if ( pCDcDrawCell == NULL )
			{
				pCDcDrawCell = OuNew<CDcDrawCell>( new CDcDrawCell ) ;
				pCDcdGridCell->setIfDcDraw( pCDcDrawCell ) ;
			}
		}

		//　(2.2.*.3)　セルの DcDrawオブジェクトに、属性を設定。
		{
			int idxRessyasyubetsu 
				= pCentDedRessya->getRessyasyubetsuIndex() ;
			const CentDedRessyasyubetsu* pCentDedRessyasyubetsu = NULL ;
			{
				pCentDedRessyasyubetsu = 
					pCentDedRosen->getCentDedRessyasyubetsuCont()->getMuPtr()
						->get( idxRessyasyubetsu ) ;
				if (m_bDisplayParentSyubetsu && pCentDedRessyasyubetsu->getParentSyubetsuIndex() >= 0)
				{
					pCentDedRessyasyubetsu
						= pCentDedRosen->getCentDedRessyasyubetsuCont()->getMuPtr()
						->get(pCentDedRessyasyubetsu->getParentSyubetsuIndex());
				}
				if ( pCentDedRessyasyubetsu == NULL )
				{
					pCentDedRessyasyubetsu = 
						pCentDedRosen->getCentDedRessyasyubetsuCont()
						->getMuPtr()->get( 0 ) ;
				}
			}
			//pCentDedRessyasyubetsu = 列車種別オブジェクト
			//	(指定がないなら、列車種別[0])

			tstring strText ;
			if ( !pCentDedRessya->isNull() )
			{
				strText = pCentDedRessyasyubetsu->getRyakusyou() ;
			}
			*pCDcDrawCell = createCDcdEkijikoku( idxRessyasyubetsu );
			pCDcDrawCell->setText( strText );
		}

		//セルの背景色を指定します。
		{
			pCDcDrawCell->setCdBrushProp(CdColorProp(255, 255, 255));
		}
	}

}
	
void CCellBuilderCustomize::update02_02_02_03_setRessya_Ressyamei( 
	int iXColumnNumber ,
	int iYColumnNumber,
	const CentDedRessya* pCentDedRessya ,
	CWndJikokuhyou* pCWndJikokuhyou ) 
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid() ;
	//const CentDedRosen* pCentDedRosen = 
	//	m_pCDedRosenFileData->getCentDedRosen() ;
	// --------------------------------
	//CDcdTargetGetDC	aCDcdTarget( NULL ) ;
	// --------------------------------
	//CdYColSpec aCdYColSpec( 
	//	CdYColSpec::ColumnType_Ressyamei ) ;
	//int iYColumnNumber = 
	//	m_CdYColSpecCont.ColumnNumberFromSpec( aCdYColSpec , false ) ;
	CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell( 
		iXColumnNumber , iYColumnNumber ) ;
	// --------------------------------
	if ( pCDcdGridCell != 0 )
	{
		typedef CDcdTextboxV3 CDcDrawCell ;
		Ou<CDcDrawCell> pCDcDrawCell ;
		// --------------------------------
		//　(2.2.*.1)　セル(ColumnType_Ressya,ColumnType_Ressyabangou) の
		//	結合セルを設定
		pCDcdGridCell->setAttachCellCount( 1 , 1 ) ;

		//　(2.2.*.2)　セル の	DcDrawオブジェクトの型を設定
		//	( CDcdTextbox とする)。
		{
			pCDcDrawCell = dynamic_castOu<CDcDrawCell>( 
				pCDcdGridCell->getIfDcDraw() ) ;
			if ( pCDcDrawCell == NULL )
			{
				pCDcDrawCell = OuNew<CDcDrawCell>( new CDcDrawCell ) ;
				pCDcdGridCell->setIfDcDraw( pCDcDrawCell ) ;
			}
		}
		//　(2.2.*.3)　セルの DcDrawオブジェクトに、属性を設定。
		{
			int idxRessyasyubetsu 
				= pCentDedRessya->getRessyasyubetsuIndex() ;
			tstring strText ;
			if ( !pCentDedRessya->isNull() )
			{
				strText = pCentDedRessya->getRessyamei() ;
			}
			*pCDcDrawCell = createCDcdRessyamei( idxRessyasyubetsu );
			pCDcDrawCell->setText( strText );
		}

		//セルの背景色を指定します。
		{
			pCDcDrawCell->setCdBrushProp(CdColorProp(255, 255, 255));
		}
	}


}
	
void CCellBuilderCustomize::update02_02_02_04_setRessya_Gousuu( 
	int iXColumnNumber ,
	int iYColumnNumber,
	const CentDedRessya* pCentDedRessya ,
	CWndJikokuhyou* pCWndJikokuhyou ) 
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid() ;
	//const CentDedRosen* pCentDedRosen = 
	//	m_pCDedRosenFileData->getCentDedRosen() ;
	// --------------------------------
	//CDcdTargetGetDC	aCDcdTarget( NULL ) ;
	// --------------------------------
	//CdYColSpec aCdYColSpec( 
	//	CdYColSpec::ColumnType_Gousuu ) ;
	//int iYColumnNumber = 
	//	m_CdYColSpecCont.ColumnNumberFromSpec( aCdYColSpec , false ) ;
	CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell( 
		iXColumnNumber , iYColumnNumber ) ;
	// --------------------------------
	if ( pCDcdGridCell != 0 )
	{
		typedef CDcdTextbox CDcDrawCell ;
		Ou<CDcDrawCell> pCDcDrawCell ;
		// --------------------------------
		//　(2.2.*.1)　セル(ColumnType_Ressya,ColumnType_Ressyabangou) の
		//	結合セルを設定
		pCDcdGridCell->setAttachCellCount( 1 , 1 ) ;

		//　(2.2.*.2)　セル の	DcDrawオブジェクトの型を設定
		//	( CDcdTextbox とする)。
		{
			pCDcDrawCell = dynamic_castOu<CDcDrawCell>( 
				pCDcdGridCell->getIfDcDraw() ) ;
			if ( pCDcDrawCell == NULL )
			{
				pCDcDrawCell = OuNew<CDcDrawCell>( new CDcDrawCell ) ;
				pCDcdGridCell->setIfDcDraw( pCDcDrawCell ) ;
			}
		}
		//　(2.2.*.3)　セルの DcDrawオブジェクトに、属性を設定。
		{
			int idxRessyasyubetsu 
				= pCentDedRessya->getRessyasyubetsuIndex() ;
			tstring strText = pCentDedRessya->getGousuu() ;
			*pCDcDrawCell = createCDcdRessyabangou( idxRessyasyubetsu );
			pCDcDrawCell->setText( strText );
		}

		//セルの背景色を指定します。
		{
			pCDcDrawCell->setCdBrushProp(CdColorProp(255, 255, 255));
		}
	}
}
	
void CCellBuilderCustomize::update02_02_02_05_setRessya_Gou( 
	int iXColumnNumber ,
	int iYColumnNumber,
	const CentDedRessya* pCentDedRessya ,
	CWndJikokuhyou* pCWndJikokuhyou ) 
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid() ;
	//const CentDedRosen* pCentDedRosen = 
	//	m_pCDedRosenFileData->getCentDedRosen() ;
	// --------------------------------
	//CDcdTargetGetDC	aCDcdTarget( NULL ) ;
	// --------------------------------
	//CdYColSpec aCdYColSpec( 
	//	CdYColSpec::ColumnType_Gou ) ;
	//int iYColumnNumber = 
	//	m_CdYColSpecCont.ColumnNumberFromSpec( aCdYColSpec , false ) ;
	CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell( 
		iXColumnNumber , iYColumnNumber ) ;
	// --------------------------------
	if ( pCDcdGridCell != 0 )
	{
		typedef CDcdTextbox CDcDrawCell ;
		Ou<CDcDrawCell> pCDcDrawCell ;
		// --------------------------------
		//　(2.2.*.1)　セルの結合セルを設定
		pCDcdGridCell->setAttachCellCount( 1 , 1 ) ;

		//　(2.2.*.2)　セル の	DcDrawオブジェクトの型を設定
		//	( CDcdTextbox とする)。
		{
			pCDcDrawCell = dynamic_castOu<CDcDrawCell>( 
				pCDcdGridCell->getIfDcDraw() ) ;
			if ( pCDcDrawCell == NULL )
			{
				pCDcDrawCell = OuNew<CDcDrawCell>( new CDcDrawCell ) ;
				pCDcdGridCell->setIfDcDraw( pCDcDrawCell ) ;
			}
		}
		//　(2.2.*.3)　セルの DcDrawオブジェクトに、属性を設定。
		{
			int idxRessyasyubetsu 
				= pCentDedRessya->getRessyasyubetsuIndex() ;

			CString	strText ;
			if ( !pCentDedRessya->getGousuu().empty() )
			{
				strText.LoadString( IDS_WORD_GOUSUU2 ) ;
			}

			*pCDcDrawCell = createCDcdRessyabangou( idxRessyasyubetsu );
			pCDcDrawCell->setText( (LPCTSTR)strText );
		}

		//セルの背景色を指定します。
		{
			pCDcDrawCell->setCdBrushProp(CdColorProp(255, 255, 255));
		}
	}
}

void CCellBuilderCustomize::update02_02_02_13_setRessya_ShihatsuEkimei(
	int iXColumnNumber,
	int iYColumnNumber,
	const CentDedRessya * pCentDedRessya,
	CWndJikokuhyou * pCWndJikokuhyou)
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	const CentDedRosen* pCentDedRosen =
		m_pCDedRosenFileData->getCentDedRosen();
	const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki =
		pCentDedRosen->getCentDedEkiCont()->getMuPtr(
			pCentDedRessya->getRessyahoukou());
	// --------------------------------
	//CDcdTargetGetDC	aCDcdTarget(NULL);
	// --------------------------------
	{
		//CdYColSpec aCdYColSpec(
		//	CdYColSpec::ColumnType_ShihatsuEkimei);
		//int iYColumnNumber =
		//	m_CdYColSpecCont.ColumnNumberFromSpec(aCdYColSpec, false);
		CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell(
			iXColumnNumber, iYColumnNumber);
		// --------------------------------
		if (pCDcdGridCell != 0)
		{
			typedef CDcdTextbox CDcDrawCell;
			Ou<CDcDrawCell> pCDcDrawCell;
			// --------------------------------
			//　(2.2.*.1)　セルの結合セルを設定
			pCDcdGridCell->setAttachCellCount(1, 1);

			//　(2.2.*.2)　セル の	DcDrawオブジェクトの型を設定
			//	( CDcdTextbox とする)。
			{
				pCDcDrawCell = dynamic_castOu<CDcDrawCell>(
					pCDcdGridCell->getIfDcDraw());
				if (pCDcDrawCell == NULL)
				{
					pCDcDrawCell = OuNew<CDcDrawCell>(new CDcDrawCell);
					pCDcdGridCell->setIfDcDraw(pCDcDrawCell);
				}
			}
			//　(2.2.*.3)　セルの DcDrawオブジェクトに、属性を設定。
			{
				//pCDcDrawCell->setText("");
				pCDcDrawCell->setCdDrawTextProp(getCdDrawTextPropOperation());
				tstring strText;
				if (pCentDedRessya->getValidSihatsuEki()!= -1)
				{
					if (pCentDedRessya->getFirstOperation().getBOperation() == CentDedBeforeOperation::BOperation_Outer)
					{
						strText = muCdDedEki->get(pCentDedRessya->getValidSihatsuEki()).getOuterTerminalJikokuRyaku(
							pCentDedRessya->getFirstOperation().getOuterShihatsuekiIndex(),true);
					}
					else
					{
						strText = muCdDedEki->get(pCentDedRessya->getValidSihatsuEki()).getEkimeiJikokuhyouRyaku(true);
					}
				}
				pCDcDrawCell->setText(strText);
			}

			//セルの背景色を指定します。
			{
				pCDcDrawCell->setCdBrushProp(CdColorProp(255, 255, 255));
			}
		}
	}
}

void CCellBuilderCustomize::update02_02_02_14_setRessya_ShuchakuEkimei(
	int iXColumnNumber,
	int iYColumnNumber,
	const CentDedRessya * pCentDedRessya,
	CWndJikokuhyou * pCWndJikokuhyou)
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	const CentDedRosen* pCentDedRosen =
		m_pCDedRosenFileData->getCentDedRosen();
	const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki =
		pCentDedRosen->getCentDedEkiCont()->getMuPtr(
			pCentDedRessya->getRessyahoukou());
	// --------------------------------
	//CDcdTargetGetDC	aCDcdTarget(NULL);
	// --------------------------------
	{
		//CdYColSpec aCdYColSpec(
		//	CdYColSpec::ColumnType_ShuchakuEkimei);
		//int iYColumnNumber =
		//	m_CdYColSpecCont.ColumnNumberFromSpec(aCdYColSpec, false);
		CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell(
			iXColumnNumber, iYColumnNumber);
		// --------------------------------
		if (pCDcdGridCell != 0)
		{
			typedef CDcdTextbox CDcDrawCell;
			Ou<CDcDrawCell> pCDcDrawCell;
			// --------------------------------
			//　(2.2.*.1)　セルの結合セルを設定
			pCDcdGridCell->setAttachCellCount(1, 1);

			//　(2.2.*.2)　セル の	DcDrawオブジェクトの型を設定
			//	( CDcdTextbox とする)。
			{
				pCDcDrawCell = dynamic_castOu<CDcDrawCell>(
					pCDcdGridCell->getIfDcDraw());
				if (pCDcDrawCell == NULL)
				{
					pCDcDrawCell = OuNew<CDcDrawCell>(new CDcDrawCell);
					pCDcdGridCell->setIfDcDraw(pCDcDrawCell);
				}
			}
			//　(2.2.*.3)　セルの DcDrawオブジェクトに、属性を設定。
			{
				//pCDcDrawCell->setText("");
				pCDcDrawCell->setCdDrawTextProp(getCdDrawTextPropOperation());
				tstring strText;
				if (pCentDedRessya->getValidSyuuchakuEki() != -1)
				{
					if (pCentDedRessya->getLastOperation().getAOperation() == CentDedAfterOperation::AOperation_Outer)
					{
						strText = muCdDedEki->get(pCentDedRessya->getValidSyuuchakuEki()).getOuterTerminalJikokuRyaku(
							pCentDedRessya->getLastOperation().getOuterShuchakuekiIndex(),true);
					}
					else
					{
						strText = muCdDedEki->get(pCentDedRessya->getValidSyuuchakuEki()).getEkimeiJikokuhyouRyaku(true);
					}
				}
				pCDcDrawCell->setText(strText);
			}

			//セルの背景色を指定します。
			{
				pCDcDrawCell->setCdBrushProp(CdColorProp(255, 255, 255));
			}
		}
	}
}


void CCellBuilderCustomize::update02_02_02_15_setRessya_OuterTerminal_Shihatsu(
	int iXColumnNumber,
	int iYColumnNumber,
	const CentDedRessya * pCentDedRessya,
	CWndJikokuhyou * pCWndJikokuhyou)
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	const CentDedRosen* pCentDedRosen =
		m_pCDedRosenFileData->getCentDedRosen();
	const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki =
		pCentDedRosen->getCentDedEkiCont()->getMuPtr(
			pCentDedRessya->getRessyahoukou());
	// --------------------------------
	//CDcdTargetGetDC	aCDcdTarget(NULL);
	// --------------------------------
	{
		//CdYColSpec aCdYColSpec1(
		//	CdYColSpec::ColumnType_Outer_Shihatsu1);
		//CdYColSpec aCdYColSpec2(
		//	CdYColSpec::ColumnType_Outer_Shihatsu2);
		//int iYColumnNumber1 =
		//	m_CdYColSpecCont.ColumnNumberFromSpec(aCdYColSpec1, false);
		//int iYColumnNumber2 =
		//	m_CdYColSpecCont.ColumnNumberFromSpec(aCdYColSpec2, false);
		CDcdGridCell* pCDcdGridCell1 = pCDcdGrid->getCell(
			iXColumnNumber, iYColumnNumber);
		CDcdGridCell* pCDcdGridCell2 = pCDcdGrid->getCell(
			iXColumnNumber, iYColumnNumber + 1);
		// --------------------------------
		if (pCDcdGridCell1 != 0 && pCDcdGridCell2 != 0)
		{
			typedef CDcdTextbox CDcDrawCell;
			Ou<CDcDrawCell> pCDcDrawCell1;
			Ou<CDcDrawCell> pCDcDrawCell2;
			// --------------------------------
			//　(2.2.*.1)　セルの結合セルを設定
			pCDcdGridCell1->setAttachCellCount(1, 1);
			pCDcdGridCell2->setAttachCellCount(1, 1);

			//　(2.2.*.2)　セル の	DcDrawオブジェクトの型を設定
			//	( CDcdTextbox とする)。
			{
				pCDcDrawCell1 = dynamic_castOu<CDcDrawCell>(
					pCDcdGridCell1->getIfDcDraw());
				pCDcDrawCell2 = dynamic_castOu<CDcDrawCell>(
					pCDcdGridCell2->getIfDcDraw());
				if (pCDcDrawCell1 == NULL)
				{
					pCDcDrawCell1 = OuNew<CDcDrawCell>(new CDcDrawCell);
					pCDcdGridCell1->setIfDcDraw(pCDcDrawCell1);
				}
				if (pCDcDrawCell2 == NULL)
				{
					pCDcDrawCell2 = OuNew<CDcDrawCell>(new CDcDrawCell);
					pCDcdGridCell2->setIfDcDraw(pCDcDrawCell2);
				}
			}
			//　(2.2.*.3)　セルの DcDrawオブジェクトに、属性を設定。
			{
				int idxRessyasyubetsu
					= pCentDedRessya->getRessyasyubetsuIndex();
				*pCDcDrawCell1 = createCDcdRessyabangou(idxRessyasyubetsu);
				*pCDcDrawCell2 = createCDcdRessyabangou(idxRessyasyubetsu);
				//pCDcDrawCell1->setCdDrawTextProp(getCdDrawTextPropOperation());
				//pCDcDrawCell2->setCdDrawTextProp(getCdDrawTextPropOperation());
				tstring strText1;
				tstring strText2;

				const CentDedBeforeOperation aFirstOperation = pCentDedRessya->getFirstOperation();
				if (aFirstOperation.getBOperation() == CentDedBeforeOperation::BOperation_Outer)
				{
					CentDedEkiCont::CdDedEki aCdDedEki = muCdDedEki->get(pCentDedRessya->getValidSihatsuEki());
					strText1 = aCdDedEki.getOuterTerminalJikokuRyaku(aFirstOperation.getOuterShihatsuekiIndex(),true);
					if (!(aFirstOperation.getOuterShihatsuJikoku().isNull()))
					{
						CdDedJikoku aCdDedJikoku
							= aFirstOperation.getOuterShihatsuJikoku();
						strText2 = getCdDedJikokuConv().encode(aCdDedJikoku,false);
					}
				}
				pCDcDrawCell1->setText(strText1);
				pCDcDrawCell2->setText(strText2);

			}

			//セルの背景色を指定します。
			{
				pCDcDrawCell1->setCdBrushProp(CdColorProp(255, 255, 255));
				pCDcDrawCell2->setCdBrushProp(CdColorProp(255, 255, 255));
			}
		}
	}
}

void CCellBuilderCustomize::update02_02_02_06_setRessya_Chaku( 
	int iXColumnNumber ,
	int iYColumnNumber,
	const CentDedRessya* pCentDedRessya ,
	int iEkiOrder ,
	int iSyubetsuChangeEkiOrder,
	int iConnectEkiOrder,
	int iReleaseEkiOrder,
	CWndJikokuhyou* pCWndJikokuhyou ) 
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid() ;
	const CentDedRosen* pCentDedRosen = 
		m_pCDedRosenFileData->getCentDedRosen() ;
	const CentDedEkiCont* pCentDedEkiCont =
		pCentDedRosen->getCentDedEkiCont();
	const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki = 
		pCentDedEkiCont->getMuPtr(
			pCentDedRessya->getRessyahoukou() ) ;
	// --------------------------------
	//CDcdTargetGetDC	aCDcdTarget( NULL ) ;
	// --------------------------------
	{
		//CdYColSpec aCdYColSpec( 
		//	CdYColSpec::ColumnType_Ekijikoku_Chaku , 
		//	iEkiOrder ) ;
		//int iYColumnNumber = 
		//	m_CdYColSpecCont.ColumnNumberFromSpec( aCdYColSpec , false ) ;
		CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell( 
			iXColumnNumber , iYColumnNumber ) ;
		// --------------------------------
		if ( pCDcdGridCell != 0 )
		{
			typedef CDcdTextbox CDcDrawCell ;
			Ou<CDcDrawCell> pCDcDrawCell ;
			// --------------------------------
			//　(2.2.*.1)　セルの結合セルを設定
			pCDcdGridCell->setAttachCellCount( 1 , 1 ) ;

			//　(2.2.*.2)　セル の	DcDrawオブジェクトの型を設定
			//	( CDcdTextbox とする)。
			{
				pCDcDrawCell = dynamic_castOu<CDcDrawCell>( 
					pCDcdGridCell->getIfDcDraw() ) ;
				if ( pCDcDrawCell == NULL )
				{
					pCDcDrawCell = OuNew<CDcDrawCell>( new CDcDrawCell ) ;
					pCDcdGridCell->setIfDcDraw( pCDcDrawCell ) ;
				}
			}
			//　(2.2.*.3)　セルの DcDrawオブジェクトに、属性を設定。
			{
				CentDedEkiCont::CdDedEki aCdDedEki = muCdDedEki->get( iEkiOrder ) ;

				int idxRessyasyubetsu 
					= pCentDedRessya->getRessyasyubetsuIndex() ;
				
				//	主要駅では、空欄に主要駅表記を行います。
				//	起点・終点・着発駅のいずれかである場合、
				//	境界線に接している駅である場合は除きます。
				bool bIsSyuyouEkiHyouki = false ;
				if ( aCdDedEki.getEkikibo() == CentDedEki::Ekikibo_Syuyou 
					&&	0 < iEkiOrder 
					&& iEkiOrder < muCdDedEki->size() - 1 
					&& (!aCdDedEki.getJikokuhyouChakuJikokuDisplay() ||
						!aCdDedEki.getJikokuhyouHatsuJikokuDisplay()))
				{
					//	境界線に接している駅である場合は除きます。
					CentDedEkiCont::CdDedEki aCentDedEkiTonari ;
					if ( iEkiOrder > 0 )
					{
						aCentDedEkiTonari = muCdDedEki->get( iEkiOrder - 1 ) ;
					}

					if ( !aCentDedEkiTonari.getKyoukaisen()  && 
						!aCdDedEki.getKyoukaisen() )
					{
						bIsSyuyouEkiHyouki = true ;
					}
				}
				//bIsSyuyouEkiHyouji = 空欄に主要駅表記を行います。

				CentDedEkiJikoku	aCentDedEkiJikoku =
					pCentDedRessya->getCentDedEkiJikoku( iEkiOrder ) ;
				CdDedJikoku aCdDedJikoku 
							= aCentDedEkiJikoku.getChakujikoku() ;
				
				// --------------------------------
				//	駅時刻に合わせて、セルに文字を表示
				// --------------------------------
				int iValidSihatsuEki = pCentDedRessya->getValidSihatsuEki();
				int iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();
				if (iValidSihatsuEki == -1 || iValidSyuuchakuEki == -1)
				{
					if (bIsSyuyouEkiHyouki)
					{
						//	主要駅での表記（着発の場合は除く）
						//	"----"
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_UNKOUNASI_SYUYOU));
					}
					else
					{
						//	その他の駅での表記
						//	"・・"
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_UNKOUNASI_IPPAN));
					}
				}
				else if (iEkiOrder < iValidSihatsuEki)
				{
					if (pCentDedRessya->getFirstOperation().getBOperation() == CentDedBeforeOperation::BOperation_Outer
						&& m_bDisplayOuterTerminalShihatsu)
					{
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_KEIYUNASI));//"||"

					}
					else if (iSyubetsuChangeEkiOrder != -1)
					{
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_KEIYUNASI));//"||"
					}
					else if (iEkiOrder == iReleaseEkiOrder)
					{
						/**
							発時刻表示の有無にかかわらず、この欄に「↴」を表示する
						*/
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_RELEASE));
					}
					else if (iReleaseEkiOrder < iEkiOrder && iReleaseEkiOrder != -1)
					{
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_KEIYUNASI));//"||"
					}
					else if (bIsSyuyouEkiHyouki)
					{
						//	主要駅での表記（着発の場合は除く）
						//	"----"
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_UNKOUNASI_SYUYOU));
					}
					else
					{
						//	その他の駅での表記
						//	"・・"
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_UNKOUNASI_IPPAN));
					}
				}
				else if (iEkiOrder == iValidSihatsuEki)
				{
					if (pCentDedRessya->getFirstOperation().getBOperation() == CentDedBeforeOperation::BOperation_Outer
						&& m_bDisplayOuterTerminalShihatsu)
					{
						/**
							路線外始発の場合、当駅着時刻の設定の有無で変化します
							設定あり：停車・運転停車とみなします。従来通りの処理です。
							設定なし：駅扱い通過の場合は通過とみなします。路線外始発以外の作業は全て無効扱いになります
								通過をみなしているときは、当駅着時刻部は経由無し表記にします
								駅扱い停車の場合は、着時刻欄は経由無し表記にします。
						*/
						if (pCentDedRessya->getFirstOperation().getChakuJikoku().isNull() ||
							aCentDedEkiJikoku.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Tsuuka &&
							!m_bDisplayTsuukaEkiJikoku)
						{
							*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
							pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
								IDS_WORD_JIKOKUHYOU_KEIYUNASI));//"||"
						}
						else if(aCentDedEkiJikoku.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Tsuuka)
						{
							*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
							pCDcDrawCell->setCdDrawTextProp(
								getCdDrawTextPropTsuuka());

							/**
								秒単位表示OFFの場合は、切り上げ・切り捨ての処理を行いますが、
								その補助のため、着時刻が切り上げで、発時刻が30秒以上切り上げまたは切り捨ての場合は、発時刻の取得を行います。
							*/
							CdDedJikoku aHatsuJikoku;
							if (!getDisplaySecondEkiJikoku() &&
								m_iSecondRoundChaku == 2 &&
								m_iSecondRoundHatsu <= 1)
							{
								aHatsuJikoku = aCentDedEkiJikoku.getHatsujikoku();
								if (!aHatsuJikoku.isNull())
								{
									int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
									const CentDedAfterOperationCont* pAfterCont = aCentDedEkiJikoku.getCentDedAfterOperationCont();
									for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
									{
										const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
										if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt &&
											iRessyaTrack != pAfterOperation->getShuntTrackIndex())
										{
											/**
												同じ番線からの入換は、入換自体を無効と見なし、次を検索します
											*/
											if (pAfterOperation->getIsDisplayHatsuJikoku())
											{
												aHatsuJikoku = pAfterOperation->getOperationHatsuJikoku();
												break;
											}
											/**
												getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
											*/
											iRessyaTrack = pAfterOperation->getShuntTrackIndex();
										}
									}
								}
							}

							tstring strText = getCdDedJikokuConv().encode(pCentDedRessya->getFirstOperation().getChakuJikoku(),
								true, aHatsuJikoku);
							pCDcDrawCell->setText(strText);
						}
						else
						{
							*pCDcDrawCell = createCDcdEkijikoku(idxRessyasyubetsu);

							/**
								秒単位表示OFFの場合は、切り上げ・切り捨ての処理を行いますが、
								その補助のため、着時刻が切り上げで、発時刻が30秒以上切り上げまたは切り捨ての場合は、発時刻の取得を行います。
							*/
							CdDedJikoku aHatsuJikoku;
							if (!getDisplaySecondEkiJikoku() &&
								m_iSecondRoundChaku == 2 &&
								m_iSecondRoundHatsu <= 1)
							{
								aHatsuJikoku = aCentDedEkiJikoku.getHatsujikoku();
								if (!aHatsuJikoku.isNull())
								{
									int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
									const CentDedAfterOperationCont* pAfterCont = aCentDedEkiJikoku.getCentDedAfterOperationCont();
									for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
									{
										const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
										if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt &&
											iRessyaTrack != pAfterOperation->getShuntTrackIndex())
										{
											/**
												同じ番線からの入換は、入換自体を無効と見なし、次を検索します
											*/
											if (pAfterOperation->getIsDisplayHatsuJikoku())
											{
												aHatsuJikoku = pAfterOperation->getOperationHatsuJikoku();
												break;
											}
											/**
												getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
											*/
											iRessyaTrack = pAfterOperation->getShuntTrackIndex();
										}
									}
								}
							}

							tstring strText = getCdDedJikokuConv().encode(pCentDedRessya->getFirstOperation().getChakuJikoku(),
								true, aHatsuJikoku);
							pCDcDrawCell->setText(strText);
						}
					}
					else if (iSyubetsuChangeEkiOrder != -1 &&
						iSyubetsuChangeEkiOrder < iEkiOrder)
					{
						//今後、設定で着時刻を入れられるようにする
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_KEIYUNASI));//"||"
					}
					else if (iReleaseEkiOrder == iEkiOrder &&
						aCdDedEki.getJikokuhyouHatsuJikokuDisplay())
					{
						/**
							発時刻表示の有無で変わる
							発時刻表示がある場合は、この欄に「↴」を表示する
							発時刻表示がない場合は、この欄には、発時刻を入れ、一つ上の欄に、表示を行う。
						*/
						//if (aCdDedEki.getJikokuhyouHatsuJikokuDisplay())
						//{
							*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
							pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
								IDS_WORD_JIKOKUHYOU_RELEASE));
						//}
						//else if (iEkiOrder != 0)
						//{
						//	int iYColumnNumberPrev = iYColumnNumber - 1;
						//	//CdYColSpec aCdYColSpec = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberPrev);

						//	CDcdGridCell* pCDcdGridCellPrev = pCDcdGrid->getCell(
						//		iXColumnNumber, iYColumnNumberPrev);
						//	if (pCDcdGridCellPrev != 0)
						//	{
						//		//typedef CDcdTextbox CDcDrawCell;
						//		Ou<CDcDrawCell> pCDcDrawCellPrev;
						//		pCDcdGridCellPrev->setAttachCellCount(1, 1);

						//		pCDcDrawCellPrev = dynamic_castOu<CDcDrawCell>(
						//			pCDcdGridCellPrev->getIfDcDraw());
						//		if (pCDcDrawCellPrev == NULL)
						//		{
						//			pCDcDrawCellPrev = OuNew<CDcDrawCell>(new CDcDrawCell);
						//			pCDcdGridCellPrev->setIfDcDraw(pCDcDrawCellPrev);
						//		}
						//		*pCDcDrawCellPrev = createCDcdRessyabangou(idxRessyasyubetsu);
						//		pCDcDrawCellPrev->setText(_T("↴"));//"||"
						//	}
						//}
					}
					//この駅が着時刻のみ表示の場合は、着時刻欄に発時刻を表示する
					else if (!aCdDedEki.getJikokuhyouHatsuJikokuDisplay())
					{
						aCdDedJikoku = aCentDedEkiJikoku.getHatsujikoku();
						const CentDedAfterOperationCont* pAfterCont = aCentDedEkiJikoku.getCentDedAfterOperationCont();
						for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
						{
							const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
							if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt)
							{
								if (pAfterOperation->getIsDisplayHatsuJikoku())
								{
									aCdDedJikoku = pAfterOperation->getOperationHatsuJikoku();
									break;
								}
							}
						}
						tstring strText = getCdDedJikokuConv().encode(aCdDedJikoku,false);
						if (aCentDedEkiJikoku.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Tsuuka)
						{
							*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
							pCDcDrawCell->setText(strText);
							pCDcDrawCell->setCdDrawTextProp(
								getCdDrawTextPropTsuuka());
						}
						else
						{
							*pCDcDrawCell = createCDcdEkijikoku(idxRessyasyubetsu);
							pCDcDrawCell->setText(strText);
						}
					}
					else if (bIsSyuyouEkiHyouki)
					{
						//	主要駅での表記（着発の場合は除く）
						//	"----"
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_UNKOUNASI_SYUYOU));
					}
					else
					{
						//	その他の駅での表記
						//	"・・"
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_UNKOUNASI_IPPAN));
					}
				}
				else if (iEkiOrder > iValidSyuuchakuEki)
				{
					if (pCentDedRessya->getLastOperation().getAOperation() == CentDedAfterOperation::AOperation_Outer
						&& m_bDisplayOuterTerminalShuchaku)
					{
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_KEIYUNASI));//"||"

					}
					else if (iConnectEkiOrder >= iEkiOrder && iConnectEkiOrder != -1)
					{
						if (iConnectEkiOrder == iEkiOrder &&
							!aCdDedEki.getJikokuhyouHatsuJikokuDisplay())
						{
							*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
							pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
								IDS_WORD_JIKOKUHYOU_CONNECT));
						}
						else
						{
							*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
							pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
								IDS_WORD_JIKOKUHYOU_KEIYUNASI));//"||"
						}
					}
					else if (bIsSyuyouEkiHyouki)
					{
						//	主要駅での表記（着発の場合は除く）
						//	"----"
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_UNKOUNASI_SYUYOU));
					}
					else
					{
						//	その他の駅での表記
						//	"・・"
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_UNKOUNASI_IPPAN));
					}
					/**
						有効終着駅の次の駅で、この列車が路線外終着ではない、もしくは路線外終着欄がない時、
						この欄のすぐ上が発時刻欄かつ着時刻表示がない場合、
						この欄に"===="を描写します
					*/
					if (iEkiOrder == iValidSyuuchakuEki+1 &&
						(pCentDedRessya->getLastOperation().getAOperation() != CentDedAfterOperation::AOperation_Outer
							|| !m_bDisplayOuterTerminalShuchaku))
					{
						CdYColSpec aCdYColSpecPrev = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumber - 1);
						CentDedEkiCont::CdDedEki aCdDedEkiPrev = muCdDedEki->get(iEkiOrder - 1);
						if (aCdYColSpecPrev.getEkiOrder() == iEkiOrder - 1 &&
							aCdYColSpecPrev.getColumnType() == CdYColSpec::ColumnType_Ekijikoku_Hatsu &&
							!aCdDedEkiPrev.getJikokuhyouChakuJikokuDisplay())
						{
							//pCDcDrawCell->setText(_T("===="));
							pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
								IDS_WORD_JIKOKUHYOU_SYUUCHAKU));
						}
					}
				}
				//中間及び終着駅の場合
				else
				{
					switch (aCentDedEkiJikoku.getEkiatsukai())
					{
						case CentDedEkiJikoku::Ekiatsukai_None:
						{
							*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
							pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
								IDS_WORD_JIKOKUHYOU_KEIYUNASI));//"||"
						}
						break;
						case CentDedEkiJikoku::Ekiatsukai_Tsuuka:
						{
							if (pCentDedRessya->isRunBetweenNextEki(iEkiOrder - 1))
							{
								/**
									前駅からこの駅間を運行している場合、基本的に着時刻を表示します。
									着時刻がある場合は、前作業を見て、「入換着時刻を当駅の着時刻にする」が有効になっている作業がある場合は、その作業で時刻を更新する。
									着時刻がない場合は、レ印を表示します。
									ただし、当駅が有効終着駅かつ路線外終着で、当駅発時刻が空の場合は、当駅が通過扱いとなり、
									入換作業等がすべて無効扱いとなるので、この作業は行いません。
									また、この駅と次駅の間が運行なしで、通過駅時刻表示かつ着時刻がない場合は、
									運行なしを超えた先から発時刻を取得し表示します。（つまり、片側時刻のみがある通過の場合に、その時刻を両側に表示する）

								*/
								if (!aCdDedJikoku.isNull() &&
									(iEkiOrder != iValidSyuuchakuEki ||
									pCentDedRessya->getLastOperation().getAOperation() != CentDedAfterOperation::AOperation_Outer ||
									!pCentDedRessya->getLastOperation().getHatsuJikoku().isNull()))
								{
									int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
									const CentDedBeforeOperationCont* pBeforeCont = aCentDedEkiJikoku.getCentDedBeforeOperationCont();
									for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
									{
										const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
										if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt &&
											iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
										{
											/**
												同じ番線からの入換は、入換自体を無効と見なし、次を検索します
											*/
											if (pBeforeOperation->getIsDisplayChakuJikoku())
											{
												aCdDedJikoku = pBeforeOperation->getOperationChakuJikoku(true);
												break;
											}
											/**
												getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
											*/
											iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
										}
									}
								}

								/**
									bIsChakuJikoku
									この項に表示する時刻が、着時刻なのか否か
									着時刻なのか発時刻なのかで、秒単位処理が変わります。
								*/
								bool bIsChakuJikoku = true;
								if (aCdDedJikoku.isNull() &&
									iEkiOrder != iValidSyuuchakuEki &&
									m_bDisplayTsuukaEkiJikoku &&
									!pCentDedRessya->isRunBetweenNextEki(iEkiOrder))
								{
									int iHatsuEkiOrder = pCentDedRessya->getRunBetweenEkiForward(iEkiOrder);
									if (iHatsuEkiOrder != -1 &&
										pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iHatsuEkiOrder, pCentDedRessya->getRessyahoukou()))
									{
										//このケースでは、通過なので、入換作業を参照する必要はありません。
										aCdDedJikoku = pCentDedRessya->getCentDedEkiJikoku(iHatsuEkiOrder).getHatsujikoku();
										bIsChakuJikoku = false;
									}
								}

								if (!aCdDedJikoku.isNull() &&
									(m_bDisplayTsuukaEkiJikoku ||
									(iEkiOrder == iValidSyuuchakuEki &&
										pCentDedRessya->getLastOperation().getAOperation() != CentDedAfterOperation::AOperation_Outer)))
								{
									/**
										秒単位表示OFFの場合は、切り上げ・切り捨ての処理を行いますが、
										その補助のため、着時刻が切り上げで、発時刻が30秒以上切り上げまたは切り捨ての場合は、発時刻の取得を行います。
										ただし、この駅と次の駅の間が運行ありの場合は、発時刻表示がある場合に限り、
										一方、この駅と次の駅の間が運行なしの場合は、運行なしを超えた先の駅から時刻を取得します。
									*/
									CdDedJikoku aHatsuJikoku;
									if (iEkiOrder < iValidSyuuchakuEki &&
										!getDisplaySecondEkiJikoku() &&
										//aCdDedEki.getJikokuhyouHatsuJikokuDisplay() &&
										m_iSecondRoundChaku == 2 &&
										m_iSecondRoundHatsu <= 1 &&
										bIsChakuJikoku)
									{
										if (!pCentDedRessya->isRunBetweenNextEki(iEkiOrder))
										{
											int iHatsuEkiOrder = pCentDedRessya->getRunBetweenEkiForward(iEkiOrder);
											if (iHatsuEkiOrder != -1 &&
												pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iHatsuEkiOrder, pCentDedRessya->getRessyahoukou()))
											{
												aHatsuJikoku = pCentDedRessya->getCentDedEkiJikoku(iHatsuEkiOrder).getHatsujikoku();
												if (!aHatsuJikoku.isNull())
												{
													CentDedEkiJikoku aCentDedHatsuEkiJikoku = pCentDedRessya->getCentDedEkiJikoku(iHatsuEkiOrder);
													int iRessyaTrack = aCentDedHatsuEkiJikoku.getRessyaTrackIndex();
													const CentDedAfterOperationCont* pAfterCont = aCentDedHatsuEkiJikoku.getCentDedAfterOperationCont();
													for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
													{
														const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
														if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt &&
															iRessyaTrack != pAfterOperation->getShuntTrackIndex())
														{
															/**
																同じ番線からの入換は、入換自体を無効と見なし、次を検索します
															*/
															if (pAfterOperation->getIsDisplayHatsuJikoku())
															{
																aHatsuJikoku = pAfterOperation->getOperationHatsuJikoku();
																break;
															}
															/**
																getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
															*/
															iRessyaTrack = pAfterOperation->getShuntTrackIndex();
														}
													}
												}
											}
										}
										else if(aCdDedEki.getJikokuhyouHatsuJikokuDisplay())//&& pCentDedRessya->isRunBetweenNextEki(iEkiOrder)
										{
											aHatsuJikoku = aCentDedEkiJikoku.getHatsujikoku();
											if (!aHatsuJikoku.isNull())
											{
												int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
												const CentDedAfterOperationCont* pAfterCont = aCentDedEkiJikoku.getCentDedAfterOperationCont();
												for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
												{
													const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
													if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt &&
														iRessyaTrack != pAfterOperation->getShuntTrackIndex())
													{
														/**
															同じ番線からの入換は、入換自体を無効と見なし、次を検索します
														*/
														if (pAfterOperation->getIsDisplayHatsuJikoku())
														{
															aHatsuJikoku = pAfterOperation->getOperationHatsuJikoku();
															break;
														}
														/**
															getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
														*/
														iRessyaTrack = pAfterOperation->getShuntTrackIndex();
													}
												}
											}
										}
									}

									//	通過駅の駅時刻が設定されており、
									//	『通過駅の駅時刻を表示する』指定になっている場合
									//	もしくは終着駅かつ路線外終着以外の場合は
									//	時刻を表示
									*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
									tstring strText = getCdDedJikokuConv().encode(aCdDedJikoku, bIsChakuJikoku, aHatsuJikoku);
									pCDcDrawCell->setText(strText);
									pCDcDrawCell->setCdDrawTextProp(
										getCdDrawTextPropTsuuka());
								}
								else
								{
									*pCDcDrawCell = createCDcdRessyabangou(
										idxRessyasyubetsu);
									pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
										IDS_WORD_JIKOKUHYOU_TSUUKA));	//" ﾚ"
								}

							}
							else
							{
								/**
									前駅からこの駅間が運行していない場合は、基本的に経由無しを表示します。
									ただし、この駅に着時刻が設定されている場合、もしくはこの駅から次駅の間が運行ありかつ発時刻表示が無い場合は、
									着時刻を起点方から取得します。ただし、この駅から次駅の間が運行なしの場合は、
									終点方のisRunBetweenNextEkiがtrueの駅を探し、起点方の駅・この駅・終点方の駅が全て同一駅であることを確認してから、
									着時刻の取得を行います。
									上記探索において、着時刻が見つからなかった場合は、経由無しにしますが、
									この駅から次駅の間が運行ありかつ発時刻表示が無い場合は、レ印を表示します。
								*/
								if (!aCdDedJikoku.isNull() ||
									(pCentDedRessya->isRunBetweenNextEki(iEkiOrder) &&
										!aCdDedEki.getJikokuhyouHatsuJikokuDisplay()))
								{
									aCdDedJikoku.setNull();
									if (pCentDedRessya->isRunBetweenNextEki(iEkiOrder))
									{
										int iChakuEkiOrder = pCentDedRessya->getRunBetweenEkiBackward(iEkiOrder);
										if (pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iChakuEkiOrder, pCentDedRessya->getRessyahoukou()))
										{
											CentDedEkiJikoku aChakuEkiJikoku = pCentDedRessya->getCentDedEkiJikoku(iChakuEkiOrder);
											aCdDedJikoku = aChakuEkiJikoku.getChakujikoku();
											int iRessyaTrack = aChakuEkiJikoku.getRessyaTrackIndex();
											const CentDedBeforeOperationCont* pBeforeCont = aChakuEkiJikoku.getCentDedBeforeOperationCont();
											for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
											{
												const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
												if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt &&
													iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
												{
													/**
														同じ番線からの入換は、入換自体を無効と見なし、次を検索します
													*/
													if (pBeforeOperation->getIsDisplayChakuJikoku())
													{
														aCdDedJikoku = pBeforeOperation->getOperationChakuJikoku(true);
														break;
													}
													/**
														getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
													*/
													iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
												}
											}
										}
									}
									/**
										前後ともisRunBetweenNextEkiがFalseの場合は、一旦保留にします
										（番線欄や駅扱い一致、種別変更欄との兼ね合い及び、有効始発駅・終着駅より外側の表示と整合を合わせるため後回し
									*/
									//else
									//{
									//	int iChakuEkiOrder = pCentDedRessya->getRunBetweenEkiBackward(iEkiOrder);
									//	int iHatsuEkiOrder = pCentDedRessya->getRunBetweenEkiForward(iEkiOrder);
									//	if (pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iChakuEkiOrder, pCentDedRessya->getRessyahoukou()) &&
									//		pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iHatsuEkiOrder, pCentDedRessya->getRessyahoukou()))
									//	{
									//		CentDedEkiJikoku aChakuEkiJikoku = pCentDedRessya->getCentDedEkiJikoku(iChakuEkiOrder);
									//		if (aCentDedEkiJikoku.getEkiatsukai() == aChakuEkiJikoku.getEkiatsukai())
									//		{
									//			/**
									//				前後ともisRunBetweenNextEkiがFalseの場合は、駅扱いが一致しているかどうかを確認します
									//				(列車編集時、iChakuEkiOrderとiHatsuEkiOrderは駅扱いを合わせるが、この駅は対象に入らないので)
									//				駅扱いが一致している場合のみ、時刻取得を行います。
									//			*/
									//			aCdDedJikoku = aChakuEkiJikoku.getChakujikoku();
									//			int iRessyaTrack = aChakuEkiJikoku.getRessyaTrackIndex();
									//			const CentDedBeforeOperationCont* pBeforeCont = aChakuEkiJikoku.getCentDedBeforeOperationCont();
									//			for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
									//			{
									//				const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
									//				if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt &&
									//					iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
									//				{
									//					/**
									//						同じ番線からの入換は、入換自体を無効と見なし、次を検索します
									//					*/
									//					if (pBeforeOperation->getIsDisplayChakuJikoku())
									//					{
									//						aCdDedJikoku = pBeforeOperation->getOperationChakuJikoku(true);
									//						break;
									//					}
									//					/**
									//						getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
									//					*/
									//					iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
									//				}
									//			}
									//		}
									//	}
									//}
								}

								if (!aCdDedJikoku.isNull() &&
									m_bDisplayTsuukaEkiJikoku)
								{
									/**
										秒単位表示OFFの場合は、切り上げ・切り捨ての処理を行いますが、
										その補助のため、着時刻が切り上げで、発時刻が30秒以上切り上げまたは切り捨ての場合、
										かつ、発時刻表示がある場合は、発時刻の取得を行います。
										この駅と次の駅の間が運行なしの場合は、運行なしを超えた先の駅から時刻を取得します。
									*/
									CdDedJikoku aHatsuJikoku;
									if (!getDisplaySecondEkiJikoku() &&
										aCdDedEki.getJikokuhyouHatsuJikokuDisplay() &&
										m_iSecondRoundChaku == 2 &&
										m_iSecondRoundHatsu <= 1)
									{
										if (iEkiOrder < iValidSyuuchakuEki)
										{
											//pCentDedRessya->isRunBetweenNextEki(iEkiOrder)がfalseの場合は、時刻がNULLになっているはずなので、この処理は省略
											//if (pCentDedRessya->isRunBetweenNextEki(iEkiOrder))
											//{
											aHatsuJikoku = aCentDedEkiJikoku.getHatsujikoku();
											if (!aHatsuJikoku.isNull())
											{
												int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
												const CentDedAfterOperationCont* pAfterCont = aCentDedEkiJikoku.getCentDedAfterOperationCont();
												for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
												{
													const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
													if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt &&
														iRessyaTrack != pAfterOperation->getShuntTrackIndex())
													{
														/**
															同じ番線からの入換は、入換自体を無効と見なし、次を検索します
														*/
														if (pAfterOperation->getIsDisplayHatsuJikoku())
														{
															aHatsuJikoku = pAfterOperation->getOperationHatsuJikoku();
															break;
														}
														/**
															getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
														*/
														iRessyaTrack = pAfterOperation->getShuntTrackIndex();
													}
												}
											}
											//}
											//else
											//{
											//	int iHatsuEkiOrder = pCentDedRessya->getRunBetweenEkiForward(iEkiOrder);
											//	if (iHatsuEkiOrder != -1 &&
											//		pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iHatsuEkiOrder, pCentDedRessya->getRessyahoukou()))
											//	{
											//		aHatsuJikoku = pCentDedRessya->getCentDedEkiJikoku(iHatsuEkiOrder).getHatsujikoku();
											//	}
											//}
										}
									}

									//	通過駅の駅時刻が設定されており、
									//	『通過駅の駅時刻を表示する』指定になっている場合は
									//	時刻を表示
									*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
									tstring strText = getCdDedJikokuConv().encode(aCdDedJikoku, true, aHatsuJikoku);
									pCDcDrawCell->setText(strText);
									pCDcDrawCell->setCdDrawTextProp(
										getCdDrawTextPropTsuuka());
								}
								else if (pCentDedRessya->isRunBetweenNextEki(iEkiOrder) &&
									!aCdDedEki.getJikokuhyouHatsuJikokuDisplay())
								{
									*pCDcDrawCell = createCDcdRessyabangou(
										idxRessyasyubetsu);
									pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
										IDS_WORD_JIKOKUHYOU_TSUUKA));	//" ﾚ"
								}
								else
								{
									*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
									pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
										IDS_WORD_JIKOKUHYOU_KEIYUNASI));//"||"
								}
							}
						}
						break;
						case CentDedEkiJikoku::Ekiatsukai_Teisya:
						{
							if (pCentDedRessya->isRunBetweenNextEki(iEkiOrder - 1))
							{
								/**
									前駅からこの駅間を運行している場合、基本的に着時刻を表示します。
									着時刻がある場合は、前作業を見て、「入換着時刻を当駅の着時刻にする」が有効になっている作業がある場合は、その作業で時刻を更新する。
									着時刻がない場合は、○印を表示しますが、この駅が着時刻のみ表示の場合は、発時刻を代わりに表示します。
									その場合、この駅から次駅の間が運行していない場合は、終点方のisRunBetweenNextEkiがtrueの駅を探し、
									この駅と同一駅の場合は、その駅から発時刻を取得します。
								*/
								if(!aCdDedJikoku.isNull())
								{
									int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
									const CentDedBeforeOperationCont* pBeforeCont = aCentDedEkiJikoku.getCentDedBeforeOperationCont();
									for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
									{
										const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
										if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt &&
											iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
										{
											/**
												同じ番線からの入換は、入換自体を無効と見なし、次を検索します
											*/
											if (pBeforeOperation->getIsDisplayChakuJikoku())
											{
												aCdDedJikoku = pBeforeOperation->getOperationChakuJikoku(true);
												break;
											}
											/**
												getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
											*/
											iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
										}
									}
								}

								if (aCdDedJikoku.isNull() &&
									!aCdDedEki.getJikokuhyouHatsuJikokuDisplay())
								{
									if (pCentDedRessya->isRunBetweenNextEki(iEkiOrder))
									{
										aCdDedJikoku = aCentDedEkiJikoku.getHatsujikoku();

										int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
										const CentDedAfterOperationCont* pAfterCont = aCentDedEkiJikoku.getCentDedAfterOperationCont();
										for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
										{
											const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
											if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt &&
												iRessyaTrack != pAfterOperation->getShuntTrackIndex())
											{
												/**
													同じ番線からの入換は、入換自体を無効と見なし、次を検索します
												*/
												if (pAfterOperation->getIsDisplayHatsuJikoku())
												{
													aCdDedJikoku = pAfterOperation->getOperationHatsuJikoku();
													break;
												}
												/**
													getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
												*/
												iRessyaTrack = pAfterOperation->getShuntTrackIndex();
											}
										}
									}
									else
									{
										int iHatsuEkiOrder = pCentDedRessya->getRunBetweenEkiForward(iEkiOrder);
										if (pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iHatsuEkiOrder, pCentDedRessya->getRessyahoukou()))
										{
											CentDedEkiJikoku aHatsuEkiJikoku = pCentDedRessya->getCentDedEkiJikoku(iHatsuEkiOrder);
											aCdDedJikoku = aHatsuEkiJikoku.getHatsujikoku();
											int iRessyaTrack = aHatsuEkiJikoku.getRessyaTrackIndex();
											const CentDedAfterOperationCont* pAfterCont = aHatsuEkiJikoku.getCentDedAfterOperationCont();
											for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
											{
												const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
												if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt &&
													iRessyaTrack != pAfterOperation->getShuntTrackIndex())
												{
													/**
														同じ番線からの入換は、入換自体を無効と見なし、次を検索します
													*/
													if (pAfterOperation->getIsDisplayHatsuJikoku())
													{
														aCdDedJikoku = pAfterOperation->getOperationHatsuJikoku();
														break;
													}
													/**
														getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
													*/
													iRessyaTrack = pAfterOperation->getShuntTrackIndex();
												}
											}
										}
									}
								}

								if (!aCdDedJikoku.isNull())
								{
									/**
										秒単位表示OFFの場合は、切り上げ・切り捨ての処理を行いますが、
										その補助のため、着時刻が切り上げで、発時刻が30秒以上切り上げまたは切り捨ての場合かつ、発時刻の取得を行います。
										ただし、この駅と次の駅の間が運行ありの場合は、発時刻表示がある場合に限り、
										一方、この駅と次の駅の間が運行なしの場合は、運行なしを超えた先の駅から時刻を取得します。
									*/
									CdDedJikoku aHatsuJikoku;
									if (!getDisplaySecondEkiJikoku() &&
										//aCdDedEki.getJikokuhyouHatsuJikokuDisplay() &&
										m_iSecondRoundChaku == 2 &&
										m_iSecondRoundHatsu <= 1)
									{
										if (iEkiOrder < iValidSyuuchakuEki)
										{
											if (!pCentDedRessya->isRunBetweenNextEki(iEkiOrder))
											{
												int iHatsuEkiOrder = pCentDedRessya->getRunBetweenEkiForward(iEkiOrder);
												if (iHatsuEkiOrder != -1 &&
													pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iHatsuEkiOrder, pCentDedRessya->getRessyahoukou()))
												{
													aHatsuJikoku = pCentDedRessya->getCentDedEkiJikoku(iHatsuEkiOrder).getHatsujikoku();
													if (!aHatsuJikoku.isNull())
													{
														CentDedEkiJikoku aCentDedHatsuEkiJikoku = pCentDedRessya->getCentDedEkiJikoku(iHatsuEkiOrder);
														int iRessyaTrack = aCentDedHatsuEkiJikoku.getRessyaTrackIndex();
														const CentDedAfterOperationCont* pAfterCont = aCentDedHatsuEkiJikoku.getCentDedAfterOperationCont();
														for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
														{
															const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
															if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt &&
																iRessyaTrack != pAfterOperation->getShuntTrackIndex())
															{
																/**
																	同じ番線からの入換は、入換自体を無効と見なし、次を検索します
																*/
																if (pAfterOperation->getIsDisplayHatsuJikoku())
																{
																	aHatsuJikoku = pAfterOperation->getOperationHatsuJikoku();
																	break;
																}
																/**
																	getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
																*/
																iRessyaTrack = pAfterOperation->getShuntTrackIndex();
															}
														}
													}
												}
											}
											else if(aCdDedEki.getJikokuhyouHatsuJikokuDisplay())//&& pCentDedRessya->isRunBetweenNextEki(iEkiOrder)
											{
												aHatsuJikoku = aCentDedEkiJikoku.getHatsujikoku();
												if (!aHatsuJikoku.isNull())
												{
													int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
													const CentDedAfterOperationCont* pAfterCont = aCentDedEkiJikoku.getCentDedAfterOperationCont();
													for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
													{
														const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
														if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt &&
															iRessyaTrack != pAfterOperation->getShuntTrackIndex())
														{
															/**
																同じ番線からの入換は、入換自体を無効と見なし、次を検索します
															*/
															if (pAfterOperation->getIsDisplayHatsuJikoku())
															{
																aHatsuJikoku = pAfterOperation->getOperationHatsuJikoku();
																break;
															}
															/**
																getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
															*/
															iRessyaTrack = pAfterOperation->getShuntTrackIndex();
														}
													}
												}
											}
										}
									}

									//	時刻が設定されている場合は時刻を表示
									*pCDcDrawCell = createCDcdEkijikoku(idxRessyasyubetsu);
									tstring strText = getCdDedJikokuConv().encode(aCdDedJikoku,true, aHatsuJikoku);
									pCDcDrawCell->setText(strText);
								}
								else
								{
									*pCDcDrawCell = createCDcdRessyabangou(
										idxRessyasyubetsu);
									pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
										IDS_WORD_JIKOKUHYOU_TEISYA));
								}

							}
							else
							{
								/**
									前駅からこの駅間が運行していない場合は、基本的に経由無しを表示します。
									ただし、この駅に着時刻が設定されている場合、もしくはこの駅から次駅の間が運行ありかつ発時刻表示が無い場合は、
									着時刻を起点方から取得します。ただし、この駅から次駅の間が運行なしの場合は、
									終点方のisRunBetweenNextEkiがtrueの駅を探し、起点方の駅・この駅・終点方の駅が全て同一駅であることを確認してから、
									着時刻の取得を行います。
									上記探索において、着時刻が見つからなかった場合は、経由無しにしますが、
									この駅から次駅の間が運行ありかつ発時刻表示が無い場合は、まず発時刻を表示するようにし、それもない場合は○印を表示します
								*/
								if (!aCdDedJikoku.isNull() ||
									(pCentDedRessya->isRunBetweenNextEki(iEkiOrder) &&
										!aCdDedEki.getJikokuhyouHatsuJikokuDisplay()))
								{
									aCdDedJikoku.setNull();
									if (pCentDedRessya->isRunBetweenNextEki(iEkiOrder))
									{
										int iChakuEkiOrder = pCentDedRessya->getRunBetweenEkiBackward(iEkiOrder);
										if (pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iChakuEkiOrder, pCentDedRessya->getRessyahoukou()))
										{
											CentDedEkiJikoku aChakuEkiJikoku = pCentDedRessya->getCentDedEkiJikoku(iChakuEkiOrder);
											aCdDedJikoku = aChakuEkiJikoku.getChakujikoku();
											int iRessyaTrack = aChakuEkiJikoku.getRessyaTrackIndex();
											const CentDedBeforeOperationCont* pBeforeCont = aChakuEkiJikoku.getCentDedBeforeOperationCont();
											for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
											{
												const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
												if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt &&
													iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
												{
													/**
														同じ番線からの入換は、入換自体を無効と見なし、次を検索します
													*/
													if (pBeforeOperation->getIsDisplayChakuJikoku())
													{
														aCdDedJikoku = pBeforeOperation->getOperationChakuJikoku(true);
														break;
													}
													/**
														getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
													*/
													iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
												}
											}
										}
									}
									/**
										前後ともisRunBetweenNextEkiがFalseの場合は、一旦保留にします
										（番線欄や駅扱い一致、種別変更欄との兼ね合い及び、有効始発駅・終着駅より外側の表示と整合を合わせるため後回し
									*/
									//else
									//{
									//	int iChakuEkiOrder = pCentDedRessya->getRunBetweenEkiBackward(iEkiOrder);
									//	int iHatsuEkiOrder = pCentDedRessya->getRunBetweenEkiForward(iEkiOrder);
									//	if (pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iChakuEkiOrder, pCentDedRessya->getRessyahoukou()) &&
									//		pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iHatsuEkiOrder, pCentDedRessya->getRessyahoukou()))
									//	{
									//		CentDedEkiJikoku aChakuEkiJikoku = pCentDedRessya->getCentDedEkiJikoku(iChakuEkiOrder);
									//		if (aCentDedEkiJikoku.getEkiatsukai() == aChakuEkiJikoku.getEkiatsukai())
									//		{
									//			/**
									//				前後ともisRunBetweenNextEkiがFalseの場合は、駅扱いが一致しているかどうかを確認します
									//				(列車編集時、iChakuEkiOrderとiHatsuEkiOrderは駅扱いを合わせるが、この駅は対象に入らないので)
									//				駅扱いが一致している場合のみ、時刻取得を行います。
									//			*/
									//			aCdDedJikoku = aChakuEkiJikoku.getChakujikoku();
									//			int iRessyaTrack = aChakuEkiJikoku.getRessyaTrackIndex();
									//			const CentDedBeforeOperationCont* pBeforeCont = aChakuEkiJikoku.getCentDedBeforeOperationCont();
									//			for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
									//			{
									//				const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
									//				if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt &&
									//					iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
									//				{
									//					/**
									//						同じ番線からの入換は、入換自体を無効と見なし、次を検索します
									//					*/
									//					if (pBeforeOperation->getIsDisplayChakuJikoku())
									//					{
									//						aCdDedJikoku = pBeforeOperation->getOperationChakuJikoku(true);
									//						break;
									//					}
									//					/**
									//						getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
									//					*/
									//					iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
									//				}
									//			}
									//		}
									//	}
									//}
								}

								if (aCdDedJikoku.isNull() &&
									pCentDedRessya->isRunBetweenNextEki(iEkiOrder) &&
									!aCdDedEki.getJikokuhyouHatsuJikokuDisplay())
								{
									aCdDedJikoku = aCentDedEkiJikoku.getHatsujikoku();

									int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
									const CentDedAfterOperationCont* pAfterCont = aCentDedEkiJikoku.getCentDedAfterOperationCont();
									for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
									{
										const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
										if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt &&
											iRessyaTrack != pAfterOperation->getShuntTrackIndex())
										{
											/**
												同じ番線からの入換は、入換自体を無効と見なし、次を検索します
											*/
											if (pAfterOperation->getIsDisplayHatsuJikoku())
											{
												aCdDedJikoku = pAfterOperation->getOperationHatsuJikoku();
												break;
											}
											/**
												getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
											*/
											iRessyaTrack = pAfterOperation->getShuntTrackIndex();
										}
									}
								}

								if (!aCdDedJikoku.isNull())
								{
									/**
										秒単位表示OFFの場合は、切り上げ・切り捨ての処理を行いますが、
										その補助のため、着時刻が切り上げで、発時刻が30秒以上切り上げまたは切り捨ての場合、
										かつ、発時刻表示がある場合は、発時刻の取得を行います。
										この駅と次の駅の間が運行なしの場合は、運行なしを超えた先の駅から時刻を取得します。
									*/
									CdDedJikoku aHatsuJikoku;
									if (!getDisplaySecondEkiJikoku() &&
										aCdDedEki.getJikokuhyouHatsuJikokuDisplay() &&
										m_iSecondRoundChaku == 2 &&
										m_iSecondRoundHatsu <= 1)
									{
										if (iEkiOrder < iValidSyuuchakuEki)
										{
											//pCentDedRessya->isRunBetweenNextEki(iEkiOrder)がfalseの場合は、時刻がNULLになっているはずなので、この処理は省略
											//if (pCentDedRessya->isRunBetweenNextEki(iEkiOrder))
											//{
											aHatsuJikoku = aCentDedEkiJikoku.getHatsujikoku();
											if (!aHatsuJikoku.isNull())
											{
												int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
												const CentDedAfterOperationCont* pAfterCont = aCentDedEkiJikoku.getCentDedAfterOperationCont();
												for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
												{
													const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
													if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt &&
														iRessyaTrack != pAfterOperation->getShuntTrackIndex())
													{
														/**
															同じ番線からの入換は、入換自体を無効と見なし、次を検索します
														*/
														if (pAfterOperation->getIsDisplayHatsuJikoku())
														{
															aHatsuJikoku = pAfterOperation->getOperationHatsuJikoku();
															break;
														}
														/**
															getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
														*/
														iRessyaTrack = pAfterOperation->getShuntTrackIndex();
													}
												}
											}
											//}
											//else
											//{
											//	int iHatsuEkiOrder = pCentDedRessya->getRunBetweenEkiForward(iEkiOrder);
											//	if (iHatsuEkiOrder != -1 &&
											//		pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iHatsuEkiOrder, pCentDedRessya->getRessyahoukou()))
											//	{
											//		aHatsuJikoku = pCentDedRessya->getCentDedEkiJikoku(iHatsuEkiOrder).getHatsujikoku();
											//	}
											//}
										}
									}

									//	時刻が設定されている場合は時刻を表示
									*pCDcDrawCell = createCDcdEkijikoku(idxRessyasyubetsu);
									tstring strText = getCdDedJikokuConv().encode(aCdDedJikoku, true, aHatsuJikoku);
									pCDcDrawCell->setText(strText);
								}
								else if(pCentDedRessya->isRunBetweenNextEki(iEkiOrder) &&
									!aCdDedEki.getJikokuhyouHatsuJikokuDisplay())
								{
									*pCDcDrawCell = createCDcdRessyabangou(
										idxRessyasyubetsu);
									pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
										IDS_WORD_JIKOKUHYOU_TEISYA));
								}
								else
								{
									*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
									pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
										IDS_WORD_JIKOKUHYOU_KEIYUNASI));//"||"
								}
							}
						}
						break;
					}
				}

				/**
					次駅が解結駅の場合、この欄に↴印を表示することがあります
					(1)次駅が解結駅かつ有効な始発駅
					(2)次駅が着時刻又は発時刻のどちらかのみ表示
					(3)この欄の直下が、次駅の項な場合。
				*/
				if (iEkiOrder + 1 == iValidSihatsuEki &&
					iEkiOrder + 1 == iReleaseEkiOrder)
				{
					CentDedEkiCont::CdDedEki aCdDedEkiNext = muCdDedEki->get(iEkiOrder + 1);
					if (!aCdDedEkiNext.getJikokuhyouChakuJikokuDisplay() ||
						!aCdDedEkiNext.getJikokuhyouHatsuJikokuDisplay())
					{
						int iYColumnNumberNext = iYColumnNumber + 1;
						CdYColSpec aCdYColSpecNext = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberNext);
						if (aCdYColSpecNext.getEkiOrder() == iEkiOrder + 1)
						{
							*pCDcDrawCell = createCDcdRessyabangou(
								idxRessyasyubetsu);
							pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
								IDS_WORD_JIKOKUHYOU_RELEASE));
						}
					}
				}
				/**
					前駅が増結駅の場合、この欄に↳印を表示することがあります
					(1)前駅が増結駅かつ有効な終着駅
					(2)前駅が着時刻又は発時刻のどちらかのみ表示
					(3)この欄の直上が、前駅の項な場合。
				*/
				if (iEkiOrder - 1 == iValidSyuuchakuEki &&
					iEkiOrder - 1 == iConnectEkiOrder &&
					iValidSyuuchakuEki != -1)
				{
					CentDedEkiCont::CdDedEki aCdDedEkiPrev = muCdDedEki->get(iEkiOrder - 1);
					if (!aCdDedEkiPrev.getJikokuhyouChakuJikokuDisplay() ||
						!aCdDedEkiPrev.getJikokuhyouHatsuJikokuDisplay())
					{
						int iYColumnNumberPrev = iYColumnNumber - 1;
						CdYColSpec aCdYColSpecPrev = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberPrev);
						if (aCdYColSpecPrev.getEkiOrder() == iEkiOrder - 1)
						{
							*pCDcDrawCell = createCDcdRessyabangou(
								idxRessyasyubetsu);
							pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
								IDS_WORD_JIKOKUHYOU_CONNECT));
						}
					}
				}

				//セルの背景色を指定します。
				pCDcDrawCell->setCdBrushProp(getBackColor(
					iXColumnNumber,
					iEkiOrder,
					idxRessyasyubetsu));
			}
		}
	}
}

void CCellBuilderCustomize::update02_02_02_09_setRessya_Track(
	int iXColumnNumber,
	int iYColumnNumber,
	const CentDedRessya * pCentDedRessya, 
	int iEkiOrder,
	int iSyubetsuChangeEkiOrder,
	int iConnectEkiOrder,
	int iReleaseEkiOrder,
	CWndJikokuhyou * pCWndJikokuhyou)
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	const CentDedRosen* pCentDedRosen =
		m_pCDedRosenFileData->getCentDedRosen();
	const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki =
		pCentDedRosen->getCentDedEkiCont()->getMuPtr(
			pCentDedRessya->getRessyahoukou());
	// --------------------------------
	//CDcdTargetGetDC	aCDcdTarget(NULL);
	// --------------------------------
	{
		//CdYColSpec aCdYColSpec(
		//	CdYColSpec::ColumnType_Track,
		//	iEkiOrder);
		//int iYColumnNumber =
		//	m_CdYColSpecCont.ColumnNumberFromSpec(aCdYColSpec, false);
		CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell(
			iXColumnNumber, iYColumnNumber);
		// --------------------------------
		if (pCDcdGridCell != 0)
		{
			typedef CDcdTextbox CDcDrawCell;
			Ou<CDcDrawCell> pCDcDrawCell;
			// --------------------------------
			//　(2.2.*.1)　セルの結合セルを設定
			pCDcdGridCell->setAttachCellCount(1, 1);

			//　(2.2.*.2)　セル の	DcDrawオブジェクトの型を設定
			//	( CDcdTextbox とする)。
			{
				pCDcDrawCell = dynamic_castOu<CDcDrawCell>(
					pCDcdGridCell->getIfDcDraw());
				if (pCDcDrawCell == NULL)
				{
					pCDcDrawCell = OuNew<CDcDrawCell>(new CDcDrawCell);
					pCDcdGridCell->setIfDcDraw(pCDcDrawCell);
				}
			}
			//　(2.2.*.3)　セルの DcDrawオブジェクトに、属性を設定。
			{
				CentDedEkiCont::CdDedEki aCdDedEki = muCdDedEki->get(iEkiOrder);
				CentDedEkiJikoku	aCentDedEkiJikoku =
					pCentDedRessya->getCentDedEkiJikoku(iEkiOrder);
				int idxRessyasyubetsu
					= pCentDedRessya->getRessyasyubetsuIndex();
				*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
				int iValidSihatsuEki = pCentDedRessya->getValidSihatsuEki();
				int iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();

				tstring strText = _T("");

				if (iValidSihatsuEki == -1 || iValidSyuuchakuEki == -1)
				{
					strText = _T("");
				}
				else if (iEkiOrder < iValidSihatsuEki && iValidSihatsuEki != -1)
				{
					if (pCentDedRessya->getFirstOperation().getBOperation() == CentDedBeforeOperation::BOperation_Outer
						&& m_bDisplayOuterTerminalShihatsu)
					{
						strText = (LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_KEIYUNASI);//"||"

					}
					else if (iSyubetsuChangeEkiOrder != -1)
					{
						strText = (LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_KEIYUNASI);//"||"
					}
					else if (iReleaseEkiOrder == iEkiOrder &&
						aCdDedEki.getJikokuhyouChakuJikokuDisplay())
					{
						strText = (LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_KEIYUNASI);//"||"
					}
					else if (iReleaseEkiOrder < iEkiOrder && iReleaseEkiOrder != -1)
					{
						strText = (LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_KEIYUNASI);//"||"
					}
				}
				else if (iEkiOrder > iValidSyuuchakuEki && iValidSyuuchakuEki != -1)
				{
					if (pCentDedRessya->getLastOperation().getAOperation() == CentDedAfterOperation::AOperation_Outer
						&& m_bDisplayOuterTerminalShuchaku)
					{
						strText = (LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_KEIYUNASI);//"||"
					}
					else if(iConnectEkiOrder> iEkiOrder &&iConnectEkiOrder!=-1)
					{
						strText = (LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_KEIYUNASI);//"||"
					}
					else if(iConnectEkiOrder == iEkiOrder &&
						aCdDedEki.getJikokuhyouHatsuJikokuDisplay())
					{
						strText = (LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_KEIYUNASI);//"||"
					}
				}
				else if (aCentDedEkiJikoku.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_None)
				{
					//始発駅から終着駅の間は、運行なし駅に経由なしマークを表示します
					strText = (LPCTSTR)MfcUtil::LoadCString(
						IDS_WORD_JIKOKUHYOU_KEIYUNASI);//"||"
				}
				/**
					停車・通過の場合
					前後のいずれかが、停車または通過であるもしくは、
					路線の始発駅もしくは終着駅である
					(iEkiOrder==0の時に、isRunBetweenNextEki(iEkiOrder)がfalseな場合は、iValidSihatsuEkiが0にならない
						→iEkiOrder < iValidSihatsuEkiのif節に引っかかるから、終着駅の場合も同様)
				*/
				else if(iEkiOrder == 0 ||
					iEkiOrder == muCdDedEki->size()-1 || 
					pCentDedRessya->isRunBetweenNextEki(iEkiOrder - 1) ||
					pCentDedRessya->isRunBetweenNextEki(iEkiOrder))
				{
					CentDedEkiCont::CdDedEki aCdDedEki = muCdDedEki->get(iEkiOrder);
					CentDedEkiTrack2Cont aCentDedEkiTrack2Cont = aCdDedEki.getCentDedEkiTrack2Cont();

					strText = aCentDedEkiTrack2Cont.get(
						aCentDedEkiJikoku.getRessyaTrackIndex()).getTrackRyakusyou(pCentDedRessya->getRessyahoukou());
					/*int idxRessyasyubetsu
						= pCentDedRessya->getRessyasyubetsuIndex();
					*pCDcDrawCell = createCDcdEkijikoku(idxRessyasyubetsu);*/
				}
				/**
					前後ともにisRunBetweenNextEki=falseの場合、この欄を経由無し表示にします。
				*/
				else
				{
					strText = (LPCTSTR)MfcUtil::LoadCString(
						IDS_WORD_JIKOKUHYOU_KEIYUNASI);//"||"
				}

				/**
					次駅が解結駅の場合、この欄に↴印を表示することがあります
					(1)次駅が解結駅かつ有効な始発駅
					(2)次駅が着時刻又は発時刻のどちらかのみ表示
					(3)この欄の直下が、次駅の項な場合。
				*/
				if (iEkiOrder + 1 == iValidSihatsuEki &&
					iEkiOrder + 1 == iReleaseEkiOrder)
				{
					CentDedEkiCont::CdDedEki aCdDedEkiNext = muCdDedEki->get(iEkiOrder + 1);
					if (!aCdDedEkiNext.getJikokuhyouChakuJikokuDisplay() ||
						!aCdDedEkiNext.getJikokuhyouHatsuJikokuDisplay())
					{
						int iYColumnNumberNext = iYColumnNumber + 1;
						CdYColSpec aCdYColSpecNext = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberNext);
						if (aCdYColSpecNext.getEkiOrder() == iEkiOrder + 1)
						{
							strText = (LPCTSTR)MfcUtil::LoadCString(
								IDS_WORD_JIKOKUHYOU_RELEASE);
						}
					}
				}
				/**
					前駅が増結駅の場合、この欄に↳印を表示することがあります
					(1)前駅が増結駅かつ有効な終着駅
					(2)前駅が着時刻又は発時刻のどちらかのみ表示
					(3)この欄の直上が、前駅の項な場合。
				*/
				if (iEkiOrder - 1 == iValidSyuuchakuEki &&
					iEkiOrder - 1 == iConnectEkiOrder &&
					iValidSyuuchakuEki != -1)
				{
					CentDedEkiCont::CdDedEki aCdDedEkiPrev = muCdDedEki->get(iEkiOrder - 1);
					if (!aCdDedEkiPrev.getJikokuhyouChakuJikokuDisplay() ||
						!aCdDedEkiPrev.getJikokuhyouHatsuJikokuDisplay())
					{
						int iYColumnNumberPrev = iYColumnNumber - 1;
						CdYColSpec aCdYColSpecPrev = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberPrev);
						if (aCdYColSpecPrev.getEkiOrder() == iEkiOrder - 1)
						{
							strText = (LPCTSTR)MfcUtil::LoadCString(
								IDS_WORD_JIKOKUHYOU_CONNECT);
						}
					}
				}

				pCDcDrawCell->setText(strText);
			}
		}
	}
}

void CCellBuilderCustomize::update02_02_02_19_setRessya_Ressyabangou(
	int iXColumnNumber,
	int iYColumnNumber,
	const CentDedRessya* pCentDedRessya,
	int iEkiOrder,
	int iSyubetsuChangeEkiOrder,
	int iConnectEkiOrder,
	int iReleaseEkiOrder,
	CWndJikokuhyou* pCWndJikokuhyou)
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	const CentDedRosen* pCentDedRosen =
		m_pCDedRosenFileData->getCentDedRosen();
	const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki =
		pCentDedRosen->getCentDedEkiCont()->getMuPtr(
			pCentDedRessya->getRessyahoukou());
	//CDcdTargetGetDC	aCDcdTarget(NULL);
	// --------------------------------
	//CdYColSpec aCdYColSpec(
	//	CdYColSpec::ColumnType_EkiRessyabangou,
	//	iEkiOrder);
	//int iYColumnNumber =
	//	m_CdYColSpecCont.ColumnNumberFromSpec(aCdYColSpec, false);
	CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell(
		iXColumnNumber, iYColumnNumber);
	// --------------------------------
	//CdDedDispProp	aCdDedDispProp = m_pCDedRosenFileData->getCdDedDispProp() ;
	//tstring strCellExtent( aCdDedDispProp.getJikokuhyouRessyaWidth() , '0' ) ;
	//strCellExtent = セルの大きさの目安となる文字列です。
	//	時刻表列車セルの幅(文字数) CdDedDispProp::m_iJikokuhyouRessyaWidth
	//	の数だけ '0' が並んだ文字列です

	if (pCDcdGridCell != 0)
	{
		typedef CDcdTextbox CDcDrawCell;
		Ou<CDcDrawCell> pCDcDrawCell;
		// --------------------------------
		//　(2.2.*.1)　セル(ColumnType_Ressya,ColumnType_Ressyabangou) の
		//	結合セルを設定
		pCDcdGridCell->setAttachCellCount(1, 1);

		//　(2.2.*.2)　セル の	DcDrawオブジェクトの型を設定
		//	( CDcdTextbox とする)。
		{
			pCDcDrawCell = dynamic_castOu<CDcDrawCell>(
				pCDcdGridCell->getIfDcDraw());
			if (pCDcDrawCell == NULL)
			{
				pCDcDrawCell = OuNew<CDcDrawCell>(new CDcDrawCell);
				pCDcdGridCell->setIfDcDraw(pCDcDrawCell);
			}
		}

		//　(2.2.*.3)　セルの DcDrawオブジェクトに、属性を設定。
		{
			CentDedEkiCont::CdDedEki aCdDedEki = muCdDedEki->get(iEkiOrder);
			int idxRessyasyubetsu
				= pCentDedRessya->getRessyasyubetsuIndex();
			/**
				この欄に表示するもの
				・種別変更が有効な場合 (iSyubetsuChangeEkiOrder!=-1)
					iSyubetsuChangeEkiOrder<= iEkiOrder <iValidSihatsuEki
						「||」(経由無し)
					iEkiOrder=iValidSihatsuEki
						列車番号
					iValidSihatsuEki<iEkiOrder<iValidSyuuchakuEki
						isRunbetweenがtrueの場合またはgetJikokuhyouChakujikokuDisplayがfalseの場合
							getJikokuhyouRessyabangouDisplayが2の場合列車番号
							1の場合「↓」
						その他の場合
							「||」
								
					iValidSyuuchakuEki<=iEkiOrder
						空白
				・種別変更ではない場合
					iEkiOrder<iValidSihatsuEki
						空白
					iEkiOrder=iValidSihatsuEki
						getJikokuhyouRessyabangouDisplayが2の場合列車番号
						1の場合空白
					iValidSihatsuEki<iEkiOrder<iValidSyuuchakuEki
						isRunbetweenがtrueの場合またはgetJikokuhyouChakujikokuDisplayがfalseの場合
							getJikokuhyouRessyabangouDisplayが2の場合列車番号
							1の場合「↓」
						その他の場合
							「||」
					iValidSyuuchakuEki<=iEkiOrder
						空白
			*/
			int iValidSihatsuEki = pCentDedRessya->getValidSihatsuEki();
			int iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();
			tstring strText = _T("");
			if (iValidSihatsuEki == -1 || iValidSyuuchakuEki == -1)
			{
				strText = _T("");
			}
			else if (iSyubetsuChangeEkiOrder != -1 &&
				iEkiOrder < iValidSihatsuEki)
			{
				strText = (LPCTSTR)MfcUtil::LoadCString(
					IDS_WORD_JIKOKUHYOU_KEIYUNASI);//"||"
			}
			else if (iEkiOrder < iValidSihatsuEki)
			{
				strText = _T("");
			}
			else if (iValidSihatsuEki == iEkiOrder)
			{
				if (iSyubetsuChangeEkiOrder != -1 ||
					aCdDedEki.getJikokuhyouRessyabangouDisplay() == 2)
				{
					strText = pCentDedRessya->getRessyabangou();
				}
				else
				{
					strText = _T("");
				}
			}
			else if (iValidSihatsuEki < iEkiOrder&&
				iEkiOrder < iValidSyuuchakuEki)
			{
				if (pCentDedRessya->isRunBetweenNextEki(iEkiOrder)||
					!aCdDedEki.getJikokuhyouChakuJikokuDisplay())
				{
					if (aCdDedEki.getJikokuhyouRessyabangouDisplay() == 2)
					{
						strText = pCentDedRessya->getRessyabangou();
					}
					else
					{
						strText = _T("↓");
					}
				}
				else
				{
					strText = (LPCTSTR)MfcUtil::LoadCString(
						IDS_WORD_JIKOKUHYOU_KEIYUNASI);
				}
			}
			else if (iValidSyuuchakuEki <= iEkiOrder)
			{
				strText = _T("");
			}

			/**
				次駅が解結駅の場合、この欄に↴印を表示することがあります
				(1)次駅が解結駅かつ有効な始発駅
				(2)次駅が着時刻又は発時刻のどちらかのみ表示
				(3)この欄の直下が、次駅の項な場合。
			*/
			if (iEkiOrder + 1 == iValidSihatsuEki &&
				iEkiOrder + 1 == iReleaseEkiOrder)
			{
				CentDedEkiCont::CdDedEki aCdDedEkiNext = muCdDedEki->get(iEkiOrder + 1);
				if (!aCdDedEkiNext.getJikokuhyouChakuJikokuDisplay() ||
					!aCdDedEkiNext.getJikokuhyouHatsuJikokuDisplay())
				{
					int iYColumnNumberNext = iYColumnNumber + 1;
					CdYColSpec aCdYColSpecNext = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberNext);
					if (aCdYColSpecNext.getEkiOrder() == iEkiOrder + 1)
					{
						strText = (LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_RELEASE);
					}
				}
			}
			/**
				前駅が増結駅の場合、この欄に↳印を表示することがあります
				(1)前駅が増結駅かつ有効な終着駅
				(2)前駅が着時刻又は発時刻のどちらかのみ表示
				(3)この欄の直上が、前駅の項な場合。
			*/
			if (iEkiOrder - 1 == iValidSyuuchakuEki &&
				iEkiOrder - 1 == iConnectEkiOrder &&
				iValidSyuuchakuEki != -1)
			{
				CentDedEkiCont::CdDedEki aCdDedEkiPrev = muCdDedEki->get(iEkiOrder - 1);
				if (!aCdDedEkiPrev.getJikokuhyouChakuJikokuDisplay() ||
					!aCdDedEkiPrev.getJikokuhyouHatsuJikokuDisplay())
				{
					int iYColumnNumberPrev = iYColumnNumber - 1;
					CdYColSpec aCdYColSpecPrev = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberPrev);
					if (aCdYColSpecPrev.getEkiOrder() == iEkiOrder - 1)
					{
						strText = (LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_CONNECT);
					}
				}
			}

			*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
			pCDcDrawCell->setText(strText);
		}

		//セルの背景色を指定します。
		{
			pCDcDrawCell->setCdBrushProp(CdColorProp(255, 255, 255));
		}
	}
}

void CCellBuilderCustomize::update02_02_02_20_setRessya_OperationNumber(
	int iXColumnNumber,
	int iYColumnNumber,
	const CentDedRessya * pCentDedRessya,
	int iEkiOrder,
	int iSyubetsuChangeEkiOrder,
	int iConnectEkiOrder,
	int iReleaseEkiOrder,
	CWndJikokuhyou * pCWndJikokuhyou)
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	const CentDedRosen* pCentDedRosen =
		m_pCDedRosenFileData->getCentDedRosen();
	const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki =
		pCentDedRosen->getCentDedEkiCont()->getMuPtr(
			pCentDedRessya->getRessyahoukou());
	//CDcdTargetGetDC	aCDcdTarget(NULL);
	// --------------------------------
	//CdYColSpec aCdYColSpec(
	//	CdYColSpec::ColumnType_EkiOperationNumber,
	//	iEkiOrder);
	//int iYColumnNumber =
	//	m_CdYColSpecCont.ColumnNumberFromSpec(aCdYColSpec, false);
	CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell(
		iXColumnNumber, iYColumnNumber);
	// --------------------------------
	if (pCDcdGridCell != 0)
	{
		typedef CDcdTextbox CDcDrawCell;
		Ou<CDcDrawCell> pCDcDrawCell;
		// --------------------------------
		//　(2.2.*.1)　セル(ColumnType_Ressya,ColumnType_Ressyabangou) の
		//	結合セルを設定
		pCDcdGridCell->setAttachCellCount(1, 1);

		//　(2.2.*.2)　セル の	DcDrawオブジェクトの型を設定
		//	( CDcdTextbox とする)。
		{
			pCDcDrawCell = dynamic_castOu<CDcDrawCell>(
				pCDcdGridCell->getIfDcDraw());
			if (pCDcDrawCell == NULL)
			{
				pCDcDrawCell = OuNew<CDcDrawCell>(new CDcDrawCell);
				pCDcdGridCell->setIfDcDraw(pCDcDrawCell);
			}
		}

		//　(2.2.*.3)　セルの DcDrawオブジェクトに、属性を設定。
		{
			CentDedEkiCont::CdDedEki aCdDedEki = muCdDedEki->get(iEkiOrder);
			int idxRessyasyubetsu
				= pCentDedRessya->getRessyasyubetsuIndex();
			/**
				この欄に表示するもの
				・種別変更が有効な場合 (iSyubetsuChangeEkiOrder!=-1)
					iSyubetsuChangeEkiOrder<= iEkiOrder <iValidSihatsuEki
						「||」(経由無し)
					iEkiOrder=iValidSihatsuEki
						strOperationNumber
					iValidSihatsuEki<iEkiOrder<iValidSyuuchakuEki
						isRunbetweenがtrueの場合またはgetJikokuhyouChakujikokuDisplayがfalseの場合
							getJikokuhyouOperationNumberDisplayが2の場合運用番号
							1の場合「↓」
						その他の場合
							「||」
					iValidSyuuchakuEki<=iEkiOrder
						空白
				・種別変更ではない場合
					iEkiOrder<iValidSihatsuEki
						空白
					iEkiOrder=iValidSihatsuEki
						getJikokuhyouOperationNumberDisplayが2の場合運用番号
						1の場合空白
					iValidSihatsuEki<iEkiOrder<iValidSyuuchakuEki
						isRunbetweenがtrueの場合またはgetJikokuhyouChakujikokuDisplayがfalseの場合
							getJikokuhyouOperationNumberDisplayが2の場合運用番号
							1の場合「↓」
						その他の場合
							「||」
					iValidSyuuchakuEki<=iEkiOrder
						空白
			*/
			int iValidSihatsuEki = pCentDedRessya->getValidSihatsuEki();
			int iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();
			tstring strText;
			if (iValidSihatsuEki == -1 || iValidSyuuchakuEki == -1)
			{
				strText = _T("");
			}
			else if (iSyubetsuChangeEkiOrder != -1 &&
				iEkiOrder < iValidSihatsuEki)
			{
				strText = (LPCTSTR)MfcUtil::LoadCString(
					IDS_WORD_JIKOKUHYOU_KEIYUNASI);//"||"
			}
			else if (iEkiOrder < iValidSihatsuEki)
			{
				strText = _T("");
			}
			else if (iValidSihatsuEki == iEkiOrder)
			{
				if (iSyubetsuChangeEkiOrder != -1 ||
					aCdDedEki.getJikokuhyouOperationNumberDisplay() == 2)
				{
					strText = joinc('+', pCentDedRessya->getOperationNumber(iEkiOrder));
					//strText = strOperationNumber;
				}
				else
				{
					strText = _T("");
				}
			}
			else if (iValidSihatsuEki < iEkiOrder&&
				iEkiOrder < iValidSyuuchakuEki)
			{
				if (pCentDedRessya->isRunBetweenNextEki(iEkiOrder)||
					!aCdDedEki.getJikokuhyouChakuJikokuDisplay())
				{
					if (aCdDedEki.getJikokuhyouOperationNumberDisplay() == 2)
					{
						strText = joinc('+', pCentDedRessya->getOperationNumber(iEkiOrder));
						//strText = strOperationNumber;
					}
					else
					{
						strText = _T("↓");
					}
				}
				else
				{
					strText = (LPCTSTR)MfcUtil::LoadCString(
						IDS_WORD_JIKOKUHYOU_KEIYUNASI);
				}
			}
			else if (iValidSyuuchakuEki <= iEkiOrder)
			{
				strText = _T("");
			}

			/**
				次駅が解結駅の場合、この欄に↴印を表示することがあります
				(1)次駅が解結駅かつ有効な始発駅
				(2)次駅が着時刻又は発時刻のどちらかのみ表示
				(3)この欄の直下が、次駅の項な場合。
			*/
			if (iEkiOrder + 1 == iValidSihatsuEki &&
				iEkiOrder + 1 == iReleaseEkiOrder)
			{
				CentDedEkiCont::CdDedEki aCdDedEkiNext = muCdDedEki->get(iEkiOrder + 1);
				if (!aCdDedEkiNext.getJikokuhyouChakuJikokuDisplay() ||
					!aCdDedEkiNext.getJikokuhyouHatsuJikokuDisplay())
				{
					int iYColumnNumberNext = iYColumnNumber + 1;
					CdYColSpec aCdYColSpecNext = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberNext);
					if (aCdYColSpecNext.getEkiOrder() == iEkiOrder + 1)
					{
						strText = (LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_RELEASE);
					}
				}
			}
			/**
				前駅が増結駅の場合、この欄に↳印を表示することがあります
				(1)前駅が増結駅かつ有効な終着駅
				(2)前駅が着時刻又は発時刻のどちらかのみ表示
				(3)この欄の直上が、前駅の項な場合。
			*/
			if (iEkiOrder - 1 == iValidSyuuchakuEki &&
				iEkiOrder - 1 == iConnectEkiOrder &&
				iValidSyuuchakuEki != -1)
			{
				CentDedEkiCont::CdDedEki aCdDedEkiPrev = muCdDedEki->get(iEkiOrder - 1);
				if (!aCdDedEkiPrev.getJikokuhyouChakuJikokuDisplay() ||
					!aCdDedEkiPrev.getJikokuhyouHatsuJikokuDisplay())
				{
					int iYColumnNumberPrev = iYColumnNumber - 1;
					CdYColSpec aCdYColSpecPrev = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberPrev);
					if (aCdYColSpecPrev.getEkiOrder() == iEkiOrder - 1)
					{
						strText = (LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_CONNECT);
					}
				}
			}
			*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
			pCDcDrawCell->setText(strText);
		}

		//セルの背景色を指定します。
		{
			pCDcDrawCell->setCdBrushProp(CdColorProp(255, 255, 255));
		}
	}
}


void CCellBuilderCustomize::update02_02_02_21_setRessya_Ressyasyubetsu(
	int iXColumnNumber,
	int iYColumnNumber,
	const CentDedRessya* pCentDedRessya,
	int iEkiOrder,
	int iSyubetsuChangeEkiOrder,
	int iConnectEkiOrder,
	int iReleaseEkiOrder,
	CWndJikokuhyou* pCWndJikokuhyou)
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	const CentDedRosen* pCentDedRosen =
		m_pCDedRosenFileData->getCentDedRosen();
	const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki =
		pCentDedRosen->getCentDedEkiCont()->getMuPtr(
			pCentDedRessya->getRessyahoukou());
	// --------------------------------
	//CDcdTargetGetDC	aCDcdTarget(NULL);
	// --------------------------------
	//CdYColSpec aCdYColSpec(
	//	CdYColSpec::ColumnType_EkiRessyasyubetsu,
	//	iEkiOrder);
	//int iYColumnNumber =
	//	m_CdYColSpecCont.ColumnNumberFromSpec(aCdYColSpec, false);
	CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell(
		iXColumnNumber, iYColumnNumber);
	// --------------------------------
	if (pCDcdGridCell != 0)
	{
		typedef CDcdTextbox CDcDrawCell;
		Ou<CDcDrawCell> pCDcDrawCell;
		// --------------------------------
		//　(2.2.*.1)　セル(ColumnType_Ressya,ColumnType_Ressyabangou) の
		//	結合セルを設定
		pCDcdGridCell->setAttachCellCount(1, 1);

		//　(2.2.*.2)　セル の	DcDrawオブジェクトの型を設定
		//	( CDcdTextbox とする)。
		{
			pCDcDrawCell = dynamic_castOu<CDcDrawCell>(
				pCDcdGridCell->getIfDcDraw());
			if (pCDcDrawCell == NULL)
			{
				pCDcDrawCell = OuNew<CDcDrawCell>(new CDcDrawCell);
				pCDcdGridCell->setIfDcDraw(pCDcDrawCell);
			}
		}

		//　(2.2.*.3)　セルの DcDrawオブジェクトに、属性を設定。
		{
			CentDedEkiCont::CdDedEki aCdDedEki = muCdDedEki->get(iEkiOrder);
			int idxRessyasyubetsu
				= pCentDedRessya->getRessyasyubetsuIndex();
			const CentDedRessyasyubetsu* pCentDedRessyasyubetsu = NULL;
			{
				pCentDedRessyasyubetsu =
					pCentDedRosen->getCentDedRessyasyubetsuCont()->getMuPtr()
					->get(idxRessyasyubetsu);
				if (m_bDisplayParentSyubetsu && pCentDedRessyasyubetsu->getParentSyubetsuIndex() >= 0)
				{
					pCentDedRessyasyubetsu
						= pCentDedRosen->getCentDedRessyasyubetsuCont()->getMuPtr()
						->get(pCentDedRessyasyubetsu->getParentSyubetsuIndex());
				}
				if (pCentDedRessyasyubetsu == NULL)
				{
					pCentDedRessyasyubetsu =
						pCentDedRosen->getCentDedRessyasyubetsuCont()
						->getMuPtr()->get(0);
				}
			}
			//pCentDedRessyasyubetsu = 列車種別オブジェクト
			//	(指定がないなら、列車種別[0])

			tstring strRessyasyubetsu;
			if (!pCentDedRessya->isNull())
			{
				strRessyasyubetsu = pCentDedRessyasyubetsu->getRyakusyou();
			}
			/**
				この欄に表示するもの
				・種別変更が有効な場合 (iSyubetsuChangeEkiOrder!=-1)
					iSyubetsuChangeEkiOrder<= iEkiOrder <iValidSihatsuEki
						「||」(経由無し)
					iEkiOrder=iValidSihatsuEki
						種別名
					iValidSihatsuEki<iEkiOrder<iValidSyuuchakuEki
						isRunbetweenがtrueの場合またはgetJikokuhyouChakujikokuDisplayがfalseの場合
							getJikokuhyouRessyasyubetsuDisplayが2の場合種別名
							1の場合「↓」
						その他の場合
							「||」
					iValidSyuuchakuEki<=iEkiOrder
						空白
				・種別変更ではない場合
					iEkiOrder<iValidSihatsuEki
						空白
					iEkiOrder=iValidSihatsuEki
						getJikokuhyouRessyabangouDisplayが2の場合種別名
						1の場合空白
					iValidSihatsuEki<iEkiOrder<iValidSyuuchakuEki
						isRunbetweenがtrueの場合またはgetJikokuhyouChakujikokuDisplayがfalseの場合
							getJikokuhyouRessyasyubetsuDisplayが2の場合種別名
							1の場合「↓」
						その他の場合
							「||」
					iValidSyuuchakuEki<=iEkiOrder
						空白
			*/
			int iValidSihatsuEki = pCentDedRessya->getValidSihatsuEki();
			int iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();
			*pCDcDrawCell = createCDcdEkijikoku(idxRessyasyubetsu);
			tstring strText;
			if (iValidSihatsuEki == -1 || iValidSyuuchakuEki == -1)
			{
				strText = _T("");
			}
			else if (iSyubetsuChangeEkiOrder != -1 &&
				iEkiOrder < iValidSihatsuEki)
			{
				*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
				strText = (LPCTSTR)MfcUtil::LoadCString(
					IDS_WORD_JIKOKUHYOU_KEIYUNASI);//"||"
			}
			else if (iEkiOrder < iValidSihatsuEki)
			{
				strText = _T("");
			}
			else if (iValidSihatsuEki == iEkiOrder)
			{
				if (iSyubetsuChangeEkiOrder != -1 ||
					aCdDedEki.getJikokuhyouRessyaSyubetsuDisplay() == 2)
				{
					strText = strRessyasyubetsu;
				}
				else
				{
					strText = _T("");
				}
			}
			else if (iValidSihatsuEki < iEkiOrder&&
				iEkiOrder < iValidSyuuchakuEki)
			{
				if (pCentDedRessya->isRunBetweenNextEki(iEkiOrder) ||
					!aCdDedEki.getJikokuhyouChakuJikokuDisplay())
				{
					if (aCdDedEki.getJikokuhyouRessyaSyubetsuDisplay() == 2)
					{
						strText = strRessyasyubetsu;
					}
					else
					{
						strText = _T("↓");
					}
				}
				else
				{
					*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
					strText = (LPCTSTR)MfcUtil::LoadCString(
						IDS_WORD_JIKOKUHYOU_KEIYUNASI);
				}
			}
			else if (iValidSyuuchakuEki <= iEkiOrder)
			{
				strText = _T("");
			}
			/**
				次駅が解結駅の場合、この欄に↴印を表示することがあります
				(1)次駅が解結駅かつ有効な始発駅
				(2)次駅が着時刻又は発時刻のどちらかのみ表示
				(3)この欄の直下が、次駅の項な場合。
			*/
			if (iEkiOrder + 1 == iValidSihatsuEki &&
				iEkiOrder + 1 == iReleaseEkiOrder)
			{
				CentDedEkiCont::CdDedEki aCdDedEkiNext = muCdDedEki->get(iEkiOrder + 1);
				if (!aCdDedEkiNext.getJikokuhyouChakuJikokuDisplay() ||
					!aCdDedEkiNext.getJikokuhyouHatsuJikokuDisplay())
				{
					int iYColumnNumberNext = iYColumnNumber + 1;
					CdYColSpec aCdYColSpecNext = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberNext);
					if (aCdYColSpecNext.getEkiOrder() == iEkiOrder + 1)
					{
						strText = (LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_RELEASE);
					}
				}
			}
			/**
				前駅が増結駅の場合、この欄に↳印を表示することがあります
				(1)前駅が増結駅かつ有効な終着駅
				(2)前駅が着時刻又は発時刻のどちらかのみ表示
				(3)この欄の直上が、前駅の項な場合。
			*/
			if (iEkiOrder - 1 == iValidSyuuchakuEki &&
				iEkiOrder - 1 == iConnectEkiOrder &&
				iValidSyuuchakuEki != -1)
			{
				CentDedEkiCont::CdDedEki aCdDedEkiPrev = muCdDedEki->get(iEkiOrder - 1);
				if (!aCdDedEkiPrev.getJikokuhyouChakuJikokuDisplay() ||
					!aCdDedEkiPrev.getJikokuhyouHatsuJikokuDisplay())
				{
					int iYColumnNumberPrev = iYColumnNumber - 1;
					CdYColSpec aCdYColSpecPrev = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberPrev);
					if (aCdYColSpecPrev.getEkiOrder() == iEkiOrder - 1)
					{
						strText = (LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_CONNECT);
					}
				}
			}
			pCDcDrawCell->setText(strText);
		}

		//セルの背景色を指定します。
		{
			pCDcDrawCell->setCdBrushProp(CdColorProp(255, 255, 255));
		}
	}

}

void CCellBuilderCustomize::update02_02_02_22_setRessya_Ressyamei(
	int iXColumnNumber,
	int iYColumnNumber,
	const CentDedRessya* pCentDedRessya,
	int iEkiOrder,
	int iSyubetsuChangeEkiOrder,
	int iConnectEkiOrder,
	int iReleaseEkiOrder,
	CWndJikokuhyou* pCWndJikokuhyou)
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	const CentDedRosen* pCentDedRosen =
		m_pCDedRosenFileData->getCentDedRosen();
	const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki =
		pCentDedRosen->getCentDedEkiCont()->getMuPtr(
			pCentDedRessya->getRessyahoukou());
	// --------------------------------
	//CDcdTargetGetDC	aCDcdTarget(NULL);
	// --------------------------------
	//CdYColSpec aCdYColSpec(
	//	CdYColSpec::ColumnType_EkiRessyamei,
	//	iEkiOrder);
	//int iYColumnNumber =
	//	m_CdYColSpecCont.ColumnNumberFromSpec(aCdYColSpec, false);
	CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell(
		iXColumnNumber, iYColumnNumber);
	// --------------------------------
	if (pCDcdGridCell != 0)
	{
		typedef CDcdTextboxV3 CDcDrawCell;
		Ou<CDcDrawCell> pCDcDrawCell;
		// --------------------------------
		//　(2.2.*.1)　セル(ColumnType_Ressya,ColumnType_Ressyabangou) の
		//	結合セルを設定
		pCDcdGridCell->setAttachCellCount(1, 1);

		//　(2.2.*.2)　セル の	DcDrawオブジェクトの型を設定
		//	( CDcdTextbox とする)。
		{
			pCDcDrawCell = dynamic_castOu<CDcDrawCell>(
				pCDcdGridCell->getIfDcDraw());
			if (pCDcDrawCell == NULL)
			{
				pCDcDrawCell = OuNew<CDcDrawCell>(new CDcDrawCell);
				pCDcdGridCell->setIfDcDraw(pCDcDrawCell);
			}
		}
		//　(2.2.*.3)　セルの DcDrawオブジェクトに、属性を設定。
		{
			CentDedEkiCont::CdDedEki aCdDedEki = muCdDedEki->get(iEkiOrder);
			int idxRessyasyubetsu
				= pCentDedRessya->getRessyasyubetsuIndex();
			//tstring strText;
			//if (!pCentDedRessya->isNull())
			//{
			//	strText = pCentDedRessya->getRessyamei();
			//}
			/**
				この欄に表示するもの
				・種別変更が有効な場合 (iSyubetsuChangeEkiOrder!=-1)
					iSyubetsuChangeEkiOrder<= iEkiOrder <iValidSihatsuEki
						「空白」
					iEkiOrder=iValidSihatsuEki
						列車名
					iValidSihatsuEki<iEkiOrder<iValidSyuuchakuEki
						isRunbetweenがtrueの場合もしくはgetJikokuhyouChakuJikokuDisplay()がfalseの場合
							getJikokuhyouRessyabangouDisplayが2の場合列車名
							1の場合「「空白」
						その他の場合「空白」
					iValidSyuuchakuEki<=iEkiOrder
						空白
				・種別変更ではない場合
					iEkiOrder<iValidSihatsuEki
						空白
					iEkiOrder=iValidSihatsuEki
						getJikokuhyouRessyabangouDisplayが2の場合列車名
						1の場合空白
					iValidSihatsuEki<iEkiOrder<iValidSyuuchakuEki
						isRunbetweenがtrueの場合もしくはgetJikokuhyouChakuJikokuDisplay()がfalseの場合
							getJikokuhyouRessyabangouDisplayが2の場合列車名
							1の場合「空白」
						その他の場合「空白」
					iValidSyuuchakuEki<=iEkiOrder
						空白
			*/
			int iValidSihatsuEki = pCentDedRessya->getValidSihatsuEki();
			int iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();
			tstring strText;
			if (iValidSihatsuEki == -1 || iValidSyuuchakuEki == -1)
			{
				strText = _T("");
			}
			else if (iValidSihatsuEki == iEkiOrder)
			{
				if (iSyubetsuChangeEkiOrder != -1 ||
					aCdDedEki.getJikokuhyouRessyameiDisplay() == 2)
				{
					strText = pCentDedRessya->getRessyamei();
				}
				else
				{
					strText = _T("");
				}
			}
			else if (iValidSihatsuEki < iEkiOrder &&
				iEkiOrder < iValidSyuuchakuEki &&
				aCdDedEki.getJikokuhyouRessyameiDisplay() == 2 &&
				(pCentDedRessya->isRunBetweenNextEki(iEkiOrder) ||
					!aCdDedEki.getJikokuhyouChakuJikokuDisplay()))
			{
				strText = pCentDedRessya->getRessyamei();
			}
			else
			{
				strText = _T("");
			}
			*pCDcDrawCell = createCDcdRessyamei(idxRessyasyubetsu);
			pCDcDrawCell->setText(strText);
		}

		//セルの背景色を指定します。
		{
			pCDcDrawCell->setCdBrushProp(CdColorProp(255, 255, 255));
		}
	}


}

void CCellBuilderCustomize::update02_02_02_23_setRessya_Gousuu(
	int iXColumnNumber,
	int iYColumnNumber,
	const CentDedRessya* pCentDedRessya,
	int iEkiOrder,
	int iSyubetsuChangeEkiOrder,
	int iConnectEkiOrder,
	int iReleaseEkiOrder,
	CWndJikokuhyou* pCWndJikokuhyou)
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	const CentDedRosen* pCentDedRosen =
		m_pCDedRosenFileData->getCentDedRosen();
	const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki =
		pCentDedRosen->getCentDedEkiCont()->getMuPtr(
			pCentDedRessya->getRessyahoukou());
	// --------------------------------
	//CDcdTargetGetDC	aCDcdTarget(NULL);
	// --------------------------------
	//CdYColSpec aCdYColSpec(
	//	CdYColSpec::ColumnType_EkiGousuu,
	//	iEkiOrder);
	//int iYColumnNumber =
	//	m_CdYColSpecCont.ColumnNumberFromSpec(aCdYColSpec, false);
	CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell(
		iXColumnNumber, iYColumnNumber);
	// --------------------------------
	if (pCDcdGridCell != 0)
	{
		typedef CDcdTextbox CDcDrawCell;
		Ou<CDcDrawCell> pCDcDrawCell;
		// --------------------------------
		//　(2.2.*.1)　セル(ColumnType_Ressya,ColumnType_Ressyabangou) の
		//	結合セルを設定
		pCDcdGridCell->setAttachCellCount(1, 1);

		//　(2.2.*.2)　セル の	DcDrawオブジェクトの型を設定
		//	( CDcdTextbox とする)。
		{
			pCDcDrawCell = dynamic_castOu<CDcDrawCell>(
				pCDcdGridCell->getIfDcDraw());
			if (pCDcDrawCell == NULL)
			{
				pCDcDrawCell = OuNew<CDcDrawCell>(new CDcDrawCell);
				pCDcdGridCell->setIfDcDraw(pCDcDrawCell);
			}
		}
		//　(2.2.*.3)　セルの DcDrawオブジェクトに、属性を設定。
		{
			CentDedEkiCont::CdDedEki aCdDedEki = muCdDedEki->get(iEkiOrder);
			int idxRessyasyubetsu
				= pCentDedRessya->getRessyasyubetsuIndex();
			//tstring strText = pCentDedRessya->getGousuu();
			/**
				この欄に表示するもの
				・種別変更が有効な場合 (iSyubetsuChangeEkiOrder!=-1)
					iSyubetsuChangeEkiOrder<= iEkiOrder <iValidSihatsuEki
						「空白」
					iEkiOrder=iValidSihatsuEki
						号数
					iValidSihatsuEki<iEkiOrder<iValidSyuuchakuEki
						isRunbetweenがtrueの場合もしくはgetJikokuhyouChakuJikokuDisplay()がfalseの場合
							getJikokuhyouRessyabangouDisplayが2の場合種別名
							1の場合「「空白」
						その他の場合「空白」
					iValidSyuuchakuEki<=iEkiOrder
						空白
				・種別変更ではない場合
					iEkiOrder<iValidSihatsuEki
						空白
					iEkiOrder=iValidSihatsuEki
						getJikokuhyouRessyabangouDisplayが2の場合種別名
						1の場合空白
					iValidSihatsuEki<iEkiOrder<iValidSyuuchakuEki
						isRunbetweenがtrueの場合もしくはgetJikokuhyouChakuJikokuDisplay()がfalseの場合
							getJikokuhyouRessyabangouDisplayが2の場合種別名
							1の場合「空白」
						その他の場合「空白」
					iValidSyuuchakuEki<=iEkiOrder
						空白
			*/
			int iValidSihatsuEki = pCentDedRessya->getValidSihatsuEki();
			int iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();
			tstring strText;
			if (iValidSihatsuEki == -1 || iValidSyuuchakuEki == -1)
			{
				strText = _T("");
			}
			else if (iValidSihatsuEki == iEkiOrder)
			{
				if (iSyubetsuChangeEkiOrder != -1 ||
					aCdDedEki.getJikokuhyouRessyameiDisplay() == 2)
				{
					strText = pCentDedRessya->getGousuu();
				}
				else
				{
					strText = _T("");
				}
			}
			else if (iValidSihatsuEki < iEkiOrder &&
				iEkiOrder < iValidSyuuchakuEki &&
				aCdDedEki.getJikokuhyouRessyameiDisplay() == 2 &&
				(pCentDedRessya->isRunBetweenNextEki(iEkiOrder) ||
					!aCdDedEki.getJikokuhyouChakuJikokuDisplay()))
			{
				strText = pCentDedRessya->getGousuu();
			}
			else
			{
				strText = _T("");
			}
			*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
			pCDcDrawCell->setText(strText);
		}

		//セルの背景色を指定します。
		{
			pCDcDrawCell->setCdBrushProp(CdColorProp(255, 255, 255));
		}
	}
}

void CCellBuilderCustomize::update02_02_02_24_setRessya_Gou(
	int iXColumnNumber,
	int iYColumnNumber,
	const CentDedRessya* pCentDedRessya,
	int iEkiOrder,
	int iSyubetsuChangeEkiOrder,
	int iConnectEkiOrder,
	int iReleaseEkiOrder,
	CWndJikokuhyou* pCWndJikokuhyou)
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	const CentDedRosen* pCentDedRosen =
		m_pCDedRosenFileData->getCentDedRosen();
	const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki =
		pCentDedRosen->getCentDedEkiCont()->getMuPtr(
			pCentDedRessya->getRessyahoukou());
	// --------------------------------
	//CDcdTargetGetDC	aCDcdTarget(NULL);
	// --------------------------------
	//CdYColSpec aCdYColSpec(
	//	CdYColSpec::ColumnType_EkiGou,
	//	iEkiOrder);
	//int iYColumnNumber =
	//	m_CdYColSpecCont.ColumnNumberFromSpec(aCdYColSpec, false);
	CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell(
		iXColumnNumber, iYColumnNumber);
	// --------------------------------
	if (pCDcdGridCell != 0)
	{
		typedef CDcdTextbox CDcDrawCell;
		Ou<CDcDrawCell> pCDcDrawCell;
		// --------------------------------
		//　(2.2.*.1)　セルの結合セルを設定
		pCDcdGridCell->setAttachCellCount(1, 1);

		//　(2.2.*.2)　セル の	DcDrawオブジェクトの型を設定
		//	( CDcdTextbox とする)。
		{
			pCDcDrawCell = dynamic_castOu<CDcDrawCell>(
				pCDcdGridCell->getIfDcDraw());
			if (pCDcDrawCell == NULL)
			{
				pCDcDrawCell = OuNew<CDcDrawCell>(new CDcDrawCell);
				pCDcdGridCell->setIfDcDraw(pCDcDrawCell);
			}
		}
		//　(2.2.*.3)　セルの DcDrawオブジェクトに、属性を設定。
		{
			CentDedEkiCont::CdDedEki aCdDedEki = muCdDedEki->get(iEkiOrder);
			int idxRessyasyubetsu
				= pCentDedRessya->getRessyasyubetsuIndex();
			/**
				この欄に表示するもの
				・種別変更が有効な場合 (iSyubetsuChangeEkiOrder!=-1)
					iSyubetsuChangeEkiOrder<= iEkiOrder <iValidSihatsuEki
						「空白」
					iEkiOrder=iValidSihatsuEki
						「号」
					iValidSihatsuEki<iEkiOrder<iValidSyuuchakuEki
						isRunbetweenがtrueの場合もしくはgetJikokuhyouChakuJikokuDisplay()がfalseの場合
							getJikokuhyouRessyabangouDisplayが2の場合「号」
							1の場合「空白」
						その他の場合「空白」
					iValidSyuuchakuEki<=iEkiOrder
						空白
				・種別変更ではない場合
					iEkiOrder<iValidSihatsuEki
						空白
					iEkiOrder=iValidSihatsuEki
						getJikokuhyouRessyabangouDisplayが2の場合「号」
						1の場合空白
					iValidSihatsuEki<iEkiOrder<iValidSyuuchakuEki
						isRunbetweenがtrueの場合もしくはgetJikokuhyouChakuJikokuDisplay()がfalseの場合
							getJikokuhyouRessyabangouDisplayが2の場合「号」
							1の場合「空白」
						その他の場合「空白」
					iValidSyuuchakuEki<=iEkiOrder
						空白
			*/
			int iValidSihatsuEki = pCentDedRessya->getValidSihatsuEki();
			int iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();
			tstring strText;
			if (iValidSihatsuEki == -1 || iValidSyuuchakuEki == -1)
			{
				strText = _T("");
			}
			else if (pCentDedRessya->getGousuu().empty())
			{
				strText = _T("");
			}
			else if (iValidSihatsuEki == iEkiOrder)
			{
				if (iSyubetsuChangeEkiOrder != -1 ||
					aCdDedEki.getJikokuhyouRessyameiDisplay() == 2)
				{
					strText= (LPCTSTR)MfcUtil::LoadCString(IDS_WORD_GOUSUU2);
				}
				else
				{
					strText = _T("");
				}
			}
			else if (iValidSihatsuEki < iEkiOrder &&
				iEkiOrder < iValidSyuuchakuEki &&
				aCdDedEki.getJikokuhyouRessyameiDisplay() == 2 &&
				(pCentDedRessya->isRunBetweenNextEki(iEkiOrder) ||
					!aCdDedEki.getJikokuhyouChakuJikokuDisplay()))
			{
				strText = (LPCTSTR)MfcUtil::LoadCString(IDS_WORD_GOUSUU2);
			}
			else
			{
				strText = _T("");
			}

			/**
				次駅が解結駅の場合、この欄に↴印を表示することがあります
				(1)次駅が解結駅かつ有効な始発駅
				(2)次駅が着時刻又は発時刻のどちらかのみ表示
				(3)この欄の直下が、次駅の項な場合。
			*/
			if (iEkiOrder + 1 == iValidSihatsuEki &&
				iEkiOrder + 1 == iReleaseEkiOrder)
			{
				CentDedEkiCont::CdDedEki aCdDedEkiNext = muCdDedEki->get(iEkiOrder + 1);
				if (!aCdDedEkiNext.getJikokuhyouChakuJikokuDisplay() ||
					!aCdDedEkiNext.getJikokuhyouHatsuJikokuDisplay())
				{
					int iYColumnNumberNext = iYColumnNumber + 1;
					CdYColSpec aCdYColSpecNext = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberNext);
					if (aCdYColSpecNext.getEkiOrder() == iEkiOrder + 1)
					{
						strText = (LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_RELEASE);
					}
				}
			}
			/**
				前駅が増結駅の場合、この欄に↳印を表示することがあります
				(1)前駅が増結駅かつ有効な終着駅
				(2)前駅が着時刻又は発時刻のどちらかのみ表示
				(3)この欄の直上が、前駅の項な場合。
			*/
			if (iEkiOrder - 1 == iValidSyuuchakuEki &&
				iEkiOrder - 1 == iConnectEkiOrder &&
				iValidSyuuchakuEki != -1)
			{
				CentDedEkiCont::CdDedEki aCdDedEkiPrev = muCdDedEki->get(iEkiOrder - 1);
				if (!aCdDedEkiPrev.getJikokuhyouChakuJikokuDisplay() ||
					!aCdDedEkiPrev.getJikokuhyouHatsuJikokuDisplay())
				{
					int iYColumnNumberPrev = iYColumnNumber - 1;
					CdYColSpec aCdYColSpecPrev = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberPrev);
					if (aCdYColSpecPrev.getEkiOrder() == iEkiOrder - 1)
					{
						strText = (LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_CONNECT);
					}
				}
			}
			//CString	strText;

			*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
			pCDcDrawCell->setText(strText);
		}

		//セルの背景色を指定します。
		{
			pCDcDrawCell->setCdBrushProp(CdColorProp(255, 255, 255));
		}
	}
}

void CCellBuilderCustomize::update02_02_02_07_setRessya_Hatsu(
	int iXColumnNumber ,
	int iYColumnNumber,
	const CentDedRessya* pCentDedRessya ,
	int iEkiOrder ,
	int iSyubetsuChangeEkiOrder,
	int iConnectEkiOrder,
	int iReleaseEkiOrder,
	CWndJikokuhyou* pCWndJikokuhyou ) 
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid() ;
	const CentDedRosen* pCentDedRosen = 
		m_pCDedRosenFileData->getCentDedRosen() ;
	const CentDedEkiCont* pCentDedEkiCont =
		pCentDedRosen->getCentDedEkiCont();
	const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki = 
		pCentDedEkiCont->getMuPtr(
			pCentDedRessya->getRessyahoukou() ) ;
	// --------------------------------
	//CDcdTargetGetDC	aCDcdTarget( NULL ) ;
	// --------------------------------
	{
		//CdYColSpec aCdYColSpec( 
		//	CdYColSpec::ColumnType_Ekijikoku_Hatsu , 
		//	iEkiOrder ) ;
		//int iYColumnNumber = 
		//	m_CdYColSpecCont.ColumnNumberFromSpec( aCdYColSpec , false ) ;
		CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell( 
			iXColumnNumber , iYColumnNumber ) ;
		// --------------------------------
		if ( pCDcdGridCell != 0 )
		{
			typedef CDcdTextbox CDcDrawCell ;
			Ou<CDcDrawCell> pCDcDrawCell ;
			// --------------------------------
			//　(2.2.*.1)　セルの結合セルを設定
			pCDcdGridCell->setAttachCellCount( 1 , 1 ) ;

			//　(2.2.*.2)　セル の	DcDrawオブジェクトの型を設定
			//	( CDcdTextbox とする)。
			{
				pCDcDrawCell = dynamic_castOu<CDcDrawCell>( 
					pCDcdGridCell->getIfDcDraw() ) ;
				if ( pCDcDrawCell == NULL )
				{
					pCDcDrawCell = OuNew<CDcDrawCell>( new CDcDrawCell ) ;
					pCDcdGridCell->setIfDcDraw( pCDcDrawCell ) ;
				}
			}
			//　(2.2.*.3)　セルの DcDrawオブジェクトに、属性を設定。
			{
				CentDedEkiCont::CdDedEki aCdDedEki = muCdDedEki->get( iEkiOrder ) ;
				int idxRessyasyubetsu 
					= pCentDedRessya->getRessyasyubetsuIndex() ;
				//	主要駅では、空欄に主要駅表記を行います。
				//	起点・終点・着発駅のいずれかである場合、
				//	境界線に接している駅である場合は除きます。
				bool bIsSyuyouEkiHyouki = false ;
				if ( aCdDedEki.getEkikibo() == CentDedEki::Ekikibo_Syuyou 
					&&	0 < iEkiOrder 
					&& iEkiOrder < muCdDedEki->size() - 1 
					&& (!aCdDedEki.getJikokuhyouChakuJikokuDisplay() ||
						!aCdDedEki.getJikokuhyouHatsuJikokuDisplay()))
				{
					//	境界線に接している駅である場合は除きます。
					CentDedEkiCont::CdDedEki aCentDedEkiTonari ;
					if ( iEkiOrder > 0 )
					{
						aCentDedEkiTonari = muCdDedEki->get( iEkiOrder - 1 ) ;
					}

					if ( !aCentDedEkiTonari.getKyoukaisen()  && 
						!aCdDedEki.getKyoukaisen() )
					{
						bIsSyuyouEkiHyouki = true ;
					}
				}
				//bIsSyuyouEkiHyouji = 空欄に主要駅表記を行います。

				CentDedEkiJikoku	aCentDedEkiJikoku =
					pCentDedRessya->getCentDedEkiJikoku( iEkiOrder ) ;
				CdDedJikoku aCdDedJikoku 
					= aCentDedEkiJikoku.getHatsujikoku() ;

				// --------------------------------
				//	駅時刻に合わせて、セルに文字を表示
				// --------------------------------
				int iValidSihatsuEki = pCentDedRessya->getValidSihatsuEki();
				int iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();
				if (iValidSihatsuEki == -1 || iValidSyuuchakuEki == -1)
				{
					if (bIsSyuyouEkiHyouki)
					{
						//	主要駅での表記（着発の場合は除く）
						//	"----"
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_UNKOUNASI_SYUYOU));
					}
					else
					{
						//	その他の駅での表記
						//	"・・"
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_UNKOUNASI_IPPAN));
					}
				}
				else if (iEkiOrder < iValidSihatsuEki && iValidSihatsuEki != -1)
				{
					if (pCentDedRessya->getFirstOperation().getBOperation() == CentDedBeforeOperation::BOperation_Outer
						&& m_bDisplayOuterTerminalShihatsu)
					{
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_KEIYUNASI));//"||"

					}
					else if (iSyubetsuChangeEkiOrder != -1)
					{
						//設定で発時刻を入れられるようにする(つもり)
						//if (iSyubetsuChangeEkiOrder == iEkiOrder)
						//{

						//}
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_KEIYUNASI));//"||"
					}
					else if(iReleaseEkiOrder <= iEkiOrder && iReleaseEkiOrder != -1)
					{
						/**
							解結駅かつ、着時刻表示がない場合は、発時刻欄に↴を表示する。
						*/
						if (iEkiOrder == iReleaseEkiOrder &&
							!aCdDedEki.getJikokuhyouChakuJikokuDisplay())
						{
							*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
							pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
									IDS_WORD_JIKOKUHYOU_RELEASE));
						}
						else
						{
							*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
							pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
								IDS_WORD_JIKOKUHYOU_KEIYUNASI));//"||"
						}
					}
					else if (bIsSyuyouEkiHyouki)
					{
						//	主要駅での表記（着発の場合は除く）
						//	"----"
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_UNKOUNASI_SYUYOU));
					}
					else
					{
						//	その他の駅での表記
						//	"・・"
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_UNKOUNASI_IPPAN));
					}
				}
				else if (iEkiOrder == iValidSyuuchakuEki)
				{
					if (pCentDedRessya->getLastOperation().getAOperation() == CentDedAfterOperation::AOperation_Outer
						&& m_bDisplayOuterTerminalShuchaku)
					{
						/**
							路線外終着の場合、当駅発時刻の設定の有無で変化します
							設定あり：停車・運転停車とみなします。従来通りの処理です。
							設定なし：駅扱い通過の場合は通過とみなします。路線外終着以外の作業は全て無効扱いになります
								通過をみなしているときは、当駅発時刻部は経由無し表記にします
								駅扱い停車の場合は、着時刻欄は経由無し表記にします。
						*/
						if (pCentDedRessya->getLastOperation().getHatsuJikoku().isNull() ||
							aCentDedEkiJikoku.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Tsuuka &&
							!m_bDisplayTsuukaEkiJikoku)
						{
							*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
							pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
								IDS_WORD_JIKOKUHYOU_KEIYUNASI));//"||"
						}
						else if(aCentDedEkiJikoku.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Tsuuka)
						{
							*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
							pCDcDrawCell->setCdDrawTextProp(
								getCdDrawTextPropTsuuka());

							/**
								秒単位表示OFFの場合は、切り上げ・切り捨ての処理を行いますが、
								その補助のため、着時刻が切り上げまたは30秒以上切り上げで、発時刻が切り捨ての場合は、着時刻の取得を行います。
							*/
							CdDedJikoku aChakuJikoku;
							if (!getDisplaySecondEkiJikoku() &&
								m_iSecondRoundChaku >= 1 &&
								m_iSecondRoundHatsu == 0)
							{
								aChakuJikoku = aCentDedEkiJikoku.getChakujikoku();
								if (!aChakuJikoku.isNull())
								{
									int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
									const CentDedBeforeOperationCont* pBeforeCont = aCentDedEkiJikoku.getCentDedBeforeOperationCont();
									for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
									{
										const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
										if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt &&
											iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
										{
											/**
												同じ番線からの入換は、入換自体を無効と見なし、次を検索します
											*/
											if (pBeforeOperation->getIsDisplayChakuJikoku())
											{
												aChakuJikoku = pBeforeOperation->getOperationChakuJikoku(true);
												break;
											}
											/**
												getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
											*/
											iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
										}
									}
								}
							}

							tstring strText = getCdDedJikokuConv().encode(pCentDedRessya->getLastOperation().getHatsuJikoku(),
								false, aChakuJikoku);
							pCDcDrawCell->setText(strText);
						}
						else
						{
							*pCDcDrawCell = createCDcdEkijikoku(idxRessyasyubetsu);

							/**
								秒単位表示OFFの場合は、切り上げ・切り捨ての処理を行いますが、
								その補助のため、着時刻が切り上げまたは30秒以上切り上げで、発時刻が切り捨ての場合は、着時刻の取得を行います。
							*/
							CdDedJikoku aChakuJikoku;
							if (!getDisplaySecondEkiJikoku() &&
								m_iSecondRoundChaku >= 1 &&
								m_iSecondRoundHatsu == 0)
							{
								aChakuJikoku = aCentDedEkiJikoku.getChakujikoku();
								if (!aChakuJikoku.isNull())
								{
									int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
									const CentDedBeforeOperationCont* pBeforeCont = aCentDedEkiJikoku.getCentDedBeforeOperationCont();
									for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
									{
										const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
										if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt &&
											iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
										{
											/**
												同じ番線からの入換は、入換自体を無効と見なし、次を検索します
											*/
											if (pBeforeOperation->getIsDisplayChakuJikoku())
											{
												aChakuJikoku = pBeforeOperation->getOperationChakuJikoku(true);
												break;
											}
											/**
												getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
											*/
											iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
										}
									}
								}
							}

							tstring strText = getCdDedJikokuConv().encode(pCentDedRessya->getLastOperation().getHatsuJikoku(),
								false, aChakuJikoku);
							pCDcDrawCell->setText(strText);
						}
					}
					else if (iEkiOrder == iConnectEkiOrder &&
						aCdDedEki.getJikokuhyouChakuJikokuDisplay())
					{
						/**
							着時刻表示の有無で変わる
							着時刻表示がある場合は、この欄に「↳」を表示する
							着時刻表示がない場合は、この欄には着時刻を入れ、一つ下の欄に表示を行う。
						*/

						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
								IDS_WORD_JIKOKUHYOU_CONNECT));
					}
					//この駅が発時刻のみ表示の場合は、発時刻欄に着時刻を表示する
					else if (!aCdDedEki.getJikokuhyouChakuJikokuDisplay())
					{
						aCdDedJikoku = aCentDedEkiJikoku.getChakujikoku();
						const CentDedBeforeOperationCont* pBeforeCont = aCentDedEkiJikoku.getCentDedBeforeOperationCont();
						for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
						{
							const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
							if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt)
							{
								if (pBeforeOperation->getIsDisplayChakuJikoku())
								{
									aCdDedJikoku = pBeforeOperation->getOperationChakuJikoku(true);
									break;
								}
							}
						}
						tstring strText = getCdDedJikokuConv().encode(aCdDedJikoku,true);
						if (aCentDedEkiJikoku.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Tsuuka)
						{
							*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
							pCDcDrawCell->setText(strText);
							pCDcDrawCell->setCdDrawTextProp(
								getCdDrawTextPropTsuuka());
						}
						else
						{
							*pCDcDrawCell = createCDcdEkijikoku(idxRessyasyubetsu);
							pCDcDrawCell->setText(strText);
						}
					}
					else if (bIsSyuyouEkiHyouki)
					{
						//	主要駅での表記（着発の場合は除く）
						//	"----"
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_UNKOUNASI_SYUYOU));
					}
					else
					{
						//	その他の駅での表記
						//	"・・"
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_UNKOUNASI_IPPAN));
					}
				}
				else if (iEkiOrder > iValidSyuuchakuEki && iValidSyuuchakuEki != -1)
				{
					if (pCentDedRessya->getLastOperation().getAOperation() == CentDedAfterOperation::AOperation_Outer
						&& m_bDisplayOuterTerminalShuchaku)
					{
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_KEIYUNASI));//"||"

					}
					else if (iConnectEkiOrder > iEkiOrder && iConnectEkiOrder != -1)
					{
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_KEIYUNASI));//"||"
					}
					else if (iConnectEkiOrder == iEkiOrder)
					{
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_CONNECT));
					}
					else if (bIsSyuyouEkiHyouki)
					{
						//	主要駅での表記（着発の場合は除く）
						//	"----"
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_UNKOUNASI_SYUYOU));
					}
					else
					{
						//	その他の駅での表記
						//	"・・"
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_UNKOUNASI_IPPAN));
					}
					/**
						有効終着駅の次の駅で、この列車が路線外終着ではない、もしくは路線外終着欄がない時、
						この欄のすぐ上が発時刻欄かつ着時刻表示がない場合、
						この欄に"===="を描写します
					*/
					if (iEkiOrder == iValidSyuuchakuEki + 1 &&
						(pCentDedRessya->getLastOperation().getAOperation() != CentDedAfterOperation::AOperation_Outer
							|| !m_bDisplayOuterTerminalShuchaku))
					{
						CdYColSpec aCdYColSpecPrev = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumber - 1);
						CentDedEkiCont::CdDedEki aCdDedEkiPrev = muCdDedEki->get(iEkiOrder - 1);
						if (aCdYColSpecPrev.getEkiOrder() == iEkiOrder - 1 &&
							aCdYColSpecPrev.getColumnType() == CdYColSpec::ColumnType_Ekijikoku_Hatsu &&
							!aCdDedEkiPrev.getJikokuhyouChakuJikokuDisplay())
						{
							//pCDcDrawCell->setText(_T("===="));
							pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
								IDS_WORD_JIKOKUHYOU_SYUUCHAKU));
						}
					}
				}
				//始発駅及び中間駅の場合
				else
				{
					switch (aCentDedEkiJikoku.getEkiatsukai())
					{
					case CentDedEkiJikoku::Ekiatsukai_None:
					{
						*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
						pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
							IDS_WORD_JIKOKUHYOU_KEIYUNASI));//"||"
					}
					break;
					case CentDedEkiJikoku::Ekiatsukai_Tsuuka:
					{
						if (pCentDedRessya->isRunBetweenNextEki(iEkiOrder))
						{
							/**
								この駅から次駅間を運行している場合、基本的に発時刻を表示します。
								発時刻がある場合は、後作業を見て、「入換発時刻を当駅の発時刻にする」が有効になっている作業がある場合は、その作業で時刻を更新する。
								発時刻がない場合は、レ印を表示します。
								ただし、当駅が有効始発駅かつ路線外始発で、当駅着時刻が空の場合は、当駅が通過扱いとなり、
								入換作業等がすべて無効扱いとなるので、この作業は行いません。
								また、この駅と前駅の間が運行なしで、通過駅時刻表示かつ発時刻がない場合は、
								運行なしを超えた先から着時刻を取得し表示します。（つまり、片側時刻のみがある通過の場合に、その時刻を両側に表示する）
							*/
							if (!aCdDedJikoku.isNull() &&
								(iEkiOrder != iValidSihatsuEki ||
								pCentDedRessya->getFirstOperation().getBOperation() != CentDedBeforeOperation::BOperation_Outer ||
								!pCentDedRessya->getFirstOperation().getChakuJikoku().isNull()))
							{
								int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
								const CentDedAfterOperationCont* pAfterCont = aCentDedEkiJikoku.getCentDedAfterOperationCont();
								for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
								{
									const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
									if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt &&
										iRessyaTrack != pAfterOperation->getShuntTrackIndex())
									{
										/**
											同じ番線からの入換は、入換自体を無効と見なし、次を検索します
										*/
										if (pAfterOperation->getIsDisplayHatsuJikoku())
										{
											aCdDedJikoku = pAfterOperation->getOperationHatsuJikoku();
											break;
										}
										/**
											getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
										*/
										iRessyaTrack = pAfterOperation->getShuntTrackIndex();
									}
								}
							}

							/**
								bIsChakuJikoku
								この項に表示する時刻が、着時刻なのか否か
								着時刻なのか発時刻なのかで、秒単位処理が変わります。
							*/
							bool bIsChakuJikoku = false;
							if (aCdDedJikoku.isNull() &&
								iEkiOrder != iValidSihatsuEki &&
								m_bDisplayTsuukaEkiJikoku &&
								!pCentDedRessya->isRunBetweenNextEki(iEkiOrder - 1))
							{
								int iChakuEkiOrder = pCentDedRessya->getRunBetweenEkiBackward(iEkiOrder);
								if (iChakuEkiOrder != -1 &&
									pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iChakuEkiOrder, pCentDedRessya->getRessyahoukou()))
								{
									//このケースでは、通過なので、入換作業を参照する必要はありません。
									aCdDedJikoku = pCentDedRessya->getCentDedEkiJikoku(iChakuEkiOrder).getChakujikoku();
									bIsChakuJikoku = true;
								}
							}

							if (!aCdDedJikoku.isNull() &&
								(m_bDisplayTsuukaEkiJikoku ||
								(iEkiOrder == iValidSihatsuEki &&
									pCentDedRessya->getFirstOperation().getBOperation() != CentDedBeforeOperation::BOperation_Outer)))
							{
								/**
									秒単位表示OFFの場合は、切り上げ・切り捨ての処理を行いますが、
									その補助のため、着時刻が30秒以上切り上げまたは切り上げで、発時刻が切り捨ての場合、
									かつ、着時刻表示がある場合は、着時刻の取得を行います。
									この駅と前の駅の間が運行なしの場合は、運行なしを超えた先の駅から時刻を取得します。
								*/
								CdDedJikoku aChakuJikoku;
								if (iEkiOrder > iValidSihatsuEki &&
									!getDisplaySecondEkiJikoku() &&
									//aCdDedEki.getJikokuhyouChakuJikokuDisplay() &&
									m_iSecondRoundChaku >= 1 &&
									m_iSecondRoundHatsu == 0 &&
									!bIsChakuJikoku)
								{
									if (!pCentDedRessya->isRunBetweenNextEki(iEkiOrder - 1))
									{
										int iChakuEkiOrder = pCentDedRessya->getRunBetweenEkiBackward(iEkiOrder);
										if (iChakuEkiOrder != -1 &&
											pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iChakuEkiOrder, pCentDedRessya->getRessyahoukou()))
										{
											aChakuJikoku = pCentDedRessya->getCentDedEkiJikoku(iChakuEkiOrder).getChakujikoku();
											if (!aChakuJikoku.isNull())
											{
												CentDedEkiJikoku aCentDedChakuEkiJikoku = pCentDedRessya->getCentDedEkiJikoku(iChakuEkiOrder);
												int iRessyaTrack = aCentDedChakuEkiJikoku.getRessyaTrackIndex();
												const CentDedBeforeOperationCont* pBeforeCont = aCentDedChakuEkiJikoku.getCentDedBeforeOperationCont();
												for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
												{
													const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
													if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt &&
														iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
													{
														/**
															同じ番線からの入換は、入換自体を無効と見なし、次を検索します
														*/
														if (pBeforeOperation->getIsDisplayChakuJikoku())
														{
															aChakuJikoku = pBeforeOperation->getOperationChakuJikoku(true);
															break;
														}
														/**
															getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
														*/
														iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
													}
												}
											}
										}
									}
									else if(aCdDedEki.getJikokuhyouChakuJikokuDisplay())//&& pCentDedRessya->isRunBetweenNextEki(iEkiOrder - 1)
									{
										aChakuJikoku = aCentDedEkiJikoku.getChakujikoku();
										if (!aChakuJikoku.isNull())
										{
											int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
											const CentDedBeforeOperationCont* pBeforeCont = aCentDedEkiJikoku.getCentDedBeforeOperationCont();
											for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
											{
												const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
												if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt &&
													iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
												{
													/**
														同じ番線からの入換は、入換自体を無効と見なし、次を検索します
													*/
													if (pBeforeOperation->getIsDisplayChakuJikoku())
													{
														aChakuJikoku = pBeforeOperation->getOperationChakuJikoku(true);
														break;
													}
													/**
														getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
													*/
													iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
												}
											}
										}
									}
								}

								//	通過駅の駅時刻が設定されており、
								//	『通過駅の駅時刻を表示する』指定になっている場合
								//	もしくは始発駅かつ路線外始発以外の場合は
								//	時刻を表示
								*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
								tstring strText = getCdDedJikokuConv().encode(aCdDedJikoku, bIsChakuJikoku, aChakuJikoku);
								pCDcDrawCell->setText(strText);
								pCDcDrawCell->setCdDrawTextProp(
									getCdDrawTextPropTsuuka());
							}
							else
							{
								*pCDcDrawCell = createCDcdRessyabangou(
									idxRessyasyubetsu);
								pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
									IDS_WORD_JIKOKUHYOU_TSUUKA));	//" ﾚ"
							}
						}
						else
						{
							/**
								この駅から次駅間が運行していない場合は、基本的に経由無しを表示します。
								ただし、この駅に発時刻が設定されている場合、もしくは前駅からこの駅の間が運行ありかつ着時刻表示が無い場合は、
								発時刻を終点方から取得します。ただし、前駅からこの駅の間が運行なしの場合は、
								起点方のisRunBetweenNextEkiがtrueの駅を探し、起点方の駅・この駅・終点方の駅が全て同一駅であることを確認してから、
								発時刻の取得を行います。
								上記探索において、発時刻が見つからなかった場合は、経由無しにしますが、
								前駅からこの駅の間が運行ありかつ着時刻表示が無い場合は、レ印を表示します
							*/
							if (!aCdDedJikoku.isNull() ||
								(pCentDedRessya->isRunBetweenNextEki(iEkiOrder - 1) &&
									!aCdDedEki.getJikokuhyouChakuJikokuDisplay()))
							{
								aCdDedJikoku.setNull();
								if (pCentDedRessya->isRunBetweenNextEki(iEkiOrder - 1))
								{
									int iHatsuEkiOrder = pCentDedRessya->getRunBetweenEkiForward(iEkiOrder);
									if (pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iHatsuEkiOrder, pCentDedRessya->getRessyahoukou()))
									{
										CentDedEkiJikoku aHatsuEkiJikoku = pCentDedRessya->getCentDedEkiJikoku(iHatsuEkiOrder);
										aCdDedJikoku = aHatsuEkiJikoku.getHatsujikoku();
										int iRessyaTrack = aHatsuEkiJikoku.getRessyaTrackIndex();
										const CentDedAfterOperationCont* pAfterCont = aHatsuEkiJikoku.getCentDedAfterOperationCont();
										for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
										{
											const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
											if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt &&
												iRessyaTrack != pAfterOperation->getShuntTrackIndex())
											{
												/**
													同じ番線からの入換は、入換自体を無効と見なし、次を検索します
												*/
												if (pAfterOperation->getIsDisplayHatsuJikoku())
												{
													aCdDedJikoku = pAfterOperation->getOperationHatsuJikoku();
													break;
												}
												/**
													getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
												*/
												iRessyaTrack = pAfterOperation->getShuntTrackIndex();
											}
										}
									}
								}
								/**
									前後ともisRunBetweenNextEkiがFalseの場合は、一旦保留にします
									（番線欄や駅扱い一致、種別変更欄との兼ね合い及び、有効始発駅・終着駅より外側の表示と整合を合わせるため後回し
								*/
								//else
								//{
								//	int iChakuEkiOrder = pCentDedRessya->getRunBetweenEkiBackward(iEkiOrder);
								//	int iHatsuEkiOrder = pCentDedRessya->getRunBetweenEkiForward(iEkiOrder);
								//	if (pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iChakuEkiOrder, pCentDedRessya->getRessyahoukou()) &&
								//		pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iHatsuEkiOrder, pCentDedRessya->getRessyahoukou()))
								//	{
								//		CentDedEkiJikoku aHatsuEkiJikoku = pCentDedRessya->getCentDedEkiJikoku(iHatsuEkiOrder);
								//		if (aCentDedEkiJikoku.getEkiatsukai() == aHatsuEkiJikoku.getEkiatsukai())
								//		{
								//			/**
								//				前後ともisRunBetweenNextEkiがFalseの場合は、駅扱いが一致しているかどうかを確認します
								//				(列車編集時、iChakuEkiOrderとiHatsuEkiOrderは駅扱いを合わせるが、この駅は対象に入らないので)
								//				駅扱いが一致している場合のみ、時刻取得を行います。
								//			*/
								//			aCdDedJikoku = aHatsuEkiJikoku.getHatsujikoku();
								//			int iRessyaTrack = aHatsuEkiJikoku.getRessyaTrackIndex();
								//			const CentDedAfterOperationCont* pAfterCont = aHatsuEkiJikoku.getCentDedAfterOperationCont();
								//			for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
								//			{
								//				const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
								//				if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt &&
								//					iRessyaTrack != pAfterOperation->getShuntTrackIndex())
								//				{
								//					/**
								//						同じ番線からの入換は、入換自体を無効と見なし、次を検索します
								//					*/
								//					if (pAfterOperation->getIsDisplayHatsuJikoku())
								//					{
								//						aCdDedJikoku = pAfterOperation->getOperationHatsuJikoku();
								//						break;
								//					}
								//					/**
								//						getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
								//					*/
								//					iRessyaTrack = pAfterOperation->getShuntTrackIndex();
								//				}
								//			}
								//		}
								//	}
								//}
							}

							if (!aCdDedJikoku.isNull() &&
								m_bDisplayTsuukaEkiJikoku)
							{
								/**
									秒単位表示OFFの場合は、切り上げ・切り捨ての処理を行いますが、
									その補助のため、着時刻が30秒以上切り上げまたは切り上げで、発時刻が切り捨ての場合、
									かつ、着時刻表示がある場合は、着時刻の取得を行います。
									この駅と前の駅の間が運行なしの場合は、運行なしを超えた先の駅から時刻を取得します。
								*/
								CdDedJikoku aChakuJikoku;
								if (!getDisplaySecondEkiJikoku() &&
									aCdDedEki.getJikokuhyouChakuJikokuDisplay() &&
									m_iSecondRoundChaku >= 1 &&
									m_iSecondRoundHatsu == 0)
								{
									if (iEkiOrder > iValidSihatsuEki)
									{
										//pCentDedRessya->isRunBetweenNextEki(iEkiOrder-1)がfalseの場合は、時刻がNULLになっているはずなので、この処理は省略
										aChakuJikoku = aCentDedEkiJikoku.getChakujikoku();
										if (!aChakuJikoku.isNull())
										{
											int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
											const CentDedBeforeOperationCont* pBeforeCont = aCentDedEkiJikoku.getCentDedBeforeOperationCont();
											for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
											{
												const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
												if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt &&
													iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
												{
													/**
														同じ番線からの入換は、入換自体を無効と見なし、次を検索します
													*/
													if (pBeforeOperation->getIsDisplayChakuJikoku())
													{
														aChakuJikoku = pBeforeOperation->getOperationChakuJikoku(true);
														break;
													}
													/**
														getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
													*/
													iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
												}
											}
										}
									}
								}
								//	通過駅の駅時刻が設定されており、
								//	『通過駅の駅時刻を表示する』指定になっている場合は
								//	時刻を表示
								*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
								tstring strText = getCdDedJikokuConv().encode(aCdDedJikoku, false, aChakuJikoku);
								pCDcDrawCell->setText(strText);
								pCDcDrawCell->setCdDrawTextProp(
									getCdDrawTextPropTsuuka());
							}
							else if (pCentDedRessya->isRunBetweenNextEki(iEkiOrder - 1) &&
								!aCdDedEki.getJikokuhyouChakuJikokuDisplay())
							{
								*pCDcDrawCell = createCDcdRessyabangou(
									idxRessyasyubetsu);
								pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
									IDS_WORD_JIKOKUHYOU_TSUUKA));	//" ﾚ"
							}
							else
							{
								*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
								pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
									IDS_WORD_JIKOKUHYOU_KEIYUNASI));//"||"
							}
						}
					}
					break;
					case CentDedEkiJikoku::Ekiatsukai_Teisya:
					{
						if (pCentDedRessya->isRunBetweenNextEki(iEkiOrder))
						{
							/**
								この駅から次駅間を運行している場合、基本的に発時刻を表示します。
								発時刻がある場合は、後作業を見て、「入換発時刻を当駅の発時刻にする」が有効になっている作業がある場合は、その作業で時刻を更新する。
								発時刻がない場合は、○印を表示しますが、この駅が発時刻のみ表示の場合は、着時刻を代わりに表示します。
								その場合、前駅からこの駅間が運行していない場合は、起点方のisRunBetweenNextEkiがtrueの駅を探し、
								この駅と同一駅の場合は、その駅から着時刻を取得します。
							*/
							if (!aCdDedJikoku.isNull())
							{
								int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
								const CentDedAfterOperationCont* pAfterCont = aCentDedEkiJikoku.getCentDedAfterOperationCont();
								for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
								{
									const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
									if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt &&
										iRessyaTrack != pAfterOperation->getShuntTrackIndex())
									{
										/**
											同じ番線からの入換は、入換自体を無効と見なし、次を検索します
										*/
										if (pAfterOperation->getIsDisplayHatsuJikoku())
										{
											aCdDedJikoku = pAfterOperation->getOperationHatsuJikoku();
											break;
										}
										/**
											getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
										*/
										iRessyaTrack = pAfterOperation->getShuntTrackIndex();
									}
								}
							}
							if (aCdDedJikoku.isNull() &&
								!aCdDedEki.getJikokuhyouChakuJikokuDisplay())
							{
								if (pCentDedRessya->isRunBetweenNextEki(iEkiOrder - 1))
								{
									aCdDedJikoku = aCentDedEkiJikoku.getChakujikoku();

									int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
									const CentDedBeforeOperationCont* pBeforeCont = aCentDedEkiJikoku.getCentDedBeforeOperationCont();
									for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
									{
										const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
										if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt &&
											iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
										{
											/**
												同じ番線からの入換は、入換自体を無効と見なし、次を検索します
											*/
											if (pBeforeOperation->getIsDisplayChakuJikoku())
											{
												aCdDedJikoku = pBeforeOperation->getOperationChakuJikoku(true);
												break;
											}
											/**
												getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
											*/
											iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
										}
									}
								}
								else
								{
									int iChakuEkiOrder = pCentDedRessya->getRunBetweenEkiBackward(iEkiOrder);
									if (pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iChakuEkiOrder, pCentDedRessya->getRessyahoukou()))
									{
										CentDedEkiJikoku aChakuEkiJikoku = pCentDedRessya->getCentDedEkiJikoku(iChakuEkiOrder);
										aCdDedJikoku = aChakuEkiJikoku.getChakujikoku();
										int iRessyaTrack = aChakuEkiJikoku.getRessyaTrackIndex();
										const CentDedBeforeOperationCont* pBeforeCont = aChakuEkiJikoku.getCentDedBeforeOperationCont();
										for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
										{
											const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
											if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt &&
												iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
											{
												/**
													同じ番線からの入換は、入換自体を無効と見なし、次を検索します
												*/
												if (pBeforeOperation->getIsDisplayChakuJikoku())
												{
													aCdDedJikoku = pBeforeOperation->getOperationChakuJikoku(true);
													break;
												}
												/**
													getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
												*/
												iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
											}
										}
									}
								}
							}

							if (!aCdDedJikoku.isNull())
							{
								/**
									秒単位表示OFFの場合は、切り上げ・切り捨ての処理を行いますが、
									その補助のため、着時刻が30秒以上切り上げまたは切り上げで、発時刻が切り捨ての場合、着時刻の取得を行います。
									ただし、この駅と前の駅の間が運行ありの場合は、着時刻表示がある場合に限り、
									一方、この駅と前の駅の間が運行なしの場合は、運行なしを超えた先の駅から時刻を取得します。

								*/
								CdDedJikoku aChakuJikoku;
								if (!getDisplaySecondEkiJikoku() &&
									//aCdDedEki.getJikokuhyouChakuJikokuDisplay() &&
									m_iSecondRoundChaku >= 1 &&
									m_iSecondRoundHatsu == 0)
								{
									if (iEkiOrder > iValidSihatsuEki)
									{
										if (!pCentDedRessya->isRunBetweenNextEki(iEkiOrder - 1))
										{
											int iChakuEkiOrder = pCentDedRessya->getRunBetweenEkiBackward(iEkiOrder);
											if (iChakuEkiOrder != -1 &&
												pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iChakuEkiOrder, pCentDedRessya->getRessyahoukou()))
											{
												aChakuJikoku = pCentDedRessya->getCentDedEkiJikoku(iChakuEkiOrder).getChakujikoku();
												if (!aChakuJikoku.isNull())
												{
													CentDedEkiJikoku aCentDedChakuEkiJikoku = pCentDedRessya->getCentDedEkiJikoku(iChakuEkiOrder);
													int iRessyaTrack = aCentDedChakuEkiJikoku.getRessyaTrackIndex();
													const CentDedBeforeOperationCont* pBeforeCont = aCentDedChakuEkiJikoku.getCentDedBeforeOperationCont();
													for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
													{
														const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
														if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt &&
															iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
														{
															/**
																同じ番線からの入換は、入換自体を無効と見なし、次を検索します
															*/
															if (pBeforeOperation->getIsDisplayChakuJikoku())
															{
																aChakuJikoku = pBeforeOperation->getOperationChakuJikoku(true);
																break;
															}
															/**
																getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
															*/
															iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
														}
													}
												}
											}
										}
										else if(aCdDedEki.getJikokuhyouChakuJikokuDisplay())
										{
											aChakuJikoku = aCentDedEkiJikoku.getChakujikoku();
											if (!aChakuJikoku.isNull())
											{
												int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
												const CentDedBeforeOperationCont* pBeforeCont = aCentDedEkiJikoku.getCentDedBeforeOperationCont();
												for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
												{
													const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
													if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt &&
														iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
													{
														/**
															同じ番線からの入換は、入換自体を無効と見なし、次を検索します
														*/
														if (pBeforeOperation->getIsDisplayChakuJikoku())
														{
															aChakuJikoku = pBeforeOperation->getOperationChakuJikoku(true);
															break;
														}
														/**
															getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
														*/
														iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
													}
												}
											}
										}
									}
								}

								//	時刻が設定されている場合は時刻を表示
								*pCDcDrawCell = createCDcdEkijikoku(idxRessyasyubetsu);
								tstring strText = getCdDedJikokuConv().encode(aCdDedJikoku,false, aChakuJikoku);
								pCDcDrawCell->setText(strText);
							}
							else
							{
								*pCDcDrawCell = createCDcdRessyabangou(
									idxRessyasyubetsu);
								pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
									IDS_WORD_JIKOKUHYOU_TEISYA));
							}

						}
						else
						{
							/**
								この駅から次駅間が運行していない場合は、基本的に経由無しを表示します。
								ただし、この駅に発時刻が設定されている場合、もしくは前駅からこの駅の間が運行ありかつ着時刻表示が無い場合は、
								発時刻を終点方から取得します。ただし、前駅からこの駅の間が運行なしの場合は、
								起点方のisRunBetweenNextEkiがtrueの駅を探し、起点方の駅・この駅・終点方の駅が全て同一駅であることを確認してから、
								発時刻の取得を行います。
								上記探索において、発時刻が見つからなかった場合は、経由無しにしますが、
								前駅からこの駅の間が運行ありかつ着時刻表示が無い場合は、まず着時刻を表示するようにし、それもない場合は○印を表示します
							*/
							if (!aCdDedJikoku.isNull() ||
								(pCentDedRessya->isRunBetweenNextEki(iEkiOrder - 1) &&
									!aCdDedEki.getJikokuhyouChakuJikokuDisplay()))
							{
								aCdDedJikoku.setNull();
								if (pCentDedRessya->isRunBetweenNextEki(iEkiOrder - 1))
								{
									int iHatsuEkiOrder = pCentDedRessya->getRunBetweenEkiForward(iEkiOrder);
									if (pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iHatsuEkiOrder, pCentDedRessya->getRessyahoukou()))
									{
										CentDedEkiJikoku aHatsuEkiJikoku = pCentDedRessya->getCentDedEkiJikoku(iHatsuEkiOrder);
										aCdDedJikoku = aHatsuEkiJikoku.getHatsujikoku();
										int iRessyaTrack = aHatsuEkiJikoku.getRessyaTrackIndex();
										const CentDedAfterOperationCont* pAfterCont = aHatsuEkiJikoku.getCentDedAfterOperationCont();
										for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
										{
											const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
											if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt &&
												iRessyaTrack != pAfterOperation->getShuntTrackIndex())
											{
												/**
													同じ番線からの入換は、入換自体を無効と見なし、次を検索します
												*/
												if (pAfterOperation->getIsDisplayHatsuJikoku())
												{
													aCdDedJikoku = pAfterOperation->getOperationHatsuJikoku();
													break;
												}
												/**
													getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
												*/
												iRessyaTrack = pAfterOperation->getShuntTrackIndex();
											}
										}
									}
								}
								/**
									前後ともisRunBetweenNextEkiがFalseの場合は、一旦保留にします
									（番線欄や駅扱い一致、種別変更欄との兼ね合い及び、有効始発駅・終着駅より外側の表示と整合を合わせるため後回し
								*/
								//else
								//{
								//	int iChakuEkiOrder = pCentDedRessya->getRunBetweenEkiBackward(iEkiOrder);
								//	int iHatsuEkiOrder = pCentDedRessya->getRunBetweenEkiForward(iEkiOrder);
								//	if (pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iChakuEkiOrder, pCentDedRessya->getRessyahoukou()) &&
								//		pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iHatsuEkiOrder, pCentDedRessya->getRessyahoukou()))
								//	{
								//		CentDedEkiJikoku aHatsuEkiJikoku = pCentDedRessya->getCentDedEkiJikoku(iHatsuEkiOrder);
								//		if (aCentDedEkiJikoku.getEkiatsukai() == aHatsuEkiJikoku.getEkiatsukai())
								//		{
								//			/**
								//				前後ともisRunBetweenNextEkiがFalseの場合は、駅扱いが一致しているかどうかを確認します
								//				(列車編集時、iChakuEkiOrderとiHatsuEkiOrderは駅扱いを合わせるが、この駅は対象に入らないので)
								//				駅扱いが一致している場合のみ、時刻取得を行います。
								//			*/
								//			aCdDedJikoku = aHatsuEkiJikoku.getHatsujikoku();
								//			int iRessyaTrack = aHatsuEkiJikoku.getRessyaTrackIndex();
								//			const CentDedAfterOperationCont* pAfterCont = aHatsuEkiJikoku.getCentDedAfterOperationCont();
								//			for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
								//			{
								//				const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
								//				if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt &&
								//					iRessyaTrack != pAfterOperation->getShuntTrackIndex())
								//				{
								//					/**
								//						同じ番線からの入換は、入換自体を無効と見なし、次を検索します
								//					*/
								//					if (pAfterOperation->getIsDisplayHatsuJikoku())
								//					{
								//						aCdDedJikoku = pAfterOperation->getOperationHatsuJikoku();
								//						break;
								//					}
								//					/**
								//						getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
								//					*/
								//					iRessyaTrack = pAfterOperation->getShuntTrackIndex();
								//				}
								//			}
								//		}
								//	}
								//}
							}

							if (aCdDedJikoku.isNull() &&
								pCentDedRessya->isRunBetweenNextEki(iEkiOrder - 1) &&
								!aCdDedEki.getJikokuhyouChakuJikokuDisplay())
							{
								aCdDedJikoku = aCentDedEkiJikoku.getChakujikoku();

								int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
								const CentDedBeforeOperationCont* pBeforeCont = aCentDedEkiJikoku.getCentDedBeforeOperationCont();
								for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
								{
									const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
									if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt &&
										iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
									{
										/**
											同じ番線からの入換は、入換自体を無効と見なし、次を検索します
										*/
										if (pBeforeOperation->getIsDisplayChakuJikoku())
										{
											aCdDedJikoku = pBeforeOperation->getOperationChakuJikoku(true);
											break;
										}
										/**
											getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
										*/
										iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
									}
								}
							}

							if (!aCdDedJikoku.isNull())
							{
								/**
									秒単位表示OFFの場合は、切り上げ・切り捨ての処理を行いますが、
									その補助のため、着時刻が30秒以上切り上げまたは切り上げで、発時刻が切り捨ての場合、
									かつ、着時刻表示がある場合は、着時刻の取得を行います。
									この駅と前の駅の間が運行なしの場合は、運行なしを超えた先の駅から時刻を取得します。
								*/
								CdDedJikoku aChakuJikoku;
								if (!getDisplaySecondEkiJikoku() &&
									aCdDedEki.getJikokuhyouChakuJikokuDisplay() &&
									m_iSecondRoundChaku >= 1 &&
									m_iSecondRoundHatsu == 0)
								{
									if (iEkiOrder > iValidSihatsuEki)
									{
										//pCentDedRessya->isRunBetweenNextEki(iEkiOrder-1)がfalseの場合は、時刻がNULLになっているはずなので、この処理は省略
										aChakuJikoku = aCentDedEkiJikoku.getChakujikoku();
										if (!aChakuJikoku.isNull())
										{
											int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
											const CentDedBeforeOperationCont* pBeforeCont = aCentDedEkiJikoku.getCentDedBeforeOperationCont();
											for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
											{
												const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
												if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt &&
													iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
												{
													/**
														同じ番線からの入換は、入換自体を無効と見なし、次を検索します
													*/
													if (pBeforeOperation->getIsDisplayChakuJikoku())
													{
														aChakuJikoku = pBeforeOperation->getOperationChakuJikoku(true);
														break;
													}
													/**
														getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
													*/
													iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
												}
											}
										}
									}
								}
								//	時刻が設定されている場合は時刻を表示
								*pCDcDrawCell = createCDcdEkijikoku(idxRessyasyubetsu);
								tstring strText = getCdDedJikokuConv().encode(aCdDedJikoku,false, aChakuJikoku);
								pCDcDrawCell->setText(strText);
							}
							else if (pCentDedRessya->isRunBetweenNextEki(iEkiOrder - 1) &&
								!aCdDedEki.getJikokuhyouChakuJikokuDisplay())
							{
								*pCDcDrawCell = createCDcdRessyabangou(
									idxRessyasyubetsu);
								pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
									IDS_WORD_JIKOKUHYOU_TEISYA));
							}
							else
							{
								*pCDcDrawCell = createCDcdRessyabangou(idxRessyasyubetsu);
								pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
									IDS_WORD_JIKOKUHYOU_KEIYUNASI));//"||"
							}
						}
					}
					break;
					}
				}
				/**
					次駅が解結駅の場合、この欄に↴印を表示することがあります
					(1)次駅が解結駅かつ有効な始発駅
					(2)次駅が着時刻又は発時刻のどちらかのみ表示
					(3)この欄の直下が、次駅の項な場合。
				*/
				if (iEkiOrder + 1 == iValidSihatsuEki &&
					iEkiOrder + 1 == iReleaseEkiOrder)
				{
					CentDedEkiCont::CdDedEki aCdDedEkiNext = muCdDedEki->get(iEkiOrder + 1);
					if (!aCdDedEkiNext.getJikokuhyouChakuJikokuDisplay() ||
						!aCdDedEkiNext.getJikokuhyouHatsuJikokuDisplay())
					{
						int iYColumnNumberNext = iYColumnNumber + 1;
						CdYColSpec aCdYColSpecNext = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberNext);
						if (aCdYColSpecNext.getEkiOrder() == iEkiOrder + 1)
						{
							*pCDcDrawCell = createCDcdRessyabangou(
								idxRessyasyubetsu);
							pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
								IDS_WORD_JIKOKUHYOU_RELEASE));
						}
					}
				}
				/**
					前駅が増結駅の場合、この欄に↳印を表示することがあります
					(1)前駅が増結駅かつ有効な終着駅
					(2)前駅が着時刻又は発時刻のどちらかのみ表示
					(3)この欄の直上が、前駅の項な場合。
				*/
				if (iEkiOrder - 1 == iValidSyuuchakuEki &&
					iEkiOrder - 1 == iConnectEkiOrder &&
					iValidSyuuchakuEki != -1)
				{
					CentDedEkiCont::CdDedEki aCdDedEkiPrev = muCdDedEki->get(iEkiOrder - 1);
					if (!aCdDedEkiPrev.getJikokuhyouChakuJikokuDisplay() ||
						!aCdDedEkiPrev.getJikokuhyouHatsuJikokuDisplay())
					{
						int iYColumnNumberPrev = iYColumnNumber - 1;
						CdYColSpec aCdYColSpecPrev = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberPrev);
						if (aCdYColSpecPrev.getEkiOrder() == iEkiOrder - 1)
						{
							*pCDcDrawCell = createCDcdRessyabangou(
								idxRessyasyubetsu);
							pCDcDrawCell->setText((LPCTSTR)MfcUtil::LoadCString(
								IDS_WORD_JIKOKUHYOU_CONNECT));
						}
					}
				}
				
				//セルの背景色を指定します。
				pCDcDrawCell->setCdBrushProp(getBackColor(
					iXColumnNumber,
					iEkiOrder,
					idxRessyasyubetsu));
			}
		}
	}
}

void CCellBuilderCustomize::update02_02_02_16_setRessya_OuterTerminal_Shuchaku(
	int iXColumnNumber,
	int iYColumnNumber,
	const CentDedRessya * pCentDedRessya,
	CWndJikokuhyou * pCWndJikokuhyou)
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	const CentDedRosen* pCentDedRosen =
		m_pCDedRosenFileData->getCentDedRosen();
	const Mu<CentDedEkiCont::CdDedEki>* muCdDedEki =
		pCentDedRosen->getCentDedEkiCont()->getMuPtr(
			pCentDedRessya->getRessyahoukou());
	// --------------------------------
	//CDcdTargetGetDC	aCDcdTarget(NULL);
	// --------------------------------
	{
		//CdYColSpec aCdYColSpec1(
		//	CdYColSpec::ColumnType_Outer_Shuchaku1);
		//CdYColSpec aCdYColSpec2(
		//	CdYColSpec::ColumnType_Outer_Shuchaku2);
		//int iYColumnNumber1 =
		//	m_CdYColSpecCont.ColumnNumberFromSpec(aCdYColSpec1, false);
		//int iYColumnNumber2 =
		//	m_CdYColSpecCont.ColumnNumberFromSpec(aCdYColSpec2, false);
		CDcdGridCell* pCDcdGridCell1 = pCDcdGrid->getCell(
			iXColumnNumber, iYColumnNumber);
		CDcdGridCell* pCDcdGridCell2 = pCDcdGrid->getCell(
			iXColumnNumber, iYColumnNumber + 1);
		// --------------------------------
		if (pCDcdGridCell1 != 0 && pCDcdGridCell2 != 0)
		{
			typedef CDcdTextbox CDcDrawCell;
			Ou<CDcDrawCell> pCDcDrawCell1;
			Ou<CDcDrawCell> pCDcDrawCell2;
			// --------------------------------
			//　(2.2.*.1)　セルの結合セルを設定
			pCDcdGridCell1->setAttachCellCount(1, 1);
			pCDcdGridCell2->setAttachCellCount(1, 1);

			//　(2.2.*.2)　セル の	DcDrawオブジェクトの型を設定
			//	( CDcdTextbox とする)。
			{
				pCDcDrawCell1 = dynamic_castOu<CDcDrawCell>(
					pCDcdGridCell1->getIfDcDraw());
				pCDcDrawCell2 = dynamic_castOu<CDcDrawCell>(
					pCDcdGridCell2->getIfDcDraw());
				if (pCDcDrawCell1 == NULL)
				{
					pCDcDrawCell1 = OuNew<CDcDrawCell>(new CDcDrawCell);
					pCDcdGridCell1->setIfDcDraw(pCDcDrawCell1);
				}
				if (pCDcDrawCell2 == NULL)
				{
					pCDcDrawCell2 = OuNew<CDcDrawCell>(new CDcDrawCell);
					pCDcdGridCell2->setIfDcDraw(pCDcDrawCell2);
				}
			}
			//　(2.2.*.3)　セルの DcDrawオブジェクトに、属性を設定。
			{
				int idxRessyasyubetsu
				= pCentDedRessya->getRessyasyubetsuIndex();
				*pCDcDrawCell1 = createCDcdRessyabangou(idxRessyasyubetsu);
				*pCDcDrawCell2 = createCDcdRessyabangou(idxRessyasyubetsu);
				//pCDcDrawCell1->setCdDrawTextProp(getCdDrawTextPropOperation());
				//pCDcDrawCell2->setCdDrawTextProp(getCdDrawTextPropOperation());
				tstring strText1;
				tstring strText2;

				const CentDedAfterOperation aLastOperation = pCentDedRessya->getLastOperation();
				if (aLastOperation.getAOperation()== CentDedAfterOperation::AOperation_Outer)
				{
					CentDedEkiCont::CdDedEki aCdDedEki = muCdDedEki->get(pCentDedRessya->getValidSyuuchakuEki());
					strText1 = aCdDedEki.getOuterTerminalJikokuRyaku(aLastOperation.getOuterShuchakuekiIndex(),true);
					if (!(aLastOperation.getOuterShuchakuJikoku().isNull()))
					{
						CdDedJikoku aCdDedJikoku
							= aLastOperation.getOuterShuchakuJikoku();
						strText2 = getCdDedJikokuConv().encode(aCdDedJikoku,true);
					}
				}
				pCDcDrawCell1->setText(strText1);
				pCDcDrawCell2->setText(strText2);
			}

			//セルの背景色を指定します。
			{
				pCDcDrawCell1->setCdBrushProp(CdColorProp(255, 255, 255));
				pCDcDrawCell2->setCdBrushProp(CdColorProp(255, 255, 255));
			}
		}
	}
}

void CCellBuilderCustomize::update02_02_02_08_setRessya_Bikou( 
	int iXColumnNumber ,
	int iYColumnNumber,
	const CentDedRessya* pCentDedRessya ,
	CWndJikokuhyou* pCWndJikokuhyou ) 
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid() ;
	const CentDedRosen* pCentDedRosen = 
		m_pCDedRosenFileData->getCentDedRosen() ;
	// --------------------------------
	//CDcdTargetGetDC	aCDcdTarget( NULL ) ;
	// --------------------------------
	//CdYColSpec aCdYColSpec( 
	//	CdYColSpec::ColumnType_Bikou ) ;
	//int iYColumnNumber = 
	//	m_CdYColSpecCont.ColumnNumberFromSpec( aCdYColSpec , false ) ;
	CDcdGridCell* pCDcdGridCell = pCDcdGrid->getCell( 
		iXColumnNumber , iYColumnNumber ) ;
	// --------------------------------
	if ( pCDcdGridCell != 0 )
	{
		typedef CDcdTextboxV3 CDcDrawCell ;
		Ou<CDcDrawCell> pCDcDrawCell ;
		// --------------------------------
		//　(2.2.*.1)　セル(ColumnType_Ressya,ColumnType_Ressyabangou) の
		//	結合セルを設定
		pCDcdGridCell->setAttachCellCount( 1 , 1 ) ;

		//　(2.2.*.2)　セル の	DcDrawオブジェクトの型を設定
		//	( CDcdTextbox とする)。
		{
			pCDcDrawCell = dynamic_castOu<CDcDrawCell>( 
				pCDcdGridCell->getIfDcDraw() ) ;
			if ( pCDcDrawCell == NULL )
			{
				pCDcDrawCell = OuNew<CDcDrawCell>( new CDcDrawCell ) ;
				pCDcdGridCell->setIfDcDraw( pCDcDrawCell ) ;
			}
		}
		//　(2.2.*.3)　セルの DcDrawオブジェクトに、属性を設定。
		{
			int idxRessyasyubetsu 
				= pCentDedRessya->getRessyasyubetsuIndex() ;
			tstring strText = pCentDedRessya->getBikou() ;
			*pCDcDrawCell = createCDcdRessyamei( 
				idxRessyasyubetsu );
			pCDcDrawCell->setLinesExtentX ( getBikouTextExtent().getX() ) ;
			pCDcDrawCell->setLinesExtentY ( getBikouTextExtent().getY() ) ;
			pCDcDrawCell->setText( strText );
		}
	}
}

void CCellBuilderCustomize::update02_03_updateNullRessya(
	int iXColumnNumber,
	CWndJikokuhyou* pCWndJikokuhyou)
{
	CDcdGrid* pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	CDcdTargetGetDC	aCDcdTarget(NULL);

	CentDedRessya aRessya(m_pCentDedRessyaCont->createNullRessya());
	const CentDedRessya* pCentDedRessya = &aRessya;

	for (int iYColumnNumber = 0; iYColumnNumber < m_CdYColSpecCont.size(); iYColumnNumber++)
	{
		CdYColSpec aCdYColSpec = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumber);

		switch (aCdYColSpec.getColumnType())
		{
		case CdYColSpec::ColumnType_Ressyabangou:
		{
			// ================================
			//　(2.2.1)　セル(ColumnType_Ressya ,
			//	ColumnType_Ressyabangou) を設定
			// ================================
			update02_02_01_setRessya_Ressyabangou(
				iXColumnNumber,
				iYColumnNumber,
				pCentDedRessya,
				pCWndJikokuhyou);
		}
		break;
		case CdYColSpec::ColumnType_OperationNumber:
		{
			// --------------------------------
			//	(2.2.2.12)セル(ColumnType_Ressya, ColumnType_OperationNumber)
			// --------------------------------
			update02_02_02_12_setRessya_OperationNumber(
				iXColumnNumber,
				iYColumnNumber,
				pCentDedRessya,
				pCWndJikokuhyou);
		}
		break;
		case CdYColSpec::ColumnType_Ressyasyubetsu:
		{
			// --------------------------------
			//	(2.2.2.2)セル(ColumnType_Ressya, ColumnType_Ressyasyubetsu)
			// --------------------------------
			update02_02_02_02_setRessya_Ressyasyubetsu(
				iXColumnNumber,
				iYColumnNumber,
				pCentDedRessya,
				pCWndJikokuhyou);
		}
		break;
		case CdYColSpec::ColumnType_Ressyamei:
		{
			// --------------------------------
			//	(2.2.2.3)セル(ColumnType_Ressya, ColumnType_Ressyamei)
			// --------------------------------
			update02_02_02_03_setRessya_Ressyamei(
				iXColumnNumber,
				iYColumnNumber,
				pCentDedRessya,
				pCWndJikokuhyou);
		}
		break;
		case CdYColSpec::ColumnType_Gousuu:
		{
			// --------------------------------
			//	(2.2.2.4)セル(ColumnType_Ressya, ColumnType_Gousuu)
			// --------------------------------
			update02_02_02_04_setRessya_Gousuu(
				iXColumnNumber,
				iYColumnNumber,
				pCentDedRessya,
				pCWndJikokuhyou);
		}
		break;
		case CdYColSpec::ColumnType_Gou:
		{
			// --------------------------------
			//	(2.2.2.5)セル(ColumnType_Ressya, ColumnType_Gou)
			// --------------------------------
			update02_02_02_05_setRessya_Gou(
				iXColumnNumber,
				iYColumnNumber,
				pCentDedRessya,
				pCWndJikokuhyou);
		}
		break;
		case CdYColSpec::ColumnType_ShihatsuEkimei:
		{
			// --------------------------------
			//	(2.2.2.13)セル(ColumnType_Ressya, ColumnType_ShihatsuEkimei)
			// --------------------------------
			update02_02_02_13_setRessya_ShihatsuEkimei(
				iXColumnNumber,
				iYColumnNumber,
				pCentDedRessya,
				pCWndJikokuhyou);
		}
		break;
		case CdYColSpec::ColumnType_ShuchakuEkimei:
		{
			// --------------------------------
			//	(2.2.2.14)セル(ColumnType_Ressya, ColumnType_ShuchakuEkimei)
			// --------------------------------
			update02_02_02_14_setRessya_ShuchakuEkimei(
				iXColumnNumber,
				iYColumnNumber,
				pCentDedRessya,
				pCWndJikokuhyou);
		}
		break;
		case CdYColSpec::ColumnType_Outer_Shihatsu1:
		{
			// --------------------------------
			//	(2.2.2.15)セル(ColumnType_Ressya, ColumnType_Outer_Shihatsu)
			// --------------------------------
			update02_02_02_15_setRessya_OuterTerminal_Shihatsu(
				iXColumnNumber,
				iYColumnNumber,
				pCentDedRessya,
				pCWndJikokuhyou);
			iYColumnNumber += 1;
		}
		break;
		case CdYColSpec::ColumnType_Ekijikoku_Chaku:
		{
			update02_02_02_06_setRessya_Chaku(
				iXColumnNumber,
				iYColumnNumber,
				pCentDedRessya,
				aCdYColSpec.getEkiOrder(),
				-1,
				-1,
				-1,
				pCWndJikokuhyou);
		}
		break;
		case CdYColSpec::ColumnType_Track:
		{
			update02_02_02_09_setRessya_Track(
				iXColumnNumber,
				iYColumnNumber,
				pCentDedRessya,
				aCdYColSpec.getEkiOrder(),
				-1,
				-1,
				-1,
				pCWndJikokuhyou);
		}
		break;
		case CdYColSpec::ColumnType_EkiRessyabangou:
		{
			update02_02_02_19_setRessya_Ressyabangou(
				iXColumnNumber,
				iYColumnNumber,
				pCentDedRessya,
				aCdYColSpec.getEkiOrder(),
				-1,
				-1,
				-1,
				pCWndJikokuhyou);
		}
		break;
		case CdYColSpec::ColumnType_EkiOperationNumber:
		{
			update02_02_02_20_setRessya_OperationNumber(
				iXColumnNumber,
				iYColumnNumber,
				pCentDedRessya,
				aCdYColSpec.getEkiOrder(),
				-1,
				-1,
				-1,
				pCWndJikokuhyou);
		}
		break;
		case CdYColSpec::ColumnType_EkiRessyasyubetsu:
		{
			update02_02_02_21_setRessya_Ressyasyubetsu(
				iXColumnNumber,
				iYColumnNumber,
				pCentDedRessya,
				aCdYColSpec.getEkiOrder(),
				-1,
				-1,
				-1,
				pCWndJikokuhyou);
		}
		break;
		case CdYColSpec::ColumnType_EkiRessyamei:
		{
			update02_02_02_22_setRessya_Ressyamei(
				iXColumnNumber,
				iYColumnNumber,
				pCentDedRessya,
				aCdYColSpec.getEkiOrder(),
				-1,
				-1,
				-1,
				pCWndJikokuhyou);
		}
		break;
		case CdYColSpec::ColumnType_EkiGousuu:
		{
			update02_02_02_23_setRessya_Gousuu(
				iXColumnNumber,
				iYColumnNumber,
				pCentDedRessya,
				aCdYColSpec.getEkiOrder(),
				-1,
				-1,
				-1,
				pCWndJikokuhyou);
		}
		break;
		case CdYColSpec::ColumnType_EkiGou:
		{
			update02_02_02_24_setRessya_Gou(
				iXColumnNumber,
				iYColumnNumber,
				pCentDedRessya,
				aCdYColSpec.getEkiOrder(),
				-1,
				-1,
				-1,
				pCWndJikokuhyou);
		}
		break;
		case CdYColSpec::ColumnType_Ekijikoku_Hatsu:
		{
			update02_02_02_07_setRessya_Hatsu(
				iXColumnNumber,
				iYColumnNumber,
				pCentDedRessya,
				aCdYColSpec.getEkiOrder(),
				-1,
				-1,
				-1,
				pCWndJikokuhyou);
		}
		break;
		case CdYColSpec::ColumnType_Outer_Shuchaku1:
		{
			// --------------------------------
			//	(2.2.2.16)セル(ColumnType_Ressya, ColumnType_Outer_Shuchaku)
			// --------------------------------
			update02_02_02_16_setRessya_OuterTerminal_Shuchaku(
				iXColumnNumber,
				iYColumnNumber,
				pCentDedRessya,
				pCWndJikokuhyou);
			iYColumnNumber += 1;
		}
		break;
		case CdYColSpec::ColumnType_Bikou:
		{
			// --------------------------------
			//	(2.2.2.8)セル(ColumnType_Ressya,ColumnType_Bikou)
			// --------------------------------
			update02_02_02_08_setRessya_Bikou(
				iXColumnNumber,
				iYColumnNumber,
				pCentDedRessya,
				pCWndJikokuhyou);
		}
		break;
		}
	}
	
	// ================================
	//　(2.2.3)　X列(ColumnType_Ressya ) の幅を設定。
	//	幅は、駅時刻列の DcDraw オブジェクトの幅とします。
	// ================================
	CDcdGridXColumn* pCDcdGridXColumn
		= pCDcdGrid->getXColumn(iXColumnNumber);
	{
		{
			CDcdGridCell* pCDcdGridCell
				= pCDcdGrid->getCell(iXColumnNumber, 0);
			CdDcdSizeXy	aCdDcdSizeXy;
			if (pCDcdGridCell->getIfDcDraw()->getItemSize(
				&aCDcdTarget, &aCdDcdSizeXy)) {
				pCDcdGridXColumn->setColumnSize(aCdDcdSizeXy.getX());
			}
		}
	}

	// ================================
	//　(2.2.4)　X列(ColumnType_Ressya ) の境界線の 
	//	DcDrawオブジェクトの属性を設定。
	//　(2.2.5)　X列(ColumnType_Ressya ) の境界線の幅を設定。
	// ================================
	{
		CDcdGridXBorder* pCDcdGridXBorder
			= pCDcdGridXColumn->getCDcdGridXBorder();
		Ou<CDcdLine> pCDcdLine = pCDcdGridXBorder->getIfDcDraw();

		pCDcdLine->setCdPenProp(getCdPenPropNarrowLine());

		CdDcdSizeXy aCdDcdSizeXy;
		if (pCDcdLine->getItemSize(&aCDcdTarget, &aCdDcdSizeXy))
		{
			pCDcdGridXBorder->setColumnBorderSize(aCdDcdSizeXy.getX());
		}
	}
	// ================================
	//	X列を再描画領域とします。
	// ================================
	{
		CdDcdZoneXy	aCdDcdZoneXy;
		//X列の範囲
		{
			CdDcdZone	zoneXColumnZone = pCDcdGrid->getXColumnZone(
				&aCDcdTarget,
				iXColumnNumber);
			CdDcdZone	zoneXColumnBorderZone = pCDcdGrid->getXColumnBorderZone(
				&aCDcdTarget,
				iXColumnNumber);

			aCdDcdZoneXy.setX(
				zoneXColumnZone.ZoneOr(zoneXColumnBorderZone));
		}
		//Y列の範囲
		{
			CdDcdZone	zoneYColumnTop = pCDcdGrid->getYColumnZone(
				&aCDcdTarget,
				0);
			CdDcdZone	zoneYColumnBottom = pCDcdGrid->getYColumnZone(
				&aCDcdTarget,
				INT_MAX);
			aCdDcdZoneXy.setY(
				zoneYColumnTop.ZoneOr(zoneYColumnBottom));
		}
		CConverter_WinGdi	aConv;
		pCWndJikokuhyou->InvalidateRect(
			&aConv.RECTOf(aCdDcdZoneXy));
	}
}

CdColorProp CCellBuilderCustomize::getBackColor(int iXColumnNumber, int iEkiOrder, int idxRessyasyubetsu)
{
	int iBackColorPattern = m_pCentDedRessyaCont->getDia()->getBackPatternIndex();
	if (iBackColorPattern == 0)
	{
		int iJikokuhyouMainBackColorIndex = m_pCentDedRessyaCont->getDia()->getMainBackColorIndex();
		CdColorProp aCdColorProp = m_pCDedRosenFileData->
			getCdDedDispProp().getJikokuhyouBackColor(iJikokuhyouMainBackColorIndex);
		return aCdColorProp;
	}
	else if (iBackColorPattern == 1)//種別色
	{

		const CentDedRessyasyubetsu* pCentDedRessyasyubetsu
			= m_pCDedRosenFileData->getCentDedRosen()->getCentDedRessyasyubetsuCont()
			->getMuPtr()->get(idxRessyasyubetsu);
		if (m_bDisplayParentSyubetsu && pCentDedRessyasyubetsu->getParentSyubetsuIndex() >= 0)
		{
			pCentDedRessyasyubetsu
				= m_pCDedRosenFileData->getCentDedRosen()->getCentDedRessyasyubetsuCont()
				->getMuPtr()->get(pCentDedRessyasyubetsu->getParentSyubetsuIndex());
		}
		CdColorProp aCdColorProp = pCentDedRessyasyubetsu->getJikokuhyouBackColor();
		return aCdColorProp;
	}
	else if (iBackColorPattern == 2)//縦縞
	{
		int iJikokuhyouBackColorIndex;
		if (iXColumnNumber % 2 == 0)
		{
			iJikokuhyouBackColorIndex = m_pCentDedRessyaCont->getDia()->getSubBackColorIndex();

		}
		else
		{
			iJikokuhyouBackColorIndex = m_pCentDedRessyaCont->getDia()->getMainBackColorIndex();
		}
		CdColorProp aCdColorProp = m_pCDedRosenFileData->
			getCdDedDispProp().getJikokuhyouBackColor(iJikokuhyouBackColorIndex);
		return aCdColorProp;

	}
	else if (iBackColorPattern == 3)//横縞
	{
		int iJikokuhyouBackColorIndex;
		if (iEkiOrder % 2 == 0)
		{
			iJikokuhyouBackColorIndex = m_pCentDedRessyaCont->getDia()->getSubBackColorIndex();

		}
		else
		{
			iJikokuhyouBackColorIndex = m_pCentDedRessyaCont->getDia()->getMainBackColorIndex();
		}
		CdColorProp aCdColorProp = m_pCDedRosenFileData->
			getCdDedDispProp().getJikokuhyouBackColor(iJikokuhyouBackColorIndex);
		return aCdColorProp;
	}
	else if (iBackColorPattern == 4)//市松模様
	{
		int iJikokuhyouBackColorIndex;
		if ((iEkiOrder % 2 == 0) == (iXColumnNumber % 2 == 0))
		{

			iJikokuhyouBackColorIndex = m_pCentDedRessyaCont->getDia()->getSubBackColorIndex();
		}
		else
		{
			iJikokuhyouBackColorIndex = m_pCentDedRessyaCont->getDia()->getMainBackColorIndex();

		}
		CdColorProp aCdColorProp = m_pCDedRosenFileData->
			getCdDedDispProp().getJikokuhyouBackColor(iJikokuhyouBackColorIndex);
		return aCdColorProp;
	}
	else
	{
		int iJikokuhyouMainBackColorIndex = m_pCentDedRessyaCont->getDia()->getMainBackColorIndex();
		CdColorProp aCdColorProp = m_pCDedRosenFileData->
			getCdDedDispProp().getJikokuhyouBackColor(iJikokuhyouMainBackColorIndex);
		return aCdColorProp;
	}
}

	// ********************************
	//	コンストラクタ
	// ********************************
CCellBuilderCustomize::CCellBuilderCustomize(
	const CDedRosenFileData* pCDedRosenFileData,
	const CentDedRessyaCont* pCentDedRessyaCont,
	const vector<vector<int>>& contCustomizeRessyaIndex,
	bool bDisplayTsuukaEkiJikoku ,
	bool bDisplaySecondEkiJikoku ,
	bool bDisplayColonEkiJikoku,
	bool bDisplayShihatsuShuchakuEkimei,
	bool bDisplayParentSyubetsu,
	int iEnableOperation) :
	m_pCentDedRessyaCont( pCentDedRessyaCont ) ,
	m_pCDedRosenFileData( pCDedRosenFileData ) , 
	m_contCustomizeRessyaIndex(contCustomizeRessyaIndex),
	m_CdXColSpecCont( pCentDedRessyaCont ,true, contCustomizeRessyaIndex) ,
	m_bDisplayTsuukaEkiJikoku( bDisplayTsuukaEkiJikoku ) ,
	m_bDisplaySecondEkiJikoku( bDisplaySecondEkiJikoku ) ,
	m_bDisplayColonEkiJikoku(bDisplayColonEkiJikoku),
	m_bDisplayShihatsuShuchakuEkimei(bDisplayShihatsuShuchakuEkimei),
	m_bDisplayParentSyubetsu(bDisplayParentSyubetsu),
	m_iEnableOperation(iEnableOperation)
{
	CdDedDispProp	aCdDedDispProp = m_pCDedRosenFileData->getCdDedDispProp();
	m_bDisplayRessyamei = aCdDedDispProp.getDisplayRessyamei();
	m_bDisplayOuterTerminalShihatsu = aCdDedDispProp.getDisplayOuterTerminalShihatsu(pCentDedRessyaCont->getRessyahoukou());
	m_bDisplayOuterTerminalShuchaku = aCdDedDispProp.getDisplayOuterTerminalShuchaku(pCentDedRessyaCont->getRessyahoukou());
	m_iSecondRoundChaku = aCdDedDispProp.getSecondRoundChaku();
	m_iSecondRoundHatsu = aCdDedDispProp.getSecondRoundHatsu();
	m_bDisplay2400 = aCdDedDispProp.getDisplay2400();


	m_CdYColSpecCont = CdYColSpecCont(
		pCDedRosenFileData->getCentDedRosen()->getCentDedEkiCont(),
		pCentDedRessyaCont->getRessyahoukou(),
		false, true,
		bDisplayShihatsuShuchakuEkimei,
		m_bDisplayRessyamei, iEnableOperation,
		m_bDisplayOuterTerminalShihatsu, m_bDisplayOuterTerminalShuchaku);
}

	// ********************************
	//@name	CCellBuilderCustomize-操作
	// ********************************
void CCellBuilderCustomize::update( 
		CWndJikokuhyou* pCWndJikokuhyou ) 
{

	//　(1)　グリッドのうち、列車情報以外のすべての部分を設定します。
	update01_updateWithoutRessya(
		pCWndJikokuhyou ) ;

	//　(2)　列車情報を設定します。
	updateAllRessya( 
		pCWndJikokuhyou ) ;
	
	// --------------------------------
	pCWndJikokuhyou->InvalidateGrid() ;
}

void CCellBuilderCustomize::updateAllRessya( 
		CWndJikokuhyou* pCWndJikokuhyou ) 
{
	//　(2.1)　X列の数を設定します。CdXColSpecCont 
	//	で指定された列数とします。
	CDcdGrid*	pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid() ;
	pCDcdGrid->setXColumnCount( m_CdXColSpecCont.size() ) ;

	//　(2.2)　X列(ColumnType_Ressya )に、列車情報を設定
	//int iRessyaSize = m_pCentDedRessyaCont->size();
	int iRessyaSize = m_contCustomizeRessyaIndex.size();
#pragma omp parallel for schedule(guided)
	for ( int iRessyaIndex = 0 ; iRessyaIndex < iRessyaSize;
		iRessyaIndex ++ )
	{
		int iXColumnNumber = m_CdXColSpecCont.ColumnNumberFromSpec(
			CdXColSpec( 
				CdXColSpec::ColumnType_Ressya ,
				iRessyaIndex ) ) ;
		if ( iXColumnNumber >= 0 )
		{
			update02_02_updateRessya( 
				iXColumnNumber , 
				m_contCustomizeRessyaIndex[iRessyaIndex],
				//m_pCentDedRessyaCont->getMuPtr()->get( iRessyaIndex ) ,
				pCWndJikokuhyou ) ;
		}
	}

	//　(2.3)　X列(ColumnType_NewRessya )に、列車情報を設定。
	//	X列(ColumnType_Ressya )と同様。
	{
		int iXColumnNumber = m_CdXColSpecCont.ColumnNumberFromSpec(
			CdXColSpec( 
				CdXColSpec::ColumnType_NewRessya  ) ) ;
		if ( iXColumnNumber >= 0 )
		{
			//CentDedRessya aRessya( m_pCentDedRessyaCont->createNullRessya() ) ;

			update02_03_updateNullRessya( 
				iXColumnNumber , 
				//&aRessya ,
				pCWndJikokuhyou ) ;
		}
	}
}

void CCellBuilderCustomize::updateAllOperationNumber(
	CWndJikokuhyou* pCWndJikokuhyou)
{
	//　(2.1)　X列の数を設定します。CdXColSpecCont 
	//	で指定された列数とします。
	CDcdGrid*	pCDcdGrid = pCWndJikokuhyou->getCXDcdGrid();
	pCDcdGrid->setXColumnCount(m_CdXColSpecCont.size());

	//　(2.2)　X列(ColumnType_Ressya )に、列車情報を設定
	//int iRessyaSize = m_pCentDedRessyaCont->size();
	int iRessyaSize = m_contCustomizeRessyaIndex.size();
#pragma omp parallel for schedule(guided)
	for (int iRessyaIndex = 0; iRessyaIndex < iRessyaSize;
		iRessyaIndex++)
	{
		int iXColumnNumber = m_CdXColSpecCont.ColumnNumberFromSpec(
			CdXColSpec(
				CdXColSpec::ColumnType_Ressya,
				iRessyaIndex));
		int iYColumnNumber = m_CdYColSpecCont.ColumnNumberFromSpec(
			CdYColSpec(CdYColSpec::ColumnType_OperationNumber), false);
		if (iXColumnNumber >= 0 && iYColumnNumber >= 0)
		{
			CDcdTargetGetDC	aCDcdTarget(NULL);

			const vector<int>& contCustomizeRessyaIndex = m_contCustomizeRessyaIndex[iRessyaIndex];
			const CentDedRessya* pCentDedRessya;
			if (contCustomizeRessyaIndex.empty() || contCustomizeRessyaIndex.front() < 0 ||
				contCustomizeRessyaIndex.front() >= m_pCentDedRessyaCont->size())
			{
				CentDedRessya aRessya(m_pCentDedRessyaCont->createNullRessya());
				pCentDedRessya = &aRessya;
			}
			else
			{
				pCentDedRessya = m_pCentDedRessyaCont->getMuPtr()->get(contCustomizeRessyaIndex.front());
			}

			// --------------------------------
			//	(2.2.2.12)セル(ColumnType_Ressya, ColumnType_OperationNumber)
			// --------------------------------
			update02_02_02_12_setRessya_OperationNumber(
				iXColumnNumber,
				iYColumnNumber,
				pCentDedRessya,
				pCWndJikokuhyou);

			// ================================
			//	X列を再描画領域とします。
			// ================================
			CdDcdZoneXy	aCdDcdZoneXy;
			//X列の範囲
			{
				CdDcdZone	zoneXColumnZone = pCDcdGrid->getXColumnZone(
					&aCDcdTarget,
					iXColumnNumber);
				CdDcdZone	zoneXColumnBorderZone = pCDcdGrid->getXColumnBorderZone(
					&aCDcdTarget,
					iXColumnNumber);

				aCdDcdZoneXy.setX(
					zoneXColumnZone.ZoneOr(zoneXColumnBorderZone));
			}
			//Y列の範囲
			{
				CdDcdZone	zoneYColumn = pCDcdGrid->getYColumnZone(
					&aCDcdTarget,
					iYColumnNumber);
				aCdDcdZoneXy.setY(zoneYColumn);
			}
			CConverter_WinGdi	aConv;
			pCWndJikokuhyou->InvalidateRect(
				&aConv.RECTOf(aCdDcdZoneXy));
		}
	}
}

} //namespace ViewJikokuhyou
} //namespace WndJikokuhyou

